unit Global;

interface

uses
  Windows,
  Messages,
  OpenGL,
  Use_Geom;   

const
  Max_Parts = 10000;
  Max_Cars = 20;
  Max_WPN = 1000;
  Max_WayPoints = 1000;
  Max_CollPoints = 1000;
  Max_Tramps = 20;
  Max_Sprites = 1000;

type
  TCar = Record
   Real:boolean;
   Life:integer;
   Rockets,Mashingun,mines:integer;
   tip:byte;
   WayPoint:integer;
   Point:TVect;      {koord}
   Vector,Correct:TVect;     {vector dvigeniya}
   AICorrect:TVect;  {otkloneniye AI ot kursa - waypoint`ov}
   AIIdea:byte;
   Speed:Single;     {tekushii gaz}
   MaxSpeed:Single;   {max gaz}
   ControlAng:Single; {povorot rulya}
   ChangeAng:Single; 
   RealSpeed:Single; {scorost}
   RealAng:Single;   {real napravleniye}
   Scep:Single;{sceplenie}
   Ang:Single; {povorot mashini}
   Heigth,HV:Single;       {Visota - dlya teni na tramplinax}
  end;

type
  TParticle = Record
   Point:TVect;
   Vector:TVect;
   tip:byte;
   life:integer;
  end;

type
  TWeapon = record
   life:integer;
   tip:byte;
   Master:byte;
   Point:TVect;
   Vector:TVect;
   ang:single;
   Damage:byte;
  end;

type
  TWayPoint = record
   Point:TVect;
   tip:byte;{for instructions}
   Next:integer;
  end;

type
  TCollPoint = record
   real:boolean;
   A,B:TVect;
  end;

type
  TTramp = record
   real:boolean;
   tip:byte;{0- tramplin 1-hyper speed 10 - finish}
   A,B:TVect;
  end;

type
  TSprite = record
   Point:TVect;
   tip:byte;
   real,
   shadow,
   with_ang,
   with_scale,
   with_lev:boolean;
   Level:smallint;
   ang,size:single;
  end;

type
  TLevel = record
   WayPoints:array [0..Max_WayPoints] of TWayPoint;     
   Sprites:array [0..Max_Sprites] of TSprite; 
   CollPoints:array [0..Max_CollPoints] of TCollPoint;  
   Tramp:array [0..Max_Tramps] of TTramp;
   CurWP:Integer;
  end;
  
var
  hWnd: THandle;      {  }
  Msg: TMsg;
  WCE: TWndClassEx;
  PW,PH:integer;
  glhRC:HGLRC;
  glhDC:HDC;
  Mode:boolean = false;   
  {timer}
  tactH: Integer;
  {keys}
  key: array [0..255] of boolean; {}
  Mash:single = 1;{}
  KX,KY:single;{  }
  MW:Integer;{mouse wheel}
  {mouse coords}
  Mx,My:integer;   {}
  DX,DY:single;    {   }
  CX,CY,FX,FY:integer;   {   }

  {games}
  Cars:array [0..Max_Cars] of TCar;
  Parts:array [0..Max_Parts] of TParticle;
  WPN:array [0..Max_WPN] of TWeapon;
  Wind:TVect;{veter dlya pili i chastic}
  WayPoints:array [0..Max_WayPoints] of TWayPoint;
  CurWP:Integer;
  CollPoints:array [0..Max_CollPoints] of TCollPoint;
  Sprites:array [0..Max_Sprites] of TSprite;
  {Game params}
  Tramp:array [0..Max_Tramps] of TTramp;

  {car rad}
  CBR:single = 0.5; {Car ball radius}


  mbl,mbr,mbm:boolean;       {     }

  {Textures}
  Fon:cardinal;          {  }
  Tex:array [0..15] of cardinal; {  }
  CarTex:array [0..5] of cardinal;
  KolTex:array [0..2] of cardinal;
  WPNTex:array [0..2] of cardinal;

procedure add_Part(X,Y,VX,VY:single;tip:byte;life:integer);
procedure add_WPN(X,Y,VX,VY,ang:single;tip,Damage:byte;life:integer;Master:byte);
procedure add_WayPoint(X,Y:single;Tip:byte);  
procedure add_CollLine(X,Y,VX,VY:single);
function add_Sprite(X,Y:single;tip:byte;Shadow,FalseLev:boolean;Level:smallint;ang,size:single):integer;
procedure add_Tramp(X,Y,VX,VY:single;tip:byte);

implementation

procedure add_Part(X,Y,VX,VY:single;tip:byte;life:integer);
Var i:integer;
begin
 for i:=0 to Max_Parts do
 if Parts[i].life=0 then
 begin
  Parts[i].Point:=Vector(X,Y);
  Parts[i].Vector:=Vector(VX,VY);
  Parts[i].tip:=tip;
  Parts[i].life:=life;
  break;
 end;
end;

procedure add_WPN(X,Y,VX,VY,ang:single;tip,Damage:byte;life:integer;Master:byte);
Var i:integer;
begin
 for i:=0 to Max_WPN do
 if WPN[i].life=0 then
 begin
  WPN[i].Point:=Vector(X,Y);
  WPN[i].Vector:=Vector(VX,VY);
  WPN[i].Master:=Master;
  WPN[i].ang:=ang;
  WPN[i].tip:=tip;
  WPN[i].Damage:=Damage;
  WPN[i].life:=life;
  break;
 end;
end;
    
procedure add_WayPoint(X,Y:single;Tip:byte);
Var i:integer;
begin
 for i:=0 to Max_WayPoints do
  if WayPoints[i].tip=0 then
  begin
   WayPoints[CurWP].Next:=i;
   WayPoints[i].tip:=tip;
   WayPoints[i].Point.X:=X;
   WayPoints[i].Point.Y:=Y;
   CurWP:=i;
   break;
  end;
end;

procedure add_CollLine(X,Y,VX,VY:single);
Var i:integer;
begin
 for i:=0 to Max_CollPoints do
  if not CollPoints[i].real then
  begin
   CollPoints[i].real:=true;
   CollPoints[i].A:=Vector(X,Y);
   CollPoints[i].B:=Vector(VX,VY);
   break;
  end;
end;

procedure add_Tramp(X,Y,VX,VY:single;tip:byte);
Var i:integer;
begin
 for i:=0 to Max_Tramps do
  if not Tramp[i].real then
  begin
   Tramp[i].real:=true;
   Tramp[i].A:=Vector(X,Y);
   Tramp[i].B:=Vector(VX,VY);
   Tramp[i].tip:=tip;
   break;
  end;
end;

function add_Sprite(X,Y:single;tip:byte;Shadow,FalseLev:boolean;Level:smallint;ang,size:single):integer;
Var i:integer;
begin
 for i:=0 to Max_Sprites do
  if not Sprites[i].real then
  begin
   Sprites[i].real:=true;
   Sprites[i].Point:=Vector(X,Y);
   Sprites[i].tip:=tip;
   Sprites[i].with_lev:=FalseLev;
   Sprites[i].Level:=Level;
   Sprites[i].shadow:=Shadow;
   if (ang=0) then Sprites[i].with_ang:=false else
    begin
     Sprites[i].ang:=ang;
     Sprites[i].with_ang:=true;
    end;
   if (Size=0) then Sprites[i].with_scale:=false else
    begin
     Sprites[i].size:=size;
     Sprites[i].with_scale:=true;
    end;
   add_Sprite:=i;
   break;
  end;
end;

end.
