unit Main;

interface

uses     
  Windows,
  Messages,
  OpenGL,
  Global,
  SysUtils,
  Use_OpenGL,
  Use_Geom;

procedure TactTimer;
procedure Create_prog; 
procedure Kill_Prog;

Var
 instrument:byte;
 cur_num:integer;
 cur_ang:integer;
 cur_lev:integer;
 Cur_Scale:single = 1;
 Cur_Tex:byte =1;
 Cur_WL:boolean = false;
 Cur_Point:TVect;
 Tramp_type:byte;
 mbd:boolean;

implementation

procedure Save_Level(Str:String);
Var i:integer;
F:File of TLevel;
Lev:TLevel;
begin
 For i:=0 to Max_WayPoints do
  Lev.WayPoints[i]:=WayPoints[i];
 For i:=0 to Max_Sprites do
  Lev.Sprites[i]:=Sprites[i];
 For i:=0 to Max_CollPoints do
  Lev.CollPoints[i]:=CollPoints[i];
 For i:=0 to Max_Tramps do
  Lev.Tramp[i]:=Tramp[i];
 Lev.CurWP:=CurWP;
 AssignFile(F,str);
 Rewrite(F);
 Write(F,Lev);
 CloseFile(F);
end;

procedure Load_Level(Str:String);
Var i:integer;
F:File of TLevel;
Lev:TLevel;
begin
 AssignFile(F,str);
 Reset(F);
 Read(F,Lev);
 CloseFile(F);
 For i:=0 to Max_WayPoints do
  WayPoints[i]:=Lev.WayPoints[i];
 For i:=0 to Max_Sprites do
  Sprites[i]:=Lev.Sprites[i];  
 For i:=0 to Max_CollPoints do
  CollPoints[i]:=Lev.CollPoints[i];
 For i:=0 to Max_Tramps do
  Tramp[i]:=Lev.Tramp[i];
 CurWP:=Lev.CurWP;
end;

procedure Draw_Car(Car:TCar);
begin
 Case Car.tip of
  0:glColor4f(0,0,0,5);
  1:glColor4f(5,0,0,5);
  2:glColor4f(0,5,0,5);
  3:glColor4f(0,0,5,5);
  4:glColor4f(5,5,0,5);
  5:glColor4f(0,5,5,5);
  6:glColor4f(5,0,5,5);
 end;
 glTranslatef((Car.Point.X-KX)*Mash,(Car.Point.Y-KY)*Mash,0);
 glRotatef(Car.Ang,0,0,1);
 Put_Sprite(-0.25,0,Mash,Mash/2);
 Put_Sprite(0.25,0,Mash,Mash/2);
 glRotatef(-Car.Ang,0,0,1);
 glTranslatef(-(Car.Point.X-KX)*Mash,-(Car.Point.Y-KY)*Mash,0)
end;

procedure Draw_Part(Part:TParticle);
Var size:Single;
begin
 size:=0.5;
 Case Part.tip of
  0:begin            {sledi ot shin}
     size:=0.1;
     glColor4f(0,0,0,0.2);
     glTranslatef((Part.Point.X-KX)*Mash,(Part.Point.Y-KY)*Mash,0);
     Put_Sprite(0,0,Mash,Size);
     glTranslatef(-(Part.Point.X-KX)*Mash,-(Part.Point.Y-KY)*Mash,0);
    end;
  1:glColor4f(5,0,0,5);
  2:glColor4f(0,5,0,5);
  3:glColor4f(0,0,5,5);
  4:glColor4f(5,5,0,5);
  5:glColor4f(0,5,5,5);
  6:glColor4f(5,0,5,5);
 end;
// glDisable(GL_TEXTURE_2D);
{ glEnable(GL_BLEND);
 glBlendFunc( GL_ONE,GL_BLEND_DST); //    ,

 glDisable(GL_BLEND);  }
end;

procedure Draw_Sprites(l:byte);
Var i,z:integer;M,F,R:single;
begin
 glColor4f(5,5,5,5);
 if l=0 then
 for i:=0 to Max_Sprites do
  if Sprites[i].real and (Sprites[i].with_lev) then
  begin                     
   glBindTexture(GL_Texture_2d, Sprites[i].tip);
   M:=Mash{*(1+0.04*Sprites[i].Level)};
   R:=(1+0.03*Sprites[i].Level){*Mash};
   F:=Sprites[i].size*Mash;
   M:=Sprites[i].size/Mash;
   glTranslatef((Sprites[i].Point.X-kx)*Mash,(Sprites[i].Point.Y-ky)*Mash,0);
    glbegin(GL_Quads);         {  }
     gltexcoord2f(1*M+(KX)*R,1*M+(KY)*R);        {}
     glvertex2f(-f/2,-f/2);    {}
     gltexcoord2f((KX)*R,1*M+(KY)*R);
     glvertex2f(+f/2,-f/2);
     gltexcoord2f((KX)*R,(KY)*R);
     glvertex2f(+f/2,+f/2);
     gltexcoord2f(1*M+(KX)*R,(KY)*R);
     glvertex2f(-f/2,+f/2);
    glend;
   glTranslatef(-(Sprites[i].Point.X-kx)*Mash,-(Sprites[i].Point.Y-ky)*Mash,0);
  end;
 if l>0 then l:=20 else l:=0;
 for z:=-19+l to 0+l do
 for i:=0 to Max_Sprites do
  if Sprites[i].real and (Sprites[i].Level=z) and not (Sprites[i].with_lev) then
  begin
   glBindTexture(GL_Texture_2d, Sprites[i].tip);
   M:=Mash*(1+0.03*Sprites[i].Level);
   glTranslatef((Sprites[i].Point.X-kx)*M,(Sprites[i].Point.Y-ky)*M,0);
   if Sprites[i].with_ang then
    begin
     glRotatef(Sprites[i].ang,0,0,1);
    end;
   if Sprites[i].with_scale then
    Put_Sprite(0,0,1,M*Sprites[i].size)
    else Put_Sprite(0,0,1,M);
   if Sprites[i].with_ang then
    begin
     glRotatef(Sprites[i].ang,0,0,-1);
    end;
   glTranslatef(-(Sprites[i].Point.X-kx)*M,-(Sprites[i].Point.Y-ky)*M,0);
  end;
 {}
end;

procedure Check_Keys;       { }
Var i:integer;
begin
 i:=0;
 DX:=((+MX-PW/2)*0.0129/mash)+kx;
 DY:=((-MY+PH/2)*0.0129/mash)+ky; {   }
 Case instrument of
 0,1:begin
      If mbl then
       begin
        add_WayPoint(DX,DY,1);
        mbl:=false;
       end;
      if key[46] then
       for i:=2 to Max_WayPoints do
        if WayPoints[i].tip=0 then
       begin WayPoints[i-1].tip:=0;WayPoints[i-2].Next:=0;CurWP:=i-2;key[46]:=false;break;end;
     end;
  2:If mbl then
     begin
      Cur_Num:=Add_Sprite(DX,DY,0,true,false,cur_lev,cur_ang,Cur_Scale);
      mbl:=false;
      instrument:=3;
     end;
  3:begin
     If mbl then
     begin
      for i:=0 to Max_Sprites do
       if (DX<Sprites[i].Point.X+Sprites[i].size) and
          (DY<Sprites[i].Point.Y+Sprites[i].size) and
          (DX>Sprites[i].Point.X-Sprites[i].size) and
          (DY>Sprites[i].Point.Y-Sprites[i].size) then
          begin
           Cur_Num:=i;
          end;
     end;
     if key[46] then begin Sprites[i].real:=false;key[46]:=false;end;
    end;
  4:begin
     If mbl then
      begin
       if not key[16] and not mbd then
        Cur_Point:=Vector(DX,DY);
       mbd:=true;
      { Cur_Num:=Add_Sprite(DX,DY,0,true,false,cur_lev,cur_ang,Cur_Scale);
       mbl:=false; }
      end else
      if mbd then
       begin
        mbd:=false;
        Add_CollLine(DX,DY,Cur_Point.X,Cur_Point.Y);
        Cur_Point:=Vector(DX,DY);
       end;
     end;
   5:begin{Tramp}
     If mbl then
      begin
       if not key[16] and not mbd then
        Cur_Point:=Vector(DX,DY);
       mbd:=true;
      { Cur_Num:=Add_Sprite(DX,DY,0,true,false,cur_lev,cur_ang,Cur_Scale);
       mbl:=false; }
      end else
      if mbd then
       begin
        mbd:=false;
        Add_Tramp(DX,DY,Cur_Point.X,Cur_Point.Y,Tramp_type);
        Cur_Point:=Vector(DX,DY);
       end;
     end;
 end;
 {load/save}
 if key[112] then {F1 - save}
 begin
  Save_Level('testLev.txt');
 end;
 if key[113] then {F2 - load}
 begin
  Load_Level('testLev.txt');
 end;
 {control}
 if key[17] then begin KX:=Sprites[Cur_num].Point.X;KY:=Sprites[Cur_num].Point.Y; end;
 if key[87] or key[38] then
  begin
   if key[16] then
   begin
    KY:=KY+1;
    key[38]:=false;key[87]:=false;
   end else
    KY:=KY+0.1/Mash;
  end;{up}
 if key[83] or key[40] then begin
   if key[16] then
   begin
    KY:=KY-1;
    key[40]:=false;key[83]:=false;
   end else
   KY:=KY-0.1/Mash;
    end;{down}
 if key[65] or key[37] then
  begin
   if key[16] then
   begin
    KX:=KX-1;
    key[65]:=false;key[37]:=false;
   end else
   KX:=KX-0.1/Mash;
  end;{left}
 if key[68] or key[39] then
  begin
   if key[16] then
   begin
    KX:=KX+1;
    key[68]:=false;key[39]:=false;
   end else
   KX:=KX+0.1/Mash;
  end;{rigth}
 if key[17] then begin Sprites[Cur_num].Point:=Vector(KX,KY); end;

 if MW>0 then Mash:=Mash*1.1;
 if MW<0 then Mash:=Mash*0.9;
 if MW<>0 then MW:=0;
 {enter - add sprite}
 if key[32] then begin
  Cur_Num:=Add_Sprite(KX,KY,0,true,true,cur_lev,cur_ang,Cur_Scale);
  key[32]:=false;
 end;
 {nums - textures}
 for i:=0 to 9 do
  if key[49+i] then begin tramp_Type:=i;Cur_Tex:=i;key[49+i]:=false;end;
 {if shift then faster}
 i:=1;
 if key[16] then begin i:=5;end;  {shift}
 {intruments}
 if key[114] then begin instrument:=1;key[114]:=false;end;{f3 marshrut}
 if key[115] then begin instrument:=2;key[115]:=false;end;{f4 - add objects}
 if key[116] then begin instrument:=3;key[116]:=false;end;{f5 choose or objects}
 if key[117] then begin instrument:=4;key[117]:=false;end;{f6 add zabor :) }
 if key[118] then begin instrument:=5;key[118]:=false;end;{f6 add zabor :) }
 {level change with object}
 if key[109] then begin Cur_Lev:=Cur_Lev-i;key[109]:=false; end;{-  -curlev}
 if key[107] then begin Cur_Lev:=Cur_Lev+i;key[107]:=false; end;{+  +curlev}
 if key[106] then begin Cur_Lev:=0;key[106]:=false; end;{*  level:=false;}
 if key[192] then begin Cur_WL:=not Cur_WL;key[192]:=false;end; { `~  on/off propasti}
 {angle change}
 if key[188] then begin Cur_Ang:=Round(Get_R(Cur_Ang+i*2));key[188]:=false; end;{<  -angle}
 if key[190] then begin Cur_Ang:=Round(Get_R(Cur_Ang-i*2));key[190]:=false; end;{>  +angle}
 if key[191] then begin Cur_Ang:=0;key[191]:=false; end;{*  angle:=0 false;}
 {scale}
 if key[219] then begin Cur_Scale:=Cur_Scale*0.9;key[219]:=false; end;//  {  -scale}
 if key[221] then begin Cur_Scale:=Cur_Scale*1.1;key[221]:=false; end;//  }  +scale}
 if key[80] then begin Cur_Scale:=1;key[80]:=false; end;{P - usual scale}
 begin
  if Cur_Lev<-19 then Cur_Lev:=-19;
  if Cur_Lev>20 then Cur_Lev:=20;
  Sprites[Cur_num].Level:=Cur_Lev;
  Sprites[Cur_num].ang:=Cur_Ang;
  Sprites[Cur_num].with_ang:=not (Cur_Ang=0);
  Sprites[Cur_num].with_scale:= not (Cur_Scale=1);
  Sprites[Cur_num].with_lev:=not (Cur_lev=0);
  Sprites[Cur_num].size:=Cur_Scale;
  Sprites[Cur_num].tip:=Cur_Tex;
  Sprites[Cur_num].with_lev:=Cur_WL;
 end;
 if key[27] then Kill_Prog; {Esc }
end;

procedure Move_Objects;
Var i,j:integer;
begin
 {moving}
end;

procedure Render;    {}
Var
  i,j:integer;
begin
 glclear(GL_Color_Buffer_Bit xor GL_Depth_Buffer_Bit);  {}
 glLoadIdentity();     {}
{render}
 For i:=trunc(KX-10/Mash) to trunc(KX+10/Mash) do
  For j:=trunc(KY-10/Mash) to trunc(KY+10/Mash) do
   begin
    if ((i+j) mod 4 = 0) then
     glColor4f(5,5,5,5) else glColor4f(3,3,3,5);
   if  (((i>50) and (i<57))
     or ((i<-50) and (i>-57))) and (j<50) and (j>-50) then
     glColor4f(0,0,5,5);
    if  (((j>50) and (j<57))
     or ((j<-50) and (j>-57))) and (i<50) and (i>-50) then
     glColor4f(0,0,5,5);
    If (Get_S(Vector(-50,0),Vector(i,j))>50) and
     (Get_S(Vector(-50,0),Vector(i,j))<57) and (i<=-50) then
     glColor4f(0,5,0,5);
    If (Get_S(Vector(50,0),Vector(i,j))>50) and
     (Get_S(Vector(50,0),Vector(i,j))<57) and (i>=50) then
     glColor4f(0,5,0,5);
    {test}
    glbegin(GL_QUADS);
    GLVertex2f((i-KX)*Mash,(j-KY)*Mash);
    GLVertex2f((i-KX)*Mash,(j+1-KY)*Mash);
    GLVertex2f((i+1-KX)*Mash,(j+1-KY)*Mash);
    GLVertex2f((i+1-KX)*Mash,(j-KY)*Mash);
    glend;
   end;
 {test}
 glColor4f(0,0,0,5);
 Case instrument of
  0,1:Put_Text('Waypoints',-6,4.6);
  2:Put_Text('add Sprites',-6,4.6);
  3:Put_Text('choose Sprites',-6,4.6);
  4:Put_Text('set Zabor :)',-6,4.6);
  5:Put_Text('set 1)tramplin 2)speed 3)start :)'+IntToStr(Tramp_type),-6,4.6);
 end;
 Put_Text('num '+inttostr(cur_num),-6,4);
 Put_Text('Ang '+inttostr(cur_ang),-6,3.4);
 Put_Text('Level '+inttostr(cur_lev),-6,2.8);
 Put_Text('Scale '+floattostr(cur_scale),-6,2.2);
 {//test}
 glEnable(GL_Texture_2d);
 Draw_Sprites(0);
 For i:=0 to Max_Parts do
  if Parts[i].life>0 then
   Draw_Part(Parts[i]);
 For i:=0 to Max_Cars do
  if Cars[i].Real then
   Draw_Car(Cars[i]);
 Draw_Sprites(1);
 glBindTexture(GL_Texture_2d, Cur_Tex);
 Put_Sprite(-6,1,1,1);
 glDisable(GL_Texture_2d);
 {test}
 glColor4f(5,0,0,5);
 glbegin(GL_LINES);
 GLVertex2f(0,0);
 GLVertex2f(Get_X_V(90,1),Get_Y_V(90,1));
 glend;
 glColor4f(0,5,0,5);
 glbegin(GL_LINES);
 GLVertex2f(0,0);
 GLVertex2f(Get_X_V(0,1),Get_Y_V(0,1));
 glend;
 {WAYPOINTS}
 glColor4f(5,5,0,5);
 glbegin(GL_LINES);
 For i:=0 to Max_WayPoints do
  if WayPoints[i].tip>0 then
   begin
    GLVertex2f((WayPoints[i].Point.X-KX)*Mash,(WayPoints[i].Point.Y-KY)*Mash);
    GLVertex2f((WayPoints[WayPoints[i].Next].Point.X-KX)*Mash,(WayPoints[WayPoints[i].Next].Point.Y-KY)*Mash);
   end;
 glend;
 glColor4f(5,0,0,5);
 glbegin(GL_LINES);
 For i:=0 to Max_CollPoints do
  if CollPoints[i].real then
   begin
    GLVertex2f((CollPoints[i].A.X-KX)*Mash,(CollPoints[i].A.Y-KY)*Mash);
    GLVertex2f((CollPoints[i].B.X-KX)*Mash,(CollPoints[i].B.Y-KY)*Mash);
   end;
 glend;
 glColor4f(4,4,0,5);
 glbegin(GL_LINES);
 For i:=0 to 10 do
  if Tramp[i].real then
   begin
    GLVertex2f((Tramp[i].A.X-KX)*Mash,(Tramp[i].A.Y-KY)*Mash);
    GLVertex2f((Tramp[i].B.X-KX)*Mash,(Tramp[i].B.Y-KY)*Mash);
   end;
 glend;

 Put_Sprite(DX-KX,DY-KY,Mash,0.1);
 glFlush();
 SwapBuffers(glhDC);
end;

procedure TactTimer;  { }
begin
 Check_Keys;    {    }
 Move_Objects;
 Render;        {}
end;

procedure Create_prog;{ }
Var
  i,j:integer;
begin
// ShowCursor(false);  { }
 glClearColor(1.0,1.0,1.0,0);
 enable_bind_tex;
 glShadeModel(GL_SMOOTH);
 Gen_Font(glhDC);  {font}
 glDisable(GL_Depth_Test);  {   }
 {koords}
 KX:=0;
 KY:=0;
 Mash:=0.6;
 {test}
 Cars[0].Real:=true;
 Cars[0].tip:=4;
 Cars[0].MaxSpeed:=0.22;
 CurWP:=0;
 {tex}
 for i:=0 to 15 do Tex[i]:=i;
 LoadTGATexture('IMG\sand.tga',Tex[0]);
 LoadTGATexture('IMG\Block.tga',Tex[1]);
 LoadTGATexture('IMG\Road.tga' ,Tex[2]);
 LoadTGATexture('IMG\Rock1.tga',Tex[3]);
 LoadTGATexture('IMG\Rock2.tga',Tex[4]);
 LoadTGATexture('IMG\Rock3.tga',Tex[5]);
 LoadTGATexture('IMG\Rock4.tga',Tex[6]);
 LoadTGATexture('IMG\Rock5.tga',Tex[7]);
 LoadTGATexture('IMG\tramp.tga',Tex[8]);
 LoadTGATexture('IMG\Block.tga',Tex[9]);
 LoadTGATexture('IMG\Block.tga',Tex[10]);
 LoadTGATexture('IMG\Block.tga',Tex[11]);
 LoadTGATexture('IMG\Block.tga',Tex[12]);
 LoadTGATexture('IMG\Block.tga',Tex[13]);
 LoadTGATexture('IMG\Block.tga',Tex[14]);
 LoadTGATexture('IMG\Block.tga',Tex[15]);
end;

procedure Kill_Prog;
begin
 ChangeDisplaySettings(devMode(nil^), 0);{ }
 KillTimer(0,TactH);     { }
 PostQuitMessage (0);
 ShowCursor(True);        { }
end;

end.
