unit Use_OpenGL;

interface

uses Windows, Messages, OpenGl, TGA2;

type
  TTextElement = record
   text:string;        {}
   align:byte;         {0-  1- 2- }
   active,glow:boolean;{   /   }
   tlen:integer;       { }
   Visible:boolean;    {  }
   Visibility:byte;    { -    -  ,  }
   X,Y:Single;         { }
   TX,TY:Single;       {   }
   W,H:Single;         {   }
  end;

type
  PRGB = record        {      }
   r,g,b:byte;
  end;
  TSline = array[0..1] of PRGB;   { }

function IntToStr(X:integer):string;
procedure InitGL(var ghRC:HGLRC;var ghDC:HDC;var Hand:THandle;W,H:Integer);
procedure On_Resize(Width,Height:integer);
procedure CloseGL(ghRC:HGLRC;ghDC:HDC;Hand:HWND);
procedure enable_bind_tex;
procedure disable_bind_tex;
procedure Put_Sprite(X,Y,M:single;f:single;r,g,b,a:single);overload;
procedure Put_Sprite(X,Y,M:single;f:single);overload;
procedure Gen_Font(var ghDC:HDC);
procedure Put_Text(Str:string;X,Y:single);
function Create_TextElement(text:string;align:byte;Visible:boolean;X,Y:Single):TTextElement;
procedure Put_TextElement(var T:TTextElement);
procedure Anim_TextElement(Var T:TTextElement);
function Get_TE_Collizion(X,Y:Single;var T:TTextElement):boolean;
procedure Change_Resolution(x, y: word);     
procedure Restore_Resolution;
procedure LoadTGATexture(FileName: String; var TexIndex: Cardinal);
procedure Put_Tile(X,Y,M:single;i,j:byte;f:single;r,g,b,a:single);

Var
 base_Font:integer = 1;
 Max_Font:integer = 256;
 TA:array of GLubyte;

implementation

function IntToStr(X:integer):string;
begin
 Str(X, result);
end;

procedure Change_Resolution(x, y: word); { }
var
  dm: TDEVMODE;
begin
  ZeroMemory(@dm, sizeof(TDEVMODE));
  dm.dmSize := sizeof(TDEVMODE);
  dm.dmPelsWidth := x;
  dm.dmPelsHeight := y;
  dm.dmFields := DM_PELSWIDTH or DM_PELSHEIGHT;
  ChangeDisplaySettings(dm, 0);
end;

procedure Restore_Resolution;
begin
 ChangeDisplaySettings(devMode(nil^), 0);{ }
end;

procedure Put_Sprite(X,Y,M:single;f:single;r,g,b,a:single); overload;
begin
{       ,   ,}
{ f    RGB      Modulate       }
 glcolor4f(r,g,b,a);        { }
 glbegin(GL_Quads);         {  }
  gltexcoord2f(1,1);        {}
  glvertex2f(-f/2+x*M,-f/2+y*M);    {}
  gltexcoord2f(0,1);
  glvertex2f(+f/2+x*M,-f/2+y*M);
  gltexcoord2f(0,0);
  glvertex2f(+f/2+x*M,+f/2+y*M);
  gltexcoord2f(1,0);
  glvertex2f(-f/2+x*M,+f/2+y*M);
 glend;
end;

procedure Put_Sprite(X,Y,M:single;f:single);overload;
begin
{       ,   ,}
{ f    RGB      Modulate       }
 glbegin(GL_Quads);         {  }
  gltexcoord2f(1,1);        {}
  glvertex2f(-f/2+x*M,-f/2+y*M);    {}
  gltexcoord2f(0,1);
  glvertex2f(+f/2+x*M,-f/2+y*M);
  gltexcoord2f(0,0);
  glvertex2f(+f/2+x*M,+f/2+y*M);
  gltexcoord2f(1,0);
  glvertex2f(-f/2+x*M,+f/2+y*M);
 glend;
end;

procedure Put_Tile(X,Y,M:single;i,j:byte;f:single;r,g,b,a:single);
begin
 gltranslatef(x*M,y*M,0);
 glcolor4f(r,g,b,a);
 glbegin(GL_Quads);
  gltexcoord2f(i*0.125+0.002,j*0.125+0.002);
  glvertex2f(-f/2,+f/2);
  gltexcoord2f(i*0.125+0.125-0.002,j*0.125+0.002);
  glvertex2f(+f/2,+f/2);
  gltexcoord2f(i*0.125+0.125-0.002,j*0.125+0.125-0.002);
  glvertex2f(+f/2,-f/2);
  gltexcoord2f(i*0.125+0.002,j*0.125+0.125-0.002);
  glvertex2f(-f/2,-f/2);
 glend;
 gltranslatef(-x*M,-y*M,0);
{}
end;

procedure Put_Text(Str:string;X,Y:single);  {     }
Var
 i:integer;
 S:Array [0..255] of byte;
 AP:Pointer;
begin
 if Str='' then Exit;            {   }
 For i:=1 to Length(Str) do
  S[i-1]:=byte(Str[i]);          {    }
 AP:=@S[0];
 glPushAttrib(GL_LIST_BIT);      //    
 glListBase(base_Font);         { }
 glRasterPos2f(X, Y);// 
 glCallLists(Length(str),GL_UNSIGNED_BYTE,AP);{ }
 glPopAttrib(); //    
end;

procedure Gen_Font(var ghDC:HDC);{   }
Var Font:HFont;
begin
 Font:=createFont(      { }
  -26,0,             //H,W -   -   Windows     
  0,0,                // 
  FW_NORMAL,          //FW_DONTCARE - 0, FW_NORMAL - 400, FW_BOLD - 700,  FW_BLACK - 900.
  0,                  // 
  0,                  // 
  0,                  // 
  DEFAULT_CHARSET,    //   (CHINESEBIG5_CHARSET, GREEK_CHARSET, RUSSIAN_CHARSET, DEFAULT_CHARSET,  ..)
  OUT_TT_ONLY_PRECIS,      //   OUT_TT_PRECIS-   - truetype ,OUT_TT_ONLY_PRECIS  Truetype
  CLIP_DEFAULT_PRECIS,
  ANTIALIASED_QUALITY,
  FF_DONTCARE or DEFAULT_PITCH,  //    ( - DEFAULT_PITCH, FIXED_PITCH  VARIABLE_PITCH)( - FF_DECORATIVE, FF_MODERN, FF_ROMAN, FF_SCRIPT, FF_SWISS, FF_DONTCARE)
  'Comic Sans MS');      //    { 'Comic Sans MS' }
 base_Font:=glGenLists(Max_Font);    {   }
 SelectObject(ghDC,Font);
 wglUseFontBitmaps(ghDC, 0, Max_Font, base_Font); {   }
end;

{   }
function Create_TextElement(text:string;align:byte;Visible:boolean;X,Y:Single):TTextElement;
begin
 Result.text:=text;
 Result.tlen:=length(text);
 Result.align:=align;
 Result.Visible:=Visible;
 Result.Visibility:=0;                {  }
 Result.X:=X;
 Result.Y:=Y;
 Result.W:=length(text)*0.12{+0.3};   { }
 Result.H:=0.3;
 Result.TX:=0.01;                     {   }
 Result.TY:=0.06;
 Result.glow:=false;                  {  }
end;

procedure Put_TextElement(var T:TTextElement);   {  }
Var X,Y:single;
begin
 X:=0;Y:=0;
 if (T.Visibility=0) then exit;  {      -  }
 if (T.text='') then exit;
 T.W:=length(T.text)*0.13{+0.3};
 Case T.align of            {     }
  0:X:=T.X;
  1:X:=T.X-T.W/2;
  2:X:=T.X-T.W;
 end;
 Y:=T.Y;
 if T.glow then glcolor4f(0,4,0,0.7) else  {  -    - }
   glcolor4f(0,4,0,0.2);        {  -     -  }
 glbegin(GL_POLYGON);         {  }
  glvertex2f(X    ,Y+T.H);    {}
  glvertex2f(X    ,Y    );
  glvertex2f(X+T.W/20*T.Visibility,Y+T.H/50*(20-T.Visibility));        {       }
  glvertex2f(X+T.W/20*T.Visibility,Y-T.H/50*(20-T.Visibility)+T.H);
 glend;
 glcolor4f(0,4,0,1);        { }
 glbegin(GL_LINE_LOOP);         { }
  glvertex2f(X    ,Y+T.H);    {}
  glvertex2f(X    ,Y    );
  glvertex2f(X+T.W/20*T.Visibility,Y+T.H/50*(20-T.Visibility));
  glvertex2f(X+T.W/20*T.Visibility,Y-T.H/50*(20-T.Visibility)+T.H);
 glend;
 {        }
 glColor4f(1,1,1,0.3);                                { }
 Put_Text(T.text,X+T.TX+0.02+(20-T.Visibility)*0.5,Y+T.TY-0.02); { }
 glColor4f(2,2,2,5);
 Put_Text(T.text,X+T.TX+(20-T.Visibility)*0.5,Y+T.TY); { }
end;

{            }
function Get_TE_Collizion(X,Y:Single;var T:TTextElement):boolean;
begin
 T.W:=length(T.text)*0.13;
 Case T.align of        {}
  0:;
  1:X:=X+T.W/2;
  2:X:=X+T.W;
 end;
 If (X<=T.X+T.W) and (X>=T.X)   {   - ""     }
  and (Y<=T.Y+T.H) and (Y>=T.Y) then T.glow:=true else T.glow:=false;
 Result:=T.glow;
end;
{ }
procedure Anim_TextElement(Var T:TTextElement);
begin
 If T.Visible then
  begin     {  - }
   If T.Visibility<20 then T.Visibility:=T.Visibility+1;
  end
 else
  begin     {   - }
   If T.Visibility>0 then T.Visibility:=T.Visibility-1;
  end;
end;

procedure On_Resize(Width,Height:integer); {    }
begin
 glViewport(0,0,Width,Height);        
 glMatrixMode(GL_Projection);
 glLoadIdentity();
 gluPerspective(45.0, Width/Height, 0.1, 100.0);{  }
 glOrtho(-20,20,-20,20,0,50);
 gluLookAt(0,0,10, 0,0,0, 0,1,0);
 glMatrixMode(Gl_ModelView);
end;



function SetupPixelFormat(DC:HDC;g:byte):boolean;
var
pfd:PIXELFORMATDESCRIPTOR;
ppfd:PPIXELFORMATDESCRIPTOR;
pixelformat:integer;
begin
ppfd := @pfd;
ppfd.nSize := sizeof(PIXELFORMATDESCRIPTOR);
ppfd.nVersion := 1;
ppfd.dwFlags :=  PFD_DRAW_TO_WINDOW xor
                           PFD_SUPPORT_OPENGL xor
                           PFD_DOUBLEBUFFER;
ppfd.dwLayerMask := PFD_MAIN_PLANE;
ppfd.iPixelType := PFD_TYPE_RGBA;
ppfd.cColorBits := g;
ppfd.cDepthBits := g;
ppfd.cAccumBits := 0;
ppfd.cStencilBits := 0;
pixelformat := ChoosePixelFormat(dc, ppfd);
if pixelformat=0 then
begin
MessageBox(0, 'ChoosePixelFormat failed', 'Error', MB_OK);
SetupPixelFormat:=FALSE;
exit;
end;

if SetPixelFormat(dc, pixelformat, ppfd)=false then
begin
MessageBox(0, 'SetPixelFormat failed', 'Error', MB_OK);
SetupPixelFormat:=FALSE;
exit;
end;
SetupPixelFormat:=TRUE;
end;

procedure InitGL(var ghRC:HGLRC;var ghDC:HDC;var Hand:THandle;W,H:Integer);
Var
 p:TVector4f;
 d:TVector3f;
begin   {OpenGL}
 ghDC:=GetDC(HAND);       { }
 If SetupPixelFormat(ghDC,16)=False then
  Exit;
 ghRC:=wglCreateContext(ghDC);
 wglMakeCurrent(ghDC,ghRC);            {   }
 glClearColor(0.0,0.0,0.0,0.0);        {  - }
 On_Resize(W,H);                       {  }
 glEnable(GL_Color_Material);
 glEnable(GL_Depth_Test);              {Z }
 glEnable(GL_Lighting);                { }
 glEnable(GL_LIGHT0);                  { 0}
 glenable(GL_Point_Smooth);            { }
 p[0]:=2; p[1]:=-5; p[2]:=3; p[3]:=-2;      { }
 d[0]:=0; d[1]:=0; d[2]:=0;
 glLightFV(Gl_LIGHT0,Gl_Position,@p);          { }
 glLightFV(GL_LIGHT0,GL_Spot_Direction,@d);
 {Settings}
 glDepthFunc(GL_LESS);		           //  Z 
 glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);   //
end;

procedure CloseGL(ghRC:HGLRC;ghDC:HDC;Hand:HWND);
begin
 If ghRC<>0 then             { ,  }
  begin
  wglMakeCurrent(ghDc,0);
  wglDeleteContext(ghRC);
 end;
 If ghDC<>0 then
  ReleaseDC(Hand,ghDC);
end;

procedure enable_bind_tex;
begin
 glEnable(GL_TEXTURE_2D);         { }
 glEnable(GL_BLEND);             { }
 glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);{ }
end;

procedure disable_bind_tex;
begin
 glDisable(GL_BLEND);      { }
 glDisable(GL_TEXTURE_2D); { }
end;

procedure LoadTGATexture(FileName: String; var TexIndex: Cardinal);
var TGA: TTGAImage;
    TexelSize: Integer;
    TexMode: Integer;
begin
//  glGenTextures(1, @TexIndex);

  TGA := TTGAImage.Create;
  try
    TGA.LoadFromFile(FileName);
    TGA.BGRtoRGB;
    case TGA.Header.ImgSpec.Depth of
      24:
        begin
          TexelSize := 3;
          TexMode := GL_RGB;
        end;
      32:
        begin
          TexelSize := 4;
          TexMode := GL_RGBA;
        end;
      else exit;{ raise Exception.Create('Error loading ' + FileName);}
    end; // case

    glBindTexture(GL_TEXTURE_2D, TexIndex);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_NEAREST);
    gluBuild2DMipmaps(GL_TEXTURE_2D, TexelSize, TGA.Header.ImgSpec.Width,
      TGA.Header.ImgSpec.Height, TexMode, GL_UNSIGNED_BYTE, TGA.Data);
    glTexImage2D(GL_TEXTURE_2D, 0, TexelSize, TGA.Header.ImgSpec.Width,
      TGA.Header.ImgSpec.Height, 0, TexMode, GL_UNSIGNED_BYTE, TGA.Data);
  finally
    TGA.Free;
  end;
end;

end.
