unit Main;

interface

uses     
  Windows,
  Messages,
  OpenGL,
  Global,
  Use_OpenGL,
  Use_Geom,
  Use_Menu;

procedure TactTimer;
procedure Create_prog;
procedure Kill_Prog;

implementation

procedure Save_Level(Str:String);
Var i:integer;
F:File of TLevel;
Lev:TLevel;
begin
 For i:=0 to Max_WayPoints do
  Lev.WayPoints[i]:=WayPoints[i];
 For i:=0 to Max_Sprites do
  Lev.Sprites[i]:=Sprites[i];
 For i:=0 to Max_CollPoints do
  Lev.CollPoints[i]:=CollPoints[i];
 For i:=0 to Max_Tramps do
  Lev.Tramp[i]:=Tramp[i];
 Lev.CurWP:=CurWP;
 AssignFile(F,str);
 Rewrite(F);
 Write(F,Lev);
 CloseFile(F);
end;

procedure Load_Level(Str:String);
Var i:integer;
F:File of TLevel;
Lev:TLevel;
begin
 AssignFile(F,str);
 Reset(F);
 Read(F,Lev);
 CloseFile(F);
 For i:=0 to Max_WayPoints do
  WayPoints[i]:=Lev.WayPoints[i];
 For i:=0 to Max_Sprites do
  Sprites[i]:=Lev.Sprites[i];
 For i:=0 to Max_CollPoints do
  CollPoints[i]:=Lev.CollPoints[i];
 For i:=0 to Max_Tramps do
  Tramp[i]:=Lev.Tramp[i];
 CurWP:=Lev.CurWP;
end;

procedure Draw_Car_Shadow(Var Car:TCar);
begin
 glBindTexture(GL_Texture_2d,CarTex[Car.tip]);
 glColor4f(0,0,0,0.2);
 glTranslatef((Car.Point.X+Car.Heigth-KX)*Mash,(Car.Point.Y+Car.Heigth-KY)*Mash,0);
 glRotatef(Car.Ang-90,0,0,1);
 Put_Sprite(0,0,Mash,Mash*(1.4));
 glRotatef(-Car.Ang+90,0,0,1);
 glTranslatef(-(Car.Point.X+Car.Heigth-KX)*Mash,-(Car.Point.Y+Car.Heigth-KY)*Mash,0);
end;


procedure Draw_Car(Var Car:TCar);
Var S:single;
begin
 glColor4f(5,5,5,5);
 glTranslatef((Car.Point.X-KX)*Mash,(Car.Point.Y-KY)*Mash,0);
 glRotatef(Car.Ang-90,0,0,1);
 S:=Car.Heigth/10;
 Case Car.tip of
  0:begin
     glBindTexture(GL_Texture_2d,KolTex[Random(3)]);
     Put_Sprite(-0.3-0.3*S,-0.4-0.4*S,Mash,Mash*(0.3)+Mash*(0.3)*S);
     Put_Sprite( 0.3+0.3*S,-0.4-0.4*S,Mash,Mash*(0.3)+Mash*(0.3)*S);
     glBindTexture(GL_Texture_2d,CarTex[0]);
     Put_Sprite(0,0,Mash,Mash*(1.4)+Mash*S);
     glBindTexture(GL_Texture_2d,KolTex[Random(3)]);
     glTranslatef((-0.25-0.3*S)*Mash,(0.4+0.4*S)*Mash,0);
     glRotatef(+Car.ControlAng*3,0,0,1);
     Put_Sprite(-0.05,0,Mash,Mash*(0.3)+Mash*(0.3)*S);
     glRotatef(-Car.ControlAng*3,0,0,1);
     glTranslatef(-(-0.25-0.3*S)*Mash,-(0.4+0.4*S)*Mash,0);
     glTranslatef((0.25+0.3*S)*Mash,(0.4+0.4*S)*Mash,0);
     glRotatef(Car.ControlAng*3,0,0,1);
     Put_Sprite(0.05,0,Mash,Mash*(0.3)+Mash*(0.3)*S);
     glRotatef(-Car.ControlAng*3,0,0,1);
     glTranslatef(-(0.25+0.3*S)*Mash,-(0.4+0.4*S)*Mash,0);
    end;
  1:begin
     glBindTexture(GL_Texture_2d,KolTex[Random(3)]);
     Put_Sprite(-0.3-0.3*S,-0.4-0.4*S,Mash,Mash*(0.3)+Mash*(0.3)*S);
     Put_Sprite( 0.3+0.3*S,-0.4-0.4*S,Mash,Mash*(0.3)+Mash*(0.3)*S);
     glBindTexture(GL_Texture_2d,CarTex[1]);
     Put_Sprite(0,0,Mash,Mash*(1.4)+Mash*S);
     glBindTexture(GL_Texture_2d,KolTex[Random(3)]);
     glTranslatef((-0.25-0.25*S)*Mash,(0.45+0.3*S)*Mash,0);
     glRotatef(+Car.ControlAng*3,0,0,1);
     Put_Sprite(-0.05,0,Mash,Mash*(0.3)+Mash*(0.3)*S);
     glRotatef(-Car.ControlAng*3,0,0,1);
     glTranslatef(-(-0.25-0.25*S)*Mash,-(0.45+0.3*S)*Mash,0);
     glTranslatef((0.25+0.25*S)*Mash,(0.45+0.3*S)*Mash,0);
     glRotatef(Car.ControlAng*3,0,0,1);
     Put_Sprite(0.05,0,Mash,Mash*(0.3)+Mash*(0.3)*S);
     glRotatef(-Car.ControlAng*3,0,0,1);
     glTranslatef(-(0.25+0.25*S)*Mash,-(0.45+0.3*S)*Mash,0);
     end;
  2:begin
     glBindTexture(GL_Texture_2d,KolTex[Random(3)]);
     Put_Sprite(-0.3-0.3*S,-0.4-0.4*S,Mash,Mash*(0.3)+Mash*(0.3)*S);
     Put_Sprite( 0.3+0.3*S,-0.4-0.4*S,Mash,Mash*(0.3)+Mash*(0.3)*S);
     glBindTexture(GL_Texture_2d,KolTex[Random(3)]);
     glTranslatef((-0.25-0.25*S)*Mash,(0.45+0.3*S)*Mash,0);
     glRotatef(+Car.ControlAng*3,0,0,1);
     Put_Sprite(-0.05,0,Mash,Mash*(0.3)+Mash*(0.3)*S);
     glRotatef(-Car.ControlAng*3,0,0,1);
     glTranslatef(-(-0.25-0.25*S)*Mash,-(0.45+0.3*S)*Mash,0);
     glTranslatef((0.25+0.25*S)*Mash,(0.45+0.3*S)*Mash,0);
     glRotatef(Car.ControlAng*3,0,0,1);
     Put_Sprite(0.05,0,Mash,Mash*(0.3)+Mash*(0.3)*S);
     glRotatef(-Car.ControlAng*3,0,0,1);
     glTranslatef(-(0.25+0.25*S)*Mash,-(0.45+0.3*S)*Mash,0);
     glBindTexture(GL_Texture_2d,CarTex[2]);
     Put_Sprite(0,0,Mash,Mash*(1.4)+Mash*S);
   end;
 end;

 glRotatef(-Car.Ang+90,0,0,1);
 glTranslatef(-(Car.Point.X-KX)*Mash,-(Car.Point.Y-KY)*Mash,0);
end;

procedure Draw_Part(Var Part:TParticle);
Var size,x,y:Single;Fl,V:TVect;
begin
 size:=0.5;
 Case Part.tip of
  0:begin            {sledi ot shin}
     size:=0.1*Mash;
     glColor4f(3,2.5,1,0.4);
     FL.X:=-Part.Vector.Y/(abs(Part.Vector.X)+abs(Part.Vector.Y))*0.1;
     FL.Y:=Part.Vector.X/(abs(Part.Vector.X)+abs(Part.Vector.Y))*0.1;
     V:=Part.Vector;
     glDisable(GL_TExture_2D);
//     Put_Sprite(Part.Point.X-KX,Part.Point.Y-KY,Mash,Size);
     glbegin(GL_Quads);         {  }
      gltexcoord2f(1,1);        {}
      glvertex2f((Part.Point.X+FL.X+V.X-KX)*Mash,(Part.Point.Y+FL.Y+V.Y-KY)*Mash);    {}
      gltexcoord2f(0,1);
      glvertex2f((Part.Point.X+FL.X-V.X-KX)*Mash,(Part.Point.Y+FL.Y-V.Y-KY)*Mash);
      gltexcoord2f(0,0);
      glvertex2f((Part.Point.X-FL.X-V.X-KX)*Mash,(Part.Point.Y-FL.Y-V.Y-KY)*Mash);
      gltexcoord2f(1,0);
      glvertex2f((Part.Point.X-FL.X+V.X-KX)*Mash,(Part.Point.Y-FL.Y+V.Y-KY)*Mash);
     glend;         
     glEnable(GL_TExture_2D);
    end;
  1:begin            {Pil}
     glBindTexture(GL_Texture_2D,Tex[15]);
     size:=(50-Part.life)*0.06*Mash;
     glColor4f(3.2,2.2,1,0.1+(Part.life)*0.01);
     Put_Sprite(Part.Point.X-KX,Part.Point.Y-KY,Mash,Size*Mash);
    end;
  2:begin            {dim}
     glBindTexture(GL_Texture_2D,Tex[15]);
     size:=(40-Part.life)*0.03*Mash+0.1;
     glColor4f(4,4,4,0.1+(Part.life)*0.02);
     Put_Sprite(Part.Point.X-KX,Part.Point.Y-KY,Mash,Size*Mash);
    end;
  3:begin            {ogon`}
     glBindTexture(GL_Texture_2D,Tex[15]);
     size:=0.5*Mash;
     glColor4f(5,5,0,5);
     Put_Sprite(Part.Point.X-KX,Part.Point.Y-KY,Mash,Size*Mash);
    end;
  4:begin            {ogon`}
     glBindTexture(GL_Texture_2D,Tex[15]);
     size:=0.3*Mash;
     glColor4f(5,5,1,5);
     Put_Sprite(Part.Point.X-KX,Part.Point.Y-KY,Mash,Size*Mash);
    end;
  5:begin            {koleso}
     glBindTexture(GL_Texture_2d,KolTex[Random(3)]);
     glColor4f(5,5,5,5);
     Put_Sprite(Part.Point.X-KX,Part.Point.Y-KY,Part.life,Mash,Mash*(0.3));
    end;
 end;
end;

procedure boom(Point:TVect;max:integer);
Var i:integer;
begin
 for i:=0 to Max do
  Add_Part(Point.X,Point.Y,Random(200)/200-0.5,Random(200)/200-0.5,3,4);
end;

procedure Draw_Sprites(l:byte);
Var i,z:integer;M,F,R:single;
begin
 if l=0 then
 for i:=0 to Max_Sprites do
  if Sprites[i].real and (Sprites[i].with_lev) then
  begin                     
   glBindTexture(GL_Texture_2d, Sprites[i].tip);
   M:=Mash{*(1+0.04*Sprites[i].Level)};
   R:=(1+0.03*Sprites[i].Level){*Mash};
   F:=Sprites[i].size*Mash;
   M:=Sprites[i].size/Mash;
   glTranslatef((Sprites[i].Point.X-kx)*Mash,(Sprites[i].Point.Y-ky)*Mash,0);
    glbegin(GL_Quads);         {  }
     gltexcoord2f(1*M+(KX)*R,1*M+(KY)*R);        {}
     glvertex2f(-f/2,-f/2);    {}
     gltexcoord2f((KX)*R,1*M+(KY)*R);
     glvertex2f(+f/2,-f/2);
     gltexcoord2f((KX)*R,(KY)*R);
     glvertex2f(+f/2,+f/2);
     gltexcoord2f(1*M+(KX)*R,(KY)*R);
     glvertex2f(-f/2,+f/2);
    glend;
   glTranslatef(-(Sprites[i].Point.X-kx)*Mash,-(Sprites[i].Point.Y-ky)*Mash,0);
  end;
 if l>0 then l:=20 else l:=0;
 for z:=-19+l to 0+l do
 for i:=0 to Max_Sprites do
  if Sprites[i].real and (Sprites[i].Level=z) and not (Sprites[i].with_lev) then
  begin
   glBindTexture(GL_Texture_2d, Sprites[i].tip);
   M:=Mash*(1+0.03*Sprites[i].Level);
   glTranslatef((Sprites[i].Point.X-kx)*M,(Sprites[i].Point.Y-ky)*M,0);
   if Sprites[i].with_ang then
    begin
     glRotatef(Sprites[i].ang,0,0,1);
    end;
   if Sprites[i].with_scale then
    Put_Sprite(0,0,1,M*Sprites[i].size)
    else Put_Sprite(0,0,1,M);
   if Sprites[i].with_ang then
    begin
     glRotatef(Sprites[i].ang,0,0,-1);
    end;
   glTranslatef(-(Sprites[i].Point.X-kx)*M,-(Sprites[i].Point.Y-ky)*M,0);
  end;
 {}
end;

procedure Draw_WPN(Var WPN:TWeapon);
Var size:Single;
begin
 size:=0.5;
 Case WPN.tip of
  0:begin            {raketa}
     glBindTexture(GL_Texture_2d, WPNTex[0]);
     size:=0.4;
     glColor4f(5,5,5,5);
     Put_Sprite(WPN.Point.X-KX,WPN.Point.Y-KY,WPN.ang-90,Mash,Size*Mash);
    end;
  1:begin            {Pylemet}
     glBindTexture(GL_Texture_2d, WPNTex[1]);
     size:=0.3;
     glColor4f(5,5,5,5);
     Put_Sprite(WPN.Point.X-KX,WPN.Point.Y-KY,WPN.ang-90,Mash,Size*Mash);
    end;
  2:begin            {mina}
     glBindTexture(GL_Texture_2d, WPNTex[2]);
     size:=0.3;
     glColor4f(5,5,5,5);
     Put_Sprite(WPN.Point.X-KX,WPN.Point.Y-KY,WPN.ang-90,Mash,Size*Mash);
    end;
  3:;
  4:glColor4f(5,5,0,5);
 end;
end;

procedure Check_Keys;       { }
Var i,j:integer;
begin
 i:=0;
 if MW>0 then Mash:=Mash*1.1;
 if MW<0 then Mash:=Mash*0.9;
 if MW<>0 then MW:=0;
 DX:=((+MX-PW/2)*0.0129/mash)+kx;
 DY:=((-MY+PH/2)*0.0129/mash)+ky; {   }
 if (begintime<0) and (Game_Mode=0) then {race}
 begin
  if key[87] or key[38] then  {gas}
   begin
    if (Cars[i].Speed<Cars[i].MaxSpeed) then
     Cars[i].Speed:=Cars[i].Speed+0.002;
      {key[38]:=false;key[87]:=false;}
   end else{up}
  if key[83] or key[40] then begin  {tormoz i nazad}
    if (Cars[i].Speed>0) then
     Cars[i].Speed:=Cars[i].Speed-0.01 else
      if (Cars[i].Speed>-Cars[i].MaxSpeed/2) then
       Cars[i].Speed:=Cars[i].Speed-0.001;
     {key[40]:=false;key[83]:=false;}
     end else{down}
     Cars[i].Speed:=Cars[i].Speed*(0.97);
  if key[65] or key[37] then   {povorot vpravo}
   begin
    if (Cars[i].ControlAng<15) then
     if (Cars[i].ControlAng>0) then
      Cars[i].ControlAng:=Cars[i].ControlAng+0.3 else
       Cars[i].ControlAng:=Cars[i].ControlAng+0.9;
   end else{left}
  if key[68] or key[39] then   {povorot vlevo}
   begin
    if (Cars[i].ControlAng>-15) then
     if (Cars[i].ControlAng<0) then
     Cars[i].ControlAng:=Cars[i].ControlAng-0.3 else
      Cars[i].ControlAng:=Cars[i].ControlAng-0.9;
   end else{rigth}
   if Cars[i].ControlAng>0.7 then  {vozvrat rulya}
    Cars[i].ControlAng:=Cars[i].ControlAng-0.9 else
    if Cars[i].ControlAng<-0.7 then
     Cars[i].ControlAng:=Cars[i].ControlAng+0.9
      else Cars[i].ControlAng:=0;
  if (key[90] or key[97]) and (Cars[i].Mashingun>0) then  {pulemet}
   begin
    j:=random(20);
    add_WPN(Cars[i].Point.X,Cars[i].Point.Y,Get_X_V(Cars[i].Ang,0.8+j/30),Get_Y_V(Cars[i].Ang,0.8+j/30),Cars[i].Ang,1,5,60,0);
    Cars[i].Mashingun:=Cars[i].Mashingun-1;
   end;
  if (key[88] or key[98]) and (Cars[i].Rockets>0) then    {raketa}
   begin
   add_WPN(Cars[i].Point.X,Cars[i].Point.Y,0,0,Cars[i].Ang,0,35,60,0);
   Cars[i].Rockets:=Cars[i].Rockets-1;
   key[88]:=false;
   key[98]:=false;
  end;
 if (key[67] or key[99]) and (Cars[i].mines>0) then    {mina}
  begin
   add_WPN(Cars[i].Point.X,Cars[i].Point.Y,0,0,Cars[i].Ang,2,35,1000,0);
   Cars[i].mines:=Cars[i].mines-1;
   key[67]:=false;
   key[99]:=false;
  end;
 end; 
 if key[192] then
  begin
   Test:=Not Test;
   key[192]:=false;
  end;
 if key[27] then
  begin
   if Game_Mode=0 then
    Game_Mode:=1 else Game_Mode:=0; {Esc }
   key[27]:=false;
  end;
end;

procedure AI_control;
Var i,j,z:integer; Ang:Single;
begin
 for i:=1 to Max_Cars do
 if Cars[i].Real then
  begin {vsegda gas}
   begin
    if (Cars[i].Speed<Cars[i].MaxSpeed) then
     Cars[i].Speed:=Cars[i].Speed+0.002;
   end;
   {rul v storony tecushei tochki}
   ang:=Head_Rotate(Cars[i].Ang,Get_A(Cars[i].Point,plus(WayPoints[Cars[i].WayPoint].Point,Cars[i].AICorrect)),15);
   if Random(40)=1 then
    Cars[i].AIIdea:=20;
   for j:=0 to Max_Cars do      {minigun}
    if (i<>j) and Cars[j].real then
     if (Get_A(Cars[i].Point,Cars[j].Point)-Cars[i].Ang<10) then
      if  (Cars[i].Mashingun>0) and (Cars[i].AIIdea>0) then  {pulemet}
       begin
        Cars[i].AIIdea:=Cars[i].AIIdea-1;
        ang:=Head_Rotate(Cars[i].Ang,Get_A(Cars[i].Point,Cars[j].Point),10);
        z:=random(20);
        add_WPN(Cars[i].Point.X,Cars[i].Point.Y,Get_X_V(Cars[i].Ang,0.8+z/30),Get_Y_V(Cars[i].Ang,0.8+z/30),Cars[i].Ang,1,5,60,i);
        Cars[i].Mashingun:=Cars[i].Mashingun-1;
       end;
    begin
   if Random(50)=1 then
    Cars[i].AIIdea:=1;
    for j:=0 to Max_Cars do           {raketa}
    if (i<>j) and Cars[j].real then
     if (Get_A(Cars[i].Point,Cars[j].Point)-Cars[i].Ang<7) then
      if (Cars[i].AIIdea=1) then
       begin
        Cars[i].AIIdea:=Cars[i].AIIdea-1;
        if  (Cars[i].Rockets>0) then
         begin
          ang:=Head_Rotate(Cars[i].Ang,Get_A(Cars[i].Point,Cars[j].Point),7);
          add_WPN(Cars[i].Point.X,Cars[i].Point.Y,0,0,Cars[i].Ang,0,35,60,i);
          Cars[i].Rockets:=Cars[i].Rockets-1;
         end;
       end;
     if Random(150)=1 then
      if (Cars[i].mines>0) then    {mina}
       begin
        add_WPN(Cars[i].Point.X,Cars[i].Point.Y,0,0,Cars[i].Ang,2,35,1000,i);
        Cars[i].mines:=Cars[i].mines-1;
       end;
{ if key[17] and (Cars[i].Rockets>0) then    
{  begin
   add_WPN(Cars[i].Point.X,Cars[i].Point.Y,0,0,Cars[i].Ang,0,35,60,0);
   Cars[i].Rockets:=Cars[i].Rockets-1;
   key[17]:=false;
  end;
 if key[90] and (Cars[i].mines>0) then    {mina}
{  begin
   add_WPN(Cars[i].Point.X,Cars[i].Point.Y,0,0,Cars[i].Ang,2,35,1000,0);
   Cars[i].mines:=Cars[i].mines-1;
   key[90]:=false;
  end;         }
    end;

   Cars[i].ControlAng:=Cars[i].ControlAng*0.5{}+ang*0.5;
   end;
 for i:=1 to Max_Cars do
 if Cars[i].Real then
   begin
   if (Get_S(Cars[i].Point,plus(WayPoints[Cars[i].WayPoint].Point,Cars[i].AICorrect))<8) then
   {pereklucheniye na sleduuyshuy tochky - esli proehal predidyshyuy}
    begin
   {  if (Cars[i].WayPoint=0) and (WayPoints[Cars[i].WayPoint].Next=1) then
      place:=place+1; }
     Cars[i].WayPoint:=WayPoints[Cars[i].WayPoint].Next;
     Cars[i].AICorrect:=Vector(Random(5)-2,Random(5)-2);
    end;
  end;
end;

procedure Move_Objects;
Var i,j,z,f:integer;r,s,d:single;fly:boolean;
begin
 {moving}
 for i:=0 to Max_Parts do
  if Parts[i].life>0 then
   begin
    Parts[i].life:=Parts[i].life-1;
    if (Parts[i].tip<>0) then
     Parts[i].Point:=plus(Parts[i].Point,Parts[i].Vector);
    Case Parts[i].tip of
     0:begin {shini}
       end;
     3:begin {ogon}
        if Parts[i].life=0 then
         Add_Part(Parts[i].Point.X,Parts[i].Point.Y,Wind.X,Wind.Y,2,30);
       end;
    end;
   end;
 for i:=0 to Max_WPN do
  if WPN[i].life>0 then
   begin
    WPN[i].life:=WPN[i].life-1;
    WPN[i].Point:=plus(WPN[i].Point,WPN[i].Vector);
    Case WPN[i].tip of
     0:begin {rocket}
       WPN[i].Vector:=plus(WPN[i].Vector,Get_Vect(WPN[i].ang,0.03));
       Add_Part(WPN[i].Point.X,WPN[i].Point.Y,Wind.X,Wind.Y,3,3);
      end;
     1:begin {pulemet}
      // WPN[i].Vector:=plus(WPN[i].Vector,Get_Vect(WPN[i].ang,0.03));
      // Add_Part(WPN[i].Point.X,WPN[i].Point.Y,Wind.X,Wind.Y,3,3);
      end;
    end;
    for j:=0 to Max_Cars do
     if  Cars[j].Real and (j<>WPN[i].Master) then
      if (Cars[j].Point.X+CBR>WPN[i].Point.X) and
         (Cars[j].Point.Y+CBR>WPN[i].Point.Y) and
         (Cars[j].Point.X-CBR<WPN[i].Point.X) and
         (Cars[j].Point.Y-CBR<WPN[i].Point.Y) then {hit}
       begin
        Cars[j].Life:=Cars[j].Life-WPN[i].Damage;
        Add_Part(WPN[i].Point.X,WPN[i].Point.Y,Cars[j].Vector.X,Cars[j].Vector.Y,4,5);
        WPN[i].life:=0;
        if (Cars[j].Life<0) then
         begin
          boom(Cars[j].Point,30);
          add_Part(Cars[j].Point.X,Cars[j].Point.Y,Random(200)/400-0.25,Random(200)/400-0.25,5,20);
          add_Part(Cars[j].Point.X,Cars[j].Point.Y,Random(200)/400-0.25,Random(200)/400-0.25,5,20);
          add_Part(Cars[j].Point.X,Cars[j].Point.Y,Random(200)/400-0.25,Random(200)/400-0.25,5,20);
          add_Part(Cars[j].Point.X,Cars[j].Point.Y,Random(200)/400-0.25,Random(200)/400-0.25,5,20);
          Cars[j].Life:=70;
          Cars[j].Real:=false;
          Cars[j].Speed:=0;
         end;
       end;
   end;      
 for i:=0 to Max_Cars do
  if not Cars[i].Real then
  if Cars[i].Life>1 then
   Cars[i].Life:=Cars[i].Life-1 else
   if Cars[i].Life=1 then
    begin
     Cars[i].Life:=100;
     Cars[i].Real:=true;
    end;
 for j:=0 to Max_Tramps do
 if tramp[j].real then
 for i:=0 to Max_Cars do
  if Cars[i].Real then
   if (((Cars[i].Point.X+CBR>tramp[j].A.X) and
       (Cars[i].Point.X-CBR<tramp[j].B.X)) or
       ((Cars[i].Point.X+CBR>tramp[j].B.X) and
       (Cars[i].Point.X-CBR<tramp[j].A.X))) and
       (((Cars[i].Point.Y+CBR>tramp[j].A.Y) and
       (Cars[i].Point.Y-CBR<tramp[j].B.Y)) or
       ((Cars[i].Point.Y+CBR>tramp[j].B.Y) and
       (Cars[i].Point.Y-CBR<tramp[j].A.Y))) then
   if (Get_LP_S(tramp[j].A,tramp[j].B,Cars[i].Point)<CBR) then
    begin
  //  if (Get_S(tramp[j].A,Cars[i].Point)+Get_S(tramp[j].B,Cars[i].Point)-CBR*2<=Get_S(CollPoints[j].A,CollPoints[j].B)) then
     case tramp[j].tip of
     0:begin   {tramplin}
        Cars[i].HV:=Cars[i].RealSpeed;
        if i=0 then
         Check:=true;
        first:=true;
       end;
     1:begin  {speed}
        Cars[i].Speed:=Cars[i].MaxSpeed*2.1;
       end;
     2:begin {start}
        Cars[i].Rockets:=10;
        Cars[i].Mashingun:=300;
        Cars[i].mines:=10;
       end;
     end;
     if (j=0) and first then
      begin first:=false;place:=1;end else
       place:=place+1;
     if (j=0) and (i=0) and (Check) then
     begin
      Check:=false;
      lap:=lap+1;
      if (lap=maxlap) then
       begin
        Game_Mode:=2;
       end;
     end;
    end;
 for i:=0 to Max_Cars do
  if Cars[i].Real then
  begin
   fly:=true;
   Cars[i].Heigth:=Cars[i].Heigth+Cars[i].HV;
   if (Cars[i].Heigth<=0.1) then
   begin
    fly:=false;
    Cars[i].HV:=0;
    Cars[i].Heigth:=0.1;
   end else
   Cars[i].HV:=Cars[i].HV-0.008;
   Cars[i].RealAng:=Get_A(Cars[i].Vector);
   Cars[i].RealSpeed:=Get_S(Vector(0,0),Cars[i].Vector);
   {sledi ot  shin}
   if (((abs(abs(Cars[i].Speed)-Cars[i].RealSpeed)/Cars[i].MaxSpeed>=0.12)) or
    (abs(90-abs(abs(Cars[i].Ang-Cars[i].RealAng)-180))/90<0.5)) and (not fly) then
    begin
     if Random(5)=0 then
      Add_Part(Cars[i].Point.X,Cars[i].Point.Y,Wind.X,Wind.Y,2,50);
     Add_Part(Cars[i].Point.X+Get_X_V(Cars[i].Ang+30,0.5),Cars[i].Point.Y+Get_Y_V(Cars[i].Ang+30,0.5),Cars[i].Vector.X,Cars[i].Vector.Y,0,1000);
     Add_Part(Cars[i].Point.X+Get_X_V(Cars[i].Ang-30,0.5),Cars[i].Point.Y+Get_Y_V(Cars[i].Ang-30,0.5),Cars[i].Vector.X,Cars[i].Vector.Y,0,1000);
     Add_Part(Cars[i].Point.X+Get_X_V(Cars[i].Ang+150,0.5),Cars[i].Point.Y+Get_Y_V(Cars[i].Ang+150,0.5),Cars[i].Vector.X,Cars[i].Vector.Y,0,1000);
     Add_Part(Cars[i].Point.X+Get_X_V(Cars[i].Ang-150,0.5),Cars[i].Point.Y+Get_Y_V(Cars[i].Ang-150,0.5),Cars[i].Vector.X,Cars[i].Vector.Y,0,1000);
    end;
    if (abs(90-abs(abs(Cars[i].Ang-Cars[i].RealAng)-180))/90<0.5) then
     Cars[i].Scep:=0.97 else Cars[i].Scep:=0.98;
   if fly then Cars[i].Scep:=1;
   if (Random(10)<Trunc(Cars[i].RealSpeed*30)) and (not fly) then
    begin
     Add_Part(Cars[i].Point.X+Get_X_V(Cars[i].Ang+145,0.5),Cars[i].Point.Y+Get_Y_V(Cars[i].Ang+145,0.5),Wind.X,Wind.Y,1,50);
     Add_Part(Cars[i].Point.X+Get_X_V(Cars[i].Ang-145,0.5),Cars[i].Point.Y+Get_Y_V(Cars[i].Ang-145,0.5),Wind.X,Wind.Y,1,50);
    end;
  // if not fly then
    Cars[i].Ang:=Get_R(Cars[i].Ang+Cars[i].ControlAng*Cars[i].RealSpeed{+Cars[i].ControlAng*Cars[i].Scep});{*Cars[i].scep)}
   {gazuem}
   if not fly then
    if Cars[i].Speed>=Cars[i].RealSpeed then
     Cars[i].Vector:=plus(Cars[i].Vector,Get_Vect(Cars[i].Ang,0.008));
   if not fly then
    if Cars[i].Speed>Cars[i].MaxSpeed then
     Cars[i].Speed:=Cars[i].Speed*0.99;
   {sdaem nazad}
   if not fly then
    if Cars[i].Speed<=-Cars[i].RealSpeed then
     Cars[i].Vector:=plus(Cars[i].Vector,Get_Vect(Cars[i].Ang,-0.005));
  {sobstvenno dvigeniye}
   Cars[i].Point:=plus(Cars[i].Point,Cars[i].Vector);
   {tormogeniye}
   Cars[i].Vector.X:=Cars[i].Vector.X*Cars[i].Scep;
   Cars[i].Vector.Y:=Cars[i].Vector.Y*Cars[i].Scep;
  { if (abs(Cars[i].Speed)<Cars[i].RealSpeed/2) or (abs(90-abs(abs(Cars[i].Ang-Cars[i].RealAng)-180))/90<0.6) then
    begin
     Cars[i].Vector.X:=Cars[i].Vector.X*0.94;
     Cars[i].Vector.Y:=Cars[i].Vector.Y*0.94;
    end;   }
  end;
  {stolknoveniya s prepyatstviyami}
 for i:=0 to Max_Cars do
  if Cars[i].real then
  for j:=0 to Max_CollPoints do
   if CollPoints[j].real then
   begin
    r:=abs(Get_LP_S(CollPoints[j].A,CollPoints[j].B,Cars[i].Point));
    s:=Get_S(CollPoints[j].A,Cars[i].Point);
    d:=Get_S(CollPoints[j].B,Cars[i].Point);
    if (r<CBR)  then
     if (d+s-CBR<=Get_S(CollPoints[j].A,CollPoints[j].B)) then
     begin
      s:=Get_A(CollPoints[j].A,CollPoints[j].B);       //ugol naleta na liniyu
      s:=Get_R(s-90);
      Cars[i].Point:=plus(Cars[i].Point,Get_Vect(s,(CBR-r+0.1)));
      r:=Get_A(Vector(0,0),Cars[i].Vector);
      d:=Get_S(Vector(0,0),Cars[i].Vector);
      Cars[i].Vector:=minus(Cars[i].Vector,Get_Vect(s,Get_X_V(Get_R(r-s),d*1.01)));
      Cars[i].Ang:=Cars[i].Ang+Head_Rotate(Cars[i].Ang,r,5);
    end;
   end;
 {peresecheniya}
{ for z:=0 to 1 do
 for f:=0 to 1 do
 begin    }
 for i:=0 to Max_Cars do
  if Cars[i].Real then
  begin
   for j:=0 to Max_Cars do
    if Cars[j].Real then
    if (i<>j) then {:)}
    if (Cars[i].Point.X+1>Cars[j].Point.X) and
       (Cars[i].Point.X-1<Cars[j].Point.X) and
       (Cars[i].Point.Y+1>Cars[j].Point.Y) and
       (Cars[i].Point.Y-1<Cars[j].Point.Y) then { vozmogno}
     begin
      if (Get_S(Cars[i].Point,Cars[j].Point)<CBR*2) then
       begin      {stolknoveniye s peredney chastyu mashini}
       r:=Get_A(Cars[i].Point,Cars[j].Point); {   }
       s:=Get_A(Vector(0,0),Cars[i].Vector); {  }
       d:=Get_S(Vector(0,0),Cars[i].Vector); {  }
       Cars[j].Correct:=plus(Cars[j].Correct,   {    }
          Get_Vect(r,Get_X_V(Get_R(s-r),d/2)));{ Correct,      -
           ,        }
       Cars[i].Correct:=minus(Cars[i].Correct,  {    }
          Get_Vect(r,Get_X_V(Get_R(s-r),d/2))); {tut ispravlenin sili udara}
       end;
     end;
  end;
 for i:=0 to Max_Cars do    { }
  if Cars[i].real then
   begin
    if (Cars[i].Correct.X<>0) or (Cars[i].Correct.Y<>0) then {    Correct}
      Cars[i].Vector:=plus(Cars[i].Vector,Cars[i].Correct);{    }
    Cars[i].Correct:=Vector(0,0);
   end;
 for i:=0 to Max_Cars do
  if Cars[i].Real then
  begin
   for j:=0 to Max_Cars do
    if Cars[j].Real then
    if (i<>j) then {:)}
    if (Cars[i].Point.X+1>Cars[j].Point.X) and
       (Cars[i].Point.X-1<Cars[j].Point.X) and
       (Cars[i].Point.Y+1>Cars[j].Point.Y) and
       (Cars[i].Point.Y-1<Cars[j].Point.Y) then { vozmogno}
     begin
      if (Get_S(Cars[i].Point,Cars[j].Point)<CBR*2) then
       begin
        r:=Get_A(Cars[i].Point,Cars[j].Point); {   }
        s:=Get_S(Cars[i].Point,Cars[j].Point); {   }
        d:=CBR*2-S{Get_S(Vector(0,0),Cars[i].BVector[z])}; {  }
        Cars[j].Correct:=Get_Vect(r,d);
       end;
     end;
  end;
 for i:=0 to Max_Cars do
  begin
    Cars[i].Point:=plus(Cars[i].Point,Cars[i].Correct);
    Cars[i].Correct:=Vector(0,0);
  end;
 {KX ?}
 KX:=(Cars[Camera].Point.X+Get_X_V(Cars[Camera].RealAng,4/Mash))*0.15+KX*0.85;
 KY:=(Cars[Camera].Point.Y+Get_Y_V(Cars[Camera].RealAng,4/Mash))*0.15+KY*0.85;
 //KA:=KA+Head_Rotate(KA,Cars[0].RealAng,1);
 {test}
 If (Trunc(Cars[0].Point.X)=54) and (Trunc(Cars[0].Point.Y)=0) then
  begin
   Cars[0].Speed:=Cars[0].Speed/1.5;
   Cars[0].Ang:=Get_R(Cars[0].Ang+(Random(2)*2-1)*5);
  end;
end;

procedure Render;    {}
Var
  i,j:integer;
begin
 glclear(GL_Color_Buffer_Bit xor GL_Depth_Buffer_Bit);  {}
 glLoadIdentity();     {}
{render}              
 glEnable(GL_Texture_2d);
 glColor3f(5,5,5);
 glBindTexture(GL_Texture_2d,Tex[0]);
 glbegin(GL_Quads);         {  }
  gltexcoord2f(10/Mash-(KX)/2{*Mash},10/Mash-(KY)/2{*Mash});        {}
  glvertex2f(-10,-10);    {}
  gltexcoord2f(-(KX)/2{*Mash},10/Mash-(KY)/2{*Mash});
  glvertex2f(+10,-10);
  gltexcoord2f(-(KX)/2{*Mash},-(KY)/2{*Mash});
  glvertex2f(+10,+10);
  gltexcoord2f(10/Mash-(KX)/2{*Mash},-(KY)/2{*Mash});
  glvertex2f(-10,+10);
 glend;
 Draw_Sprites(0);
 For i:=0 to Max_Parts do
  if Parts[i].life>0 then
   Draw_Part(Parts[i]);
 For i:=0 to Max_Cars do
  if Cars[i].Real then
   Draw_Car_Shadow(Cars[i]);
 For i:=0 to Max_Cars do
  if Cars[i].Real then
   Draw_Car(Cars[i]);
 For i:=0 to Max_WPN do
  if WPN[i].life>0 then
   Draw_WPN(WPN[i]);
 Draw_Sprites(1);
 glDisable(GL_Texture_2d);
 {test}
 IF Test Then
 begin
 {WAYPOINTS}
  glColor4f(5,5,0,5);
  glbegin(GL_LINES);
  For i:=0 to Max_WayPoints do
   if WayPoints[i].tip>0 then
    begin
     GLVertex2f((WayPoints[i].Point.X-KX)*Mash,(WayPoints[i].Point.Y-KY)*Mash);
     GLVertex2f((WayPoints[WayPoints[i].Next].Point.X-KX)*Mash,(WayPoints[WayPoints[i].Next].Point.Y-KY)*Mash);
    end;
  glend;
  glColor4f(0,0,0,5);
  glbegin(GL_LINES);
  For i:=0 to Max_CollPoints do
   if CollPoints[i].real then
    begin
     GLVertex2f((CollPoints[i].A.X-KX)*Mash,(CollPoints[i].A.Y-KY)*Mash);
     GLVertex2f((CollPoints[i].B.X-KX)*Mash,(CollPoints[i].B.Y-KY)*Mash);
    end;
  glend;
  glColor4f(4,4,0,5);
  glbegin(GL_LINES);
  For i:=0 to 10 do
   if Tramp[i].real then
    begin
     GLVertex2f((Tramp[i].A.X-KX)*Mash,(Tramp[i].A.Y-KY)*Mash);
     GLVertex2f((Tramp[i].B.X-KX)*Mash,(Tramp[i].B.Y-KY)*Mash);
    end;
  glend;
  {test}
  glColor4f(5,0,0,5);
  glbegin(GL_LINES);
  GLVertex2f(0,0);
  GLVertex2f(Get_X_V(Cars[0].RealAng,1),Get_Y_V(Cars[0].RealAng,1));
  glend;
  glColor4f(0,0,0,5);
  glbegin(GL_LINES);
  GLVertex2f(0,0);
  GLVertex2f(Get_X_V(Cars[0].Ang+Cars[0].ControlAng*5,0.7),Get_Y_V(Cars[0].Ang+Cars[0].ControlAng*5,0.7));
  glend;
 end;
// glRotatef(KA-90,0,0,1);
 {test}
 glColor4f(0,0,0,5);
 Put_Text('Rockets  '+IntToStr(Cars[Camera].Rockets),-6,4);
 Put_Text('Minigun  '+IntToStr(Cars[Camera].Mashingun),-6,3.4);
 Put_Text('Mines     '+IntToStr(Cars[Camera].Mines),-6,2.8);
 Put_Text('Laps '+IntToStr(Lap)+'/'+IntToStr(MaxLap),5,4);
 if test then
  begin
   Put_Text('Speed '+IntToStr(trunc(Cars[0].Speed*10000))+'RealSpeed '+IntToStr(trunc(Cars[0].RealSpeed*10000)),-6,2.2);
   Put_Text('ang  '+IntToStr(trunc(Cars[0].ang))+' '+IntToStr(trunc(Cars[0].realang)),-6,1.6);
  end;
 if begintime>-60 then
  begin
   begintime:=begintime-1;
   if begintime>0 then
    Put_Text('-= '+IntToStr(trunc(begintime/60)+1)+' =-',-0.5,0)
   else
    Put_Text('-= START! =- ',-1,0)
  end;
 {Map}
 glDisable(GL_Texture_2d);
 glColor3f(0,5,0);
// glEnable(GL_LINE_WIDTH);
 glbegin(GL_LINE_Strip);
 For i:=0 to Max_WayPoints do
  if WayPoints[i].tip>0 then
    GLVertex2f(-4+WayPoints[i].Point.X*0.01,-4+WayPoints[i].Point.Y*0.01);
  GLVertex2f(-4+WayPoints[0].Point.X*0.01,-4+WayPoints[0].Point.Y*0.01);
 glend;
 glbegin(GL_Points);
 glColor3f(0,0,5);
 if Cars[0].Real then
  GLVertex2f(-4+Cars[0].Point.X*0.01,-4+Cars[0].Point.Y*0.01);
 glColor3f(5,0,0);
 For i:=1 to Max_Cars do
  if Cars[i].Real then
   GLVertex2f(-4+Cars[i].Point.X*0.01,-4+Cars[i].Point.Y*0.01);
 glend;
 glDisable(GL_Blend);
 if Game_Mode<>0 then
  put_Menu;
 glEnable(GL_Blend);
 glEnable(GL_Texture_2d);
 glFlush();
 SwapBuffers(glhDC);
end;

procedure TactTimer;  { }
begin
 Check_Keys;    {    }
 if Game_Mode<>0 then
  Check_Menu((DX-KX)*Mash,(DY-KY)*Mash,mbl or mbr);
 if (begintime<0) and ((game_mode=0) or not Cars[0].real) then
  begin
   AI_control;
   Move_Objects;
  end;
 Render;        {}
 if (Game_Mode=-1) then Kill_Prog;
end;

procedure Create_prog;{ }
Var
  i,j:integer;
begin
// ShowCursor(false);  { }
 glPointSize(8);
 glLineWidth(4);
 Randomize;
 glClearColor(1.0,1.0,1.0,0);
 enable_bind_tex;
 glShadeModel(GL_SMOOTH);
 Gen_Font(glhDC);  {font}
 glDisable(GL_Depth_Test);  {   }
 {koords}
 KX:=0;
 KY:=0;
 Wind.X:=0.02;
 Wind.Y:=0.02;
 Mash:=0.6;
 Create_Menu;
 {test}
{ Cars[0].Real:=true;
 Cars[0].Life:=100;
 Cars[0].tip:=2;
 Cars[0].MaxSpeed:=0.28;
 Cars[0].Vector.X:=0.001;
 Cars[0].Heigth:=0.1;   }
 {     }
 for i:=1 to Max_Cars do
 begin
  Cars[i].Real:=true;
  Cars[i].Life:=100;
  Cars[i].tip:=Random(3);
  Cars[i].MaxSpeed:=0.28;
  Cars[i].Vector.X:=0.001;
  Cars[i].WayPoint:=1;
  Cars[i].Heigth:=0.1;
  Cars[i].AICorrect:=Vector(Random(5)-2,Random(5)-2);
 end;
{ Add_Tramp(0,-49,0,-70,2);
 Add_Tramp(20,-50,20,-60,0);
 Add_Tramp(20,50,20,60,1);  }
 Load_Level('Lev1.txt');
 for i:=0 to Max_Cars do
  begin
   Cars[i].Point.X:=Tramp[0].A.X+(Tramp[0].B.X-Tramp[0].A.X)/(Max_Cars+2)*(i+1);
   Cars[i].Point.Y:=Tramp[0].A.Y+(Tramp[0].B.Y-Tramp[0].A.Y)/(Max_Cars+2)*(i+1);
   Cars[i].Ang:=Get_A(Cars[i].Point,WayPoints[0].Point);
  end;
 KX:=Cars[0].Point.X;
 KY:=Cars[0].Point.Y;

 {collisions}
 {tex}
 for i:=0 to 15 do Tex[i]:=i;
 LoadTGATexture('IMG\sand.tga',Tex[0]);
 LoadTGATexture('IMG\Block.tga',Tex[1]);
 LoadTGATexture('IMG\Road.tga' ,Tex[2]);
 LoadTGATexture('IMG\Rock1.tga',Tex[3]);
 LoadTGATexture('IMG\Rock2.tga',Tex[4]);
 LoadTGATexture('IMG\Rock3.tga',Tex[5]);
 LoadTGATexture('IMG\Rock4.tga',Tex[6]);
 LoadTGATexture('IMG\Rock5.tga',Tex[7]);
 LoadTGATexture('IMG\tramp.tga',Tex[8]);
 LoadTGATexture('IMG\Block.tga',Tex[9]);
 LoadTGATexture('IMG\Block.tga',Tex[10]);
 LoadTGATexture('IMG\Block.tga',Tex[11]);
 LoadTGATexture('IMG\Block.tga',Tex[12]);
 LoadTGATexture('IMG\Block.tga',Tex[13]);
 LoadTGATexture('IMG\Block.tga',Tex[14]);
 LoadTGATexture('IMG\Part_Dim.tga',Tex[15]);
 for i:=0 to 5 do CarTex[i]:=i+16;
 LoadTGATexture('IMG\Car_1.tga',Cartex[0]);
 LoadTGATexture('IMG\Car_2.tga',Cartex[1]);
 LoadTGATexture('IMG\Car_3.tga',Cartex[2]);
 for i:=0 to 2 do KolTex[i]:=i+21;
 LoadTGATexture('IMG\Koleso_1.tga',Koltex[0]);
 LoadTGATexture('IMG\Koleso_2.tga',Koltex[1]);
 LoadTGATexture('IMG\Koleso_3.tga',Koltex[2]);
 for i:=0 to 2 do WPNTex[i]:=i+24;
 LoadTGATexture('IMG\WPN_1.tga',WPNtex[0]);
 LoadTGATexture('IMG\WPN_2.tga',WPNtex[1]);
 LoadTGATexture('IMG\WPN_3.tga',WPNtex[2]);
 Camera:=Random(6)+1;
 {}
end;

procedure Kill_Prog;
begin
 //ChangeDisplaySettings(devMode(nil^), 0);{ }
 KillTimer(0,TactH);     { }
 PostQuitMessage (0);
 ShowCursor(True);        { }
end;

end.
