unit Use_Geom;

interface

{uses Math;}

const pi=3.14159265358979;    

type
  TVect = record
    X,Y:single;
  end;
                               
function ArcCos(const X: Extended): Extended;
function Get_R(S:single):single; {  <360  >0}
function Get_S(V1,V2:TVect):single;overload;{  }
function Get_S(X1,Y1,X2,Y2:single):single;overload;{  }
function Get_A(V1,V2:TVect):single;overload;  {  }  
function Get_A(V:TVect):single;overload;  {  }
function Get_X_V(ang,spd:single):single; {  sin}
function Get_Y_V(ang,spd:single):single;{  cos}
function Get_Vect(ang,spd:single):TVect; {  sin    }
function minus(A,B:TVect):TVect; { }
function plus(A,B:TVect):TVect; { }
function Vector(X,Y:single):TVect; { }
function Head_Rotate(SA,RA,Speed:single):single;{     1  2   3}
function Get_orient(A,B,C:TVect):Integer;{        }
function Get_LP_S(A,B,C:TVect):Single;
function Get_LP_ST(A,B,C:TVect):Single; 
function Collisions(b1,e1,b2,e2:TVect;var Rez:TVect):Boolean;
function next_128(A:byte):byte;
function next_64(A:byte):byte;
function next_32(A:byte):byte;
function next_16(A:byte):byte;
function next_8(A:byte):byte;
function next_12(A:byte):byte;

implementation

function ArcTan2(const Y, X: Extended): Extended;
asm
        FLD     Y
        FLD     X
        FPATAN
        FWAIT
end;

function ArcCos(const X: Extended): Extended;
begin
  Result := ArcTan2(Sqrt(1 - X * X), X);
end;

function Get_R(S:single):single; {GRADUS}
begin
 Repeat
  If S<0 then S:=S+360;
  If S>=360 then S:=S-360;
 Until (S>=0) and (S<360);
 Get_R:=S;
end;

function Get_S(V1,V2:TVect):single;{  }
var S:Single;
begin
 S:=sqrt((V2.X-V1.X)*(V2.X-V1.X)+(V2.Y-V1.Y)*(V2.Y-V1.Y));
 If S=0 then S:=0.0000001;  {    0}
 Get_S:=S;
end;

function Get_S(X1,Y1,X2,Y2:single):single;{  }
var S:Single;
begin
 S:=sqrt((X2-X1)*(X2-X1)+(Y2-Y1)*(Y2-Y1));
 If S=0 then S:=0.0000001;  {    0}
 Get_S:=S;
end;

function Get_A(V1,V2:TVect):single;overload;  {  }
Var S,C:single;
begin
 C:=(V2.X-V1.X)/Get_S(V1,V2);  {  }
 If C>=1 then C:=1;            {  }
 If C<=-1 then C:=-1;
 S:=(arccos(C))*180/pi;        {  }
 If (V2.Y-V1.Y)>0 then S:=Get_R(360-S); { ,  -   :)   }
 S:=Get_R(-S);
 Get_A:=S;
end;

function Get_A(V:TVect):single;overload;  {  }
Var S,C:single;V1:TVect;
begin
 V1.X:=0;
 V1.Y:=0;
 C:=(V.X-V1.X)/Get_S(V1,V);  {  }
 If C>=1 then C:=1;            {  }
 If C<=-1 then C:=-1;
 S:=(arccos(C))*180/pi;        {  }
 If (V.Y-V1.Y)>0 then S:=Get_R(360-S); { ,  -   :)   }
 S:=Get_R(-S);
 Get_A:=S;
end;

function Get_X_V(ang,spd:single):single; {  sin}
begin
 Get_X_V:=cos(ang/180*pi)*spd;
end;

function Get_Y_V(ang,spd:single):single;{  cos}
begin
 Get_Y_V:=sin(ang/180*pi)*spd;
end;

function Get_Vect(ang,spd:single):TVect;{  sin    }
begin
 Get_Vect.X:=cos(ang/180*pi)*spd;
 Get_Vect.Y:=sin(ang/180*pi)*spd;
end;


function minus(A,B:TVect):TVect; { }
begin
 minus.X:=A.X-B.X;
 minus.Y:=A.Y-B.Y;
end;

function plus(A,B:TVect):TVect; { }
begin
 plus.X:=A.X+B.X;
 plus.Y:=A.Y+B.Y;
end;

function Vector(X,Y:single):TVect; { }
begin
 Vector.X:=X;
 Vector.Y:=Y;
end;
{           }
{  }
function Head_Rotate(SA,RA,Speed:single):single;
var s:ShortInt;
begin
 If (RA>350) or (SA>350) or (RA<10) or (SA<10) then
  begin
   RA:=Get_R(RA+180);SA:=Get_R(SA+180);
  end;
 {     ,   0  359 -    }
 S:=Round(Speed);
 If (ABS(RA-SA)<Speed) then S:=Round(ABS(RA-SA)); {   }
 If (SA<RA) then
  If (RA-SA<=180) then  {    }
   S:=S else S:=-1*S
  else
  If (SA-RA<180) then
   S:=-1*S else S:=S;
 Head_Rotate:=S;
end;

function Get_LP_S(A,B,C:TVect):Single;
{      }
Var dx,dy,d:Single;
begin
 dx:=A.X-B.X;
 dy:=A.Y-B.Y;
 D:=dx*(C.Y-A.Y)-dy*(C.X-A.X);
 Get_LP_S:=abs(D/sqrt(dx*dx+dy*dy));{   - }
end;

function Get_LP_ST(A,B,C:TVect):Single;  { ,    }
{      }
Var dx,dy,d:Single;
begin
 dx:=A.X-B.X;
 dy:=A.Y-B.Y;
 D:=dx*(C.Y-A.Y)-dy*(C.X-A.X);
 Get_LP_ST:=D/sqrt(dx*dx+dy*dy);{   - }
end;

function Get_orient(A,B,C:TVect):Integer;{        }
Var S:Single;
begin
// S:=(A.X-C.X)*(B.Y-C.Y)-(A.Y-C.Y)*(B.X-C.X);
 if (Get_LP_ST(A,B,C)>0) then
  Get_orient:=1 else Get_orient:=-1;
end;

function Collisions(b1,e1,b2,e2:TVect;var Rez:TVect):Boolean;
Var // i,j:byte;
d,d1,d2:extended;
t1,t2:extended;
begin
 Collisions:=false;
 Rez:=Vector(0,0);
 d:=(e1.X-b1.X)*(b2.Y-e2.Y)-(b2.X-e2.X)*(e1.Y-b1.Y);
 If d<>0 then begin
  d1:=(b2.X-b1.X)*(b2.Y-e2.Y)-(b2.X-e2.X)*(b2.Y-b1.Y);
  d2:=(e1.X-b1.X)*(b2.Y-b1.Y)-(b2.X-b1.X)*(e1.Y-b1.Y);
  t1:=d1/d;
  t2:=d2/d;
  If (t1>=0) and (t1<=1) and (t2>=0) and (t2<=1) then
  begin
   Rez:=Vector(t1*e1.X+(1-t1)*b1.X,t1*e1.Y+(1-t1)*b1.Y);
   Collisions:=true;
  end;
 end;
end;

{for animation}
function next_128(A:byte):byte;
begin if A<128 then next_128:=A+1 else next_128:=0;end;

function next_64(A:byte):byte;
begin if A<64 then next_64:=A+1 else next_64:=0;end;

function next_32(A:byte):byte;
begin if A<32 then next_32:=A+1 else next_32:=0;end;

function next_16(A:byte):byte;
begin if A<16 then next_16:=A+1 else next_16:=0;end;

function next_8(A:byte):byte;
begin if A<8 then next_8:=A+1 else next_8:=0;end;

function next_12(A:byte):byte;
begin if A<12 then next_12:=A+1 else next_12:=0;end;

end.
