unit model4;
{
 Made by : SVSD_VAL
 Site    : http://svsd.mirgames.ru
 mail    : Valdim_05@mail.ru or SVSD_VAL@SibNet.ru
 ICQ     : 223-725-915
 Jabber  : svsd_val@Sibnet.ru or svsd_val@Jabber.Sibnet.ru
}
{$Warnings off}
{$Hints on}
interface

uses Windows,OpenGL15,Engine,l_math,materials;

const
     ID                      = 'OGLMAP By SVSD_VAL';
     VERSION                 = 7;
type




  THEADER      = record
   ID          : array [0..18] of Char;
   VERSION     : Word;
  end;



  TObj           = Record
   AlphaTest     : Boolean;
   VERTEXcount,
   FACEcount,
   PlaneCount,
   TEXCount      : Word;

   Vertex        : array of TVector;
   Normals       : array of TVector;
   FACE          : array of TUnsignedFace;
   FACEBBOXS     : array of TAabb;
   FaceSpheres   : Array of TSphere;
   TEXCOORD      : array of TVector2D;
   LMTEXCOORD    : array of TVector2D;
   LMFactor      : array of Single;
   AABB          : TAabb;

   TextureName   : String;
   MaterialNum   : Integer;

   //----------|
   Plane       : array of TPlane;
   Center      : TVector;
   MaxDist     : single;
   Shader_mesh : P3DObject;

   VBO_VCT,
   VBO_Face,
   VBO_TexCoord,
   VBO_TexCoord2: Cardinal;
  end;

  TLMData = Record
   Data   : PByteArray;
   W,H    : integer;
   end;

  P4MODEL = ^T4MODEL;
  T4MODEL = class
  public
   HEADER                : THEADER;
   ObjectsCount          : Word;
   Obj                   : Array of TObj;
   ModelAABB             : TAabb;
   Materials             : Array of Record
                               Name : String;
                               ID   : Cardinal;
                           end;


   LMTextureNum          : Integer;
   LMData                : TLMData;
   drawedtris            : integer;
   eee,ddd                   : integer;
   XXX                    : TVector;
   rTextures,
   rLightmaps : boolean;


   function  LoadFromFile(FileName,TextureDir:string):Boolean;

//   Procedure Render       (const Pos:TVector);
   Procedure RenderNoTex  (const Pos:TVector);
   Procedure ShaderRender (RenderMode:TMaterialRenderMode;Light:boolean);

   function  Collision            (Var Pos,Normal :TVector; Const ADDPOS: TVector; const R: single): boolean;
   function  CollisionAcc         (var Pos,Acc:TVector; const ADDPOS: TVector; const R: single): boolean;
   function  CollisionAcc2        (var Pos,Speed,Acc:TVector; const ADDPOS: TVector; const R: single): boolean;
   function  CollisionWObj        (Var Pos    :TVector; Const ADDPOS: TVector; const R: single;const I:integer): boolean;

   function ElipsoidCollision     (var Pos:TVector; const ADDPOS,Radius: TVector): boolean;
   function ElipsoidCollisionACC  (var Pos,ACC:TVector; const ADDPOS,Radius: TVector): boolean;
   function ElipsoidCollisionACC2(var Pos,Speed,Acc : TVector; const ADDPOS,Radius: TVector): boolean;

   function  LineCollisionWithNum (const BP,EP, ADDPOS: TVector;const ObjNum:Integer): boolean;
   function  LineCollision        (const BP,EP, ADDPOS: TVector): boolean;
   function  LineCollisionWithNum2(const BP,EP, ADDPOS: TVector;const ObjNum:Integer): TVector;
   function  LineCollision2       (const BP,EP, ADDPOS: TVector): TVector;

   function  OnGround         (Const Pos,ADDPOS: TVector; R: single): boolean;
//   Procedure DrawVBO(pos:TVector;Ran:single);

   function  GetColor   (const Pos    :TVector; Const ADDPOS: TVector; const R: single): TVector;
   Function GetColorFromLM(X,Y:Integer) : TVector;
   function  DeleteTextures():boolean;
   Procedure mClear;

  Private
   function  ADDTexture       (FileName:string):Integer;
//   Procedure LoadToARB_VBO;
  end;


implementation
uses game_variables;


Function T4Model.GetColorFromLM(X,Y:Integer) : TVector;
 const glbyte = 1/255;
 var n :integer;
 begin

   n := (X + (Y* LMData.W) )*4;
   if (n >( LmData.W* LmData.H * 4)) or (n<0) then begin result:=v_identity; exit; end;

   Result.x :=( LmData.Data[n]  )* glbyte;
   Result.y :=( LmData.Data[n+1] )* glbyte;
   Result.z :=( LmData.Data[n+2] )* glbyte;
end;

function  T4Model.GetColor   (const Pos    :TVector; Const ADDPOS: TVector; const R: single): TVector;
var
 i, i2  : integer;
 Dist   : single;
 ins,p  : TVector;
 minx,maxx : TVector;
var
 TV     :  TVector2D;
begin
Result := v_identity;

 P := v_sub(POS,addpos);

  dist:=sqrt(2*r*r);
 minx := v_sub(p, vector(dist,dist,dist));;
 maxx := v_add(p, vector(dist,dist,dist));;

for i := 0 to ObjectsCount - 1 do
if uAABBVsAABB(obj[i].aabb.Min,obj[i].aabb.Max,minx,maxx) then
  if V_Dist(obj[i].Center, p) <= obj[i].MaxDist + R then
   with obj[i] do
   for i2 := 0 to FACEcount - 1 do
//   if AABBVsSphere(FACEBBOXS[i2].Mins,FACEBBOXS[i2].Maxs,p,r) then

  if uAABBVsAABB(FACEBBOXS[i2].Min,FACEBBOXS[i2].Max,minx,maxx) then
   begin
      P := v_sub(POS,addpos);

    if P_Classify(Plane[i2],p) > 0 then
     begin

     Dist := P_Dist(p, Plane[i2]);
     if Dist < R then
      begin
      ins    := V_Sub (p, V_Mult(Plane[i2].Normal, Dist));

      if P_InsideTri(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]]) or
			   EdgeSphereCollision(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]], r*0.5) then
//         if abs(P.Y - ins.Y) > R/2 then
//         if P.Y > ins.Y then
         if P_Determine(plane[i2].Normal) =2 then
         begin


        Tv.X := (LmTexCoord[Face[i2, 0]].x + (p.x - Vertex[Face[i2][0]].x )* (lmFactor[i2])) * lmdata.W;
        Tv.y := (LmTexCoord[Face[i2, 0]].y + (p.z - Vertex[Face[i2][0]].z )* (lmFactor[i2])) * lmdata.H;

          Result := GetColorFromLM(round(tv.x),round(tv.y));
          exit;
         end;
      end;
     end;
   end;
end;

Procedure T4model.RenderNoTex;
var i :integer;
begin
 	glEnableClientState(GL_VERTEX_ARRAY);
  Drawedtris :=  0;

  for i := 0 to ObjectsCount-1 do
  if BoxInFrustum(v_add(obj[i].aabb.Min,pos),v_add(obj[i].aabb.Max,pos)) then
  begin
    inc(drawedtris,obj[i].FACEcount);
    glVertexPointer(3, GL_FLOAT, SizeOf(TVector), @Obj[i].Vertex[0].x);

    glDrawElements(GL_TRIANGLES, Obj[i].FACEcount*3, GL_UNSIGNED_SHORT, @Obj[i].FACE[0]);
  end;


   glDisableClientState(GL_TEXTURE_COORD_ARRAY);
   glDisableClientState(GL_VERTEX_ARRAY);
end;


{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
Procedure T4model.ShaderRender;
var i,c : integer;
begin
c:=-1;

  for i := 0 to ObjectsCount-1 do
//  if BoxInFrustum(obj[i].aabb.Min,obj[i].aabb.max) then
  begin
  if light and not uSphereVsSphere(obj[i].Center, global_light.POS, obj[i].MaxDist,global_light.Radius) then  continue;

       if c <> Obj[i].Materialnum then
       begin
       DisableLastMaterial;
       BindMaterial(Materials[Obj[i].Materialnum].ID,Rendermode);
       c := Obj[i].Materialnum;
       end;
   DrawShaderMesh(obj[i].Shader_mesh);
  end;
DisableMaterials;
      {
  c := -1;
  for i := 0 to ObjectsCount-1 do
  if BoxInFrustum(obj[i].aabb.Mins,obj[i].aabb.maxs) then
  begin
       Mat := GetMaterial(Materials[Obj[i].Materialnum].ID);
       if not (mat^.Blend.Enabled or mat^.UseAlpha) then continue;

       if c <> Obj[i].Materialnum then
       begin
        t := BindMaterial(Materials[Obj[i].Materialnum].ID,Rendermode);
        c := Obj[i].Materialnum;
       end;

   DrawShaderMesh(obj[i].Shader_mesh,t, t <>0);
  end;
DisableMaterials;
       }
end;

function T4model.ADDTexture(FileName:string):Integer;
var
i :integer;
begin
for i := 0 to length(Materials)-1 do
If SameText(Materials[i].Name,FileName) then
  Begin
    result := i;
    exit;
  end;

   i := Length(Materials);
     SetLength(Materials,i+1);
               Materials[i].Name := FileName;
               Materials[i].id   := LoadMatarial(FileName);
  Result := i;

end;

function T4model.DeleteTextures():boolean;
var
i :integer;
begin
for i := 0 to length(Materials)-1 do
      RemoveMaterial(Materials[i].ID);
           SetLength(Materials,0);
end;

Procedure T4Model.MClear;
begin
 Obj       := nil;
 DeleteTextures;
 rTextures := true;
 rLightmaps:= false;
end;
//-----------------------------------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------------------------------
function T4model.LoadFromFile(FileName,TextureDir:string):Boolean;
Procedure CalcLmFactor;
Var Factor : Array [0..4] of single;
i,i2:integer;
begin
For i := 0 to length(obj)-1 do With Obj[i] do
  begin
  SetLength(LMFactor,FaceCount);
  SetLength(FaceSpheres,FaceCount);

        For i2 := 0 to length(FACE)-1 do
        begin
         FaceSpheres[i2] := uSphereFromAABB(FACEBBOXS[i2]);

         Factor[0] := v_length( v_sub(Vertex[Face[i2][1]],Vertex[Face[i2][0]]));
         Factor[1] := v_length( v_sub(Vertex[Face[i2][2]],Vertex[Face[i2][1]]));
         Factor[2] := v_length( v_sub(Vertex[Face[i2][0]],Vertex[Face[i2][2]]));
         Factor[3] := Factor[0] + Factor[1]+ Factor[2];
         //
         Factor[0] := V_Length2d( V_sub2d(LmTEXCOORD[Face[i2][1]], LmTEXCOORD[Face[i2][0]]));
         Factor[1] := V_Length2d( V_sub2d(LmTEXCOORD[Face[i2][2]], LmTEXCOORD[Face[i2][1]]));
         Factor[2] := V_Length2d( V_sub2d(LmTEXCOORD[Face[i2][0]], LmTEXCOORD[Face[i2][2]]));
         Factor[4] := Factor[0] + Factor[1]+ Factor[2];
         LMFactor[i2] := (Factor[4] / Factor[3]);
        end;
  end;
end;

var
I   : Integer;
F   : File of byte;
B   : Byte;
begin
 try
  if NotFileExists(FileName) then exit;

  AssignFile(F,FileName);
  Reset(F);

    BlockRead(F,HEADER ,SizeOf(THeader));

    if HEADER.ID <> id then
    begin CloseFile(F);
       MessageBox('This model not a Model 4 format',1);
    exit;
    end;


    if abs (HEADER.Version - Version) >0 then
    begin CloseFile(F);
       MessageBox(Pchar('Need model 4 version:'+inttostr(version)),1);
    exit;
    end;

    mClear;

    BlockRead(F,ObjectsCount,2);

    setlength(obj,ObjectsCount);
    for i := 0 to ObjectsCount-1 do
    with obj[i] do
    begin
      BlockRead(F,AlphaTest   ,1);
      BlockRead(F,VERTEXcount ,2);
      BlockRead(F,FACEcount   ,2);
      BlockRead(F,TEXCount    ,2);
      BlockRead(F,B,1);
      SetLength(TextureName,B);

      BlockRead(F,TextureName[1],B);

      setlength(FACE      ,FACEcount);
      setlength(Plane     ,FACEcount);
      setlength(Normals   ,FACEcount);
      setlength(VERTEX    ,VERTEXcount);
      setlength(TEXCOORD  ,TEXCount);
      setlength(facebboxs ,FACEcount);

       BlockRead(F,FACE[0][0]          ,sizeof(TUnsignedFACE    )*FACEcount);
       BlockRead(F,Plane[0].Normal.x   ,sizeof(TPlane   )*FACEcount);
       BlockRead(F,VERTEX[0].x         ,sizeof(TVEctor  )*VERTEXcount);
       BlockRead(F,Normals[0].x        ,sizeof(TVEctor  )*FACEcount);
       BlockRead(F,TEXCOORD[0].x       ,sizeof(TVector2d)*TEXCount);
       BlockRead(F,FACEBBOXS[0].MIN.x  ,Sizeof(TAabb    )*FaceCount);
       BlockRead(F,AABB.MIN.x          ,Sizeof(TAAbb    ));
       BlockRead(F,Center              ,SizeOf(TVector));
       BlockRead(F,MaxDist             ,4);
    end;
    BlockRead(F,ModelAABB.MIN.x        ,Sizeof(TAAbb    ));
    CloseFile(F);

//    LoadToARB_VBO;

    for i := 0 to length(obj)-1 do
    with obj[i] do
    begin
          Shader_Mesh := CreateShaderMesh(@Face[0][0],@Vertex[0].x,@TexCoord[0].x,Length(face),Length(Vertex),Length(TexCoord));

         MaterialNum := ADDTexture(TextureDir+TextureName);

    end;
{
    if fileexists(ChangeFileExt(Filename,'.l')) then
    begin
      AssignFile(F, ChangeFileExt(Filename,'.l') );
      Reset(F);
      BlockRead(F,oj   ,sizeof(Word));
      if oj <> ObjectsCount then
               messagebox('This is no light map for this map',1)
               else rLightmaps := True;

      for i := 0 to oj-1 do
      with obj[i] do
      begin
       setlength(  LMTEXCOORD ,TEXCount);
       BlockRead(F,LMTEXCOORD[0].x,sizeof(TVector2D)*TEXCount);
      end;
      CloseFile(F);
      LMTextureNum := ADDTexture(TextureDir+ExtractFileName(ChangeFileExt(Filename,'.tga')) );
      LoadTextureEx( TextureDir+ExtractFileName(ChangeFileExt(Filename,'.jpg')),lmdata.w,lmdata.h,i,lmdata.data);
    CalcLmFactor;
    end;
}
    result := true;
 except
  result:=false;
 end;
end;


function T4model.Collision(var Pos,Normal:TVector; const ADDPOS: TVector; const R: single): boolean;
var
 i, i2  : integer;
 Dist   : single;
 P,ins,
 offset,
 minx,maxx: TVector;

begin

Result := false;
 P := v_sub(POS,addpos);
  dist:=sqrt(2*r*r);
 minx := v_sub(p, vector(dist,dist,dist));;
 maxx := v_add(p, vector(dist,dist,dist));;


for i := 0 to ObjectsCount - 1 do
if uAABBVsAABB(obj[i].aabb.Min,obj[i].aabb.Max,minx,maxx) then
  if V_Dist(obj[i].Center, p) <= obj[i].MaxDist + R then
   with obj[i] do
   for i2 := 0 to FACEcount - 1 do
  if uAABBVsAABB(FACEBBOXS[i2].Min,FACEBBOXS[i2].Max,minx,maxx) then
//if AABBVsSphere(FACEBBOXS[i2].Mins,FACEBBOXS[i2].Maxs,p,r) then

   begin
      P := v_sub(POS,addpos);

    if P_Classify(Plane[i2],p) > 0 then
     begin

     Dist := P_Dist(p, Plane[i2]);
     if Dist < R then
      begin
      offset := V_Mult(Plane[i2].Normal, R - Dist);
      ins    := V_Sub (p, V_Mult(Plane[i2].Normal, Dist));
      if P_InsideTri(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]])
      or
			   EdgeSphereCollision(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]], r*0.5)
          then
       begin
       Pos := V_Add(pos, offset);
       if (abs(P.Y - ins.Y) > (R*0.5)) and (P.Y > ins.Y) then
           Begin
             normal := Plane[i2].Normal;
             Result := true;
           end;
       end;
      end;
     end;
   end;
end;

function T4Model.CollisionAcc(var Pos,Acc:TVector; const ADDPOS: TVector; const R: single): boolean;
var
 i, i2  : integer;
 Dist   : single;
 P,ins,
 offset,
 minx,maxx: TVector;

begin

Result := false;
 P := v_sub(POS,addpos);
  dist:=sqrt(2*r*r);
 minx := v_sub(p, vector(dist,dist,dist));;
 maxx := v_add(p, vector(dist,dist,dist));;


for i := 0 to ObjectsCount - 1 do
if uAABBVsAABB(obj[i].aabb.Min,obj[i].aabb.Max,minx,maxx) then
  if V_Dist(obj[i].Center, p) <= obj[i].MaxDist + R then
   with obj[i] do
   for i2 := 0 to FACEcount - 1 do
  if uAABBVsAABB(FACEBBOXS[i2].Min,FACEBBOXS[i2].Max,minx,maxx) then
//if AABBVsSphere(FACEBBOXS[i2].Mins,FACEBBOXS[i2].Maxs,p,r) then

   begin
      P := v_sub(POS,addpos);

    if P_Classify(Plane[i2],p) > 0 then
     begin

     Dist := P_Dist(p, Plane[i2]);
     if Dist < R then
      begin
      offset := V_Mult(Plane[i2].Normal, R - Dist);
      ins    := V_Sub (p, V_Mult(Plane[i2].Normal, Dist));
      if P_InsideTri(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]])
      or
			   EdgeSphereCollision(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]], r*0.5)
          then
       begin
       Pos := V_Add(pos, offset);
       acc := ChangeAcc(acc,Plane[i2].Normal);
       if (abs(P.Y - ins.Y) > (R*0.5)) and (P.Y > ins.Y) then
       Result := true;
       end;
      end;
     end;
   end;
end;

function T4Model.CollisionAcc2(var Pos,Speed,Acc : TVector; const ADDPOS: TVector; const R: single): boolean;
var
 i, i2  : integer;
 Dist   : single;
 P,NP   : TVector;
 Sph,LBox: TAABB;
 F       : boolean;
 sp,X,X2:TVector;
begin

 P := v_sub(POS,addpos);
 NP:= v_adD(Pos,Speed);

  dist:=sqrt(2*r*r);
 sph.min  := v_sub(p, vector(dist,dist,dist));;
 sph.max  := v_add(p, vector(dist,dist,dist));;
 Lbox.MIN := v_mult(P,1.2);
 Lbox.MAX := v_mult(Np,1.2);
 F:=False;


for i := 0 to ObjectsCount - 1 do
   with obj[i] do
//if uAABBVsAABB(aabb.Mins,aabb.Maxs,lbox.mins,lbox.maxs) then
     for i2 := 0 to FACEcount - 1 do
//     if Plane_Intersection(plane[i2],p,np) then
     if LineVsPolygon2(Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]], P, NP, Plane[i2].Normal, X) then
       begin
        X2 := VAABBMin( X, Pos);
        F := True;
       end;

        SP:=X2;
        if f then
        Pos:=X2 else Pos:=NP;

        Result:=CollisionAcc(POS,ACC,addpos,r);
//        Speed := V_sub(acc,Speed);
        if f then
        Speed:=vector(0,0,0);

end;



{-------------------------------------------------------------------------------}
{-------------------------------------------------------------------------------}
{-------------------------------------------------------------------------------}

function T4model.ElipsoidCollision(var Pos:TVector; const ADDPOS,Radius: TVector): boolean;
var
 i, i2  : integer;
 Dist   : single;
 P,
 minx,maxx: TVector;
 DB : TDistBool;
begin

Result := false;
 P := v_sub(POS,addpos);
  dist:=sqrt(2*Radius.x*Radius.y*Radius.z);
 minx := v_sub(p, vector(dist,dist,dist));;
 maxx := v_add(p, vector(dist,dist,dist));;

for i := 0 to ObjectsCount - 1 do
if uAABBVsAABB(obj[i].aabb.Min,obj[i].aabb.Max,minx,maxx) then
   with obj[i] do
   for i2 := 0 to FACEcount - 1 do

   if uAABBVsAABB(FACEBBOXS[i2].Min,FACEBBOXS[i2].Max,minx,maxx) then
    if P_Classify(Plane[i2],p) > 0 then
      if P_Dist(p, Plane[i2]) < Dist then
     begin
      P := v_sub(POS,addpos);

      db:=CollEllipsToTr(p,radius,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]]);
      if db.Return then
         if (abs(pos.Y - db.Point.Y) > (Radius.y*0.5)) and (pos.Y > db.point.Y) then result := true;
      pos := p;
   end;
end;

function T4model.ElipsoidCollisionACC(var Pos,ACC:TVector; const ADDPOS,Radius: TVector): boolean;
var
 i, i2  : integer;
 Dist   : single;
 P,
 minx,
 maxx   : TVector;
     DB : TDistBool;
begin

Result  := false;
     P  := v_sub(POS,addpos);
   dist := sqrt(2*Radius.x*Radius.y*Radius.z);
   minx := v_sub(p, vector(dist,dist,dist));;
   maxx := v_add(p, vector(dist,dist,dist));;

for i := 0 to ObjectsCount - 1 do with obj[i] do
//if v_dist(Center,pos) < MaxDist+dist then
if uAABBVsAABB(aabb.Min,aabb.Max,minx,maxx) then
   for i2 := 0 to FACEcount - 1 do
//   if v_dist(FaceSpheres[i2].POS,p) < (FaceSpheres[i2].Radius+dist) then
  if uAABBVsAABB(FACEBBOXS[i2].Min,FACEBBOXS[i2].Max,minx,maxx) then
   if P_Classify(Plane[i2],p) > 0 then
         if P_Dist(p, Plane[i2]) < Dist then
         begin
            P  := v_sub(POS,addpos);
            db := CollEllipsToTr(p,radius,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]]);
            if db.Return then
            begin

            if {(abs(pos.Y - db.Point.Y) > (Radius.y*0.5)) and} (p.Y > db.point.Y) and
                  (P_Determine(Plane[i2].Normal) = 2) then
                    begin
                      result := true;
                       acc    := v_identity
                    end
                        else
                      ChangeAcc(acc,Plane[i2].Normal);

            end;
          pos := p;
       end;
end;


function T4Model.ElipsoidCollisionACC2(var Pos,Speed,Acc : TVector; const ADDPOS,Radius: TVector): boolean;
var
 i, i2  : integer;
 P,NP   : TVector;
 F      : boolean;
 X      : TVector;
begin

 P := v_sub(POS,addpos);
 NP:= v_adD(Pos,Speed);
for i := 0 to ObjectsCount - 1 do
   with obj[i] do
     for i2 := 0 to FACEcount - 1 do
     if LineVsPolygon2(Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]], P, NP, Plane[i2].Normal, X) then
       begin
        F  := True;
        Speed:= vector(0,0,0);
           ChangeAcc(acc,Plane[i2].Normal);
       end;

        if f then
        begin
        Pos  := X;
        end
           else Pos:=NP;

            Result := ElipsoidCollisionACC(POS,ACC,addpos,radius);


end;


{-------------------------------------------------------------------------------}
{-------------------------------------------------------------------------------}
{-------------------------------------------------------------------------------}

function T4Model.LineCollisionWithNum(const BP,EP, ADDPOS: TVector;const ObjNum:Integer): boolean;
var i :integer;
p1,p2:tvector;
begin
 P1:= v_sub(bp ,addpos);
 P2:= v_sub(ep ,addpos);
result:=false;
   with obj[objnum] do
   for i := 0 to FACEcount - 1 do
   if LineVsPolygon(Vertex[Face[i, 0]], Vertex[Face[i, 1]],Vertex[Face[i, 2]],p1,p2,plane[i].Normal) then begin result:=true; exit; end;
end;

function T4Model.LineCollision(const BP,EP, ADDPOS: TVector): boolean;
var i :integer;
begin
   result:=false;
   for i := 0 to ObjectsCount - 1 do
   if LineCollisionWithNum(BP,EP,ADDPOS,i) then
   begin result:=true; exit; end;

end;

function T4Model.LineCollisionWithNum2(const BP,EP, ADDPOS: TVector;const ObjNum:Integer): TVector;
var i :integer;
p1,p2,px:tvector;
begin
 P1:= v_sub(bp ,addpos);
 P2:= v_sub(ep ,addpos);
 px:=ep;
   with obj[objnum] do
   for i := 0 to FACEcount - 1 do
   if LineVsPolygon2(Vertex[Face[i, 0]],
                         Vertex[Face[i, 1]],
                         Vertex[Face[i, 2]],p1,p2,plane[i].Normal,px) then;
                         result:=px;

end;

function T4Model.LineCollision2(const BP,EP, ADDPOS: TVector): TVector;
var i,i2 :integer;
p1,p2,px:tvector;
begin
 P1:= v_sub(bp ,addpos);
 P2:= v_sub(ep ,addpos);
 px:=ep;
   for i := 0 to ObjectsCount - 1 do
   with obj[i] do
   for i2 := 0 to FACEcount - 1 do
   if LineVsPolygon2(Vertex[Face[i2, 0]],
                          Vertex[Face[i2, 1]],
                          Vertex[Face[i2, 2]],p1,p2,plane[i].Normal,px) then
                           begin
                             result:=px;
                           exit;
                           end;

end;

function T4model.CollisionWObj(var Pos:TVector;const ADDPOS: TVector; const R: single;const I:integer): boolean;
var
 i2  : integer;
 Dist   : single;
 P,ins,
 offset : TVector;
begin
Result := false;
 P := v_sub(POS,addpos);

if uAABBVsSphere(obj[i].aabb.Min,obj[i].aabb.Max,p,r) then
  if V_Dist(obj[i].Center, p) <= obj[i].MaxDist + R then
   with obj[i] do
   for i2 := 0 to FACEcount - 1 do
   begin
      P := v_sub(POS,addpos);

    if P_Classify(Plane[i2],p) > 0 then
     begin

     Dist := P_Dist(p, Plane[i2]);
     if Dist < R then
      begin
      offset := V_Mult(Plane[i2].Normal, R - Dist);
      ins    := V_Sub (p, V_Mult(Plane[i2].Normal, Dist));
      if P_InsideTri(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]]) or
			   EdgeSphereCollision(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]], r*0.5) then
       begin
       Pos := V_Add(pos, offset);
       if abs(Pos.Y - ins.Y) > R/2 then
       if Pos.Y > ins.Y then
        Result := true;
       end;
      end;
     end;
   end;
end;

function T4model.OnGround(const Pos,ADDPOS: TVector; R: single): boolean;
var
 i, i2  : integer;
 Dist   : single;
 ins,p  : TVector;
 minx,maxx : TVector;
begin
Result := false;

 P := v_sub(POS,addpos);

  dist:=sqrt(2*r*r);
 minx := v_sub(p, vector(dist,dist,dist));;
 maxx := v_add(p, vector(dist,dist,dist));;

for i := 0 to ObjectsCount - 1 do
if uAABBVsAABB(obj[i].aabb.Min,obj[i].aabb.Max,minx,maxx) then
  if V_Dist(obj[i].Center, p) <= obj[i].MaxDist + R then
   with obj[i] do
   for i2 := 0 to FACEcount - 1 do
//   if AABBVsSphere(FACEBBOXS[i2].Mins,FACEBBOXS[i2].Maxs,p,r) then

  if uAABBVsAABB(FACEBBOXS[i2].Min,FACEBBOXS[i2].Max,minx,maxx) then
   begin
      P := v_sub(POS,addpos);

    if P_Classify(Plane[i2],p) > 0 then
     begin

     Dist := P_Dist(p, Plane[i2]);
     if Dist < R then
      begin
      ins    := V_Sub (p, V_Mult(Plane[i2].Normal, Dist));

      if P_InsideTri(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]]) or
			   EdgeSphereCollision(ins,Vertex[Face[i2, 0]],Vertex[Face[i2, 1]],Vertex[Face[i2, 2]], r*0.5) then

       if abs(P.Y - ins.Y) > R/2 then
       if P.Y > ins.Y then
       begin
        Result := true;
        exit;
       end;
      end;
     end;
   end;
end;


end.
