unit Engine;
(**************
 *Engine2 0.5 *
 *************
 Made by : SVSD_VAL
 Site    : http://svsd.mirgames.ru
 mail    : Valdim_05@mail.ru or SVSD_VAL@SibNet.ru
 ICQ     : 223-725-915
 Jabber  : svsd_val@jabber.ru or svsd_val@Jabber.Sibnet.ru
*)

Interface

uses Windows,OpenGL15,directsound9,mmsystem;

{$Region 'Project Constants'}
const
  PrjName = 'Maximum Carnage';
{$EndRegion}

{$REGION 'System Referenct'}
const
  M_BTN_L = 0;
  M_BTN_R = 1;
  M_BTN_M = 2;
  M_BTN_D = 2;

type
  TRGB = record
    R, G, B : Byte;
  end;

  TRGBA = record
    R, G, B, A : Byte;
  end;

  TRenderMode = (RENDER_CASTER, RENDER_SHADOW, RENDER_ILLUM);

  TRGBArray = array [0..9] of TRGB;
  PRGBArray = ^TRGBArray;

  TRGBAArray = array [0..9] of TRGBA;
  PRGBAArray = ^TRGBAArray;

  TByteArray = array [0..9] of Byte;
  PByteArray = ^TByteArray;

  TWordArray = array [0..9] of Word;
  PWordArray = ^TWordArray;

  TPointerArray = array [0..9] of Pointer;
  PPointerArray = ^TPointerArray;

  TStrParam  = Array of String;
var
  GL_USE_SHADER : BOOLEAN = true;
  GL_SHADER_TANGENT,
  GL_SHADER_BINORMAL : Cardinal;
  GL_FOV             : Single;

{$ENDREGION}

{$REGION 'Math Reference'}
const
  deg2rad = pi / 180;
  rad2deg = 180 / pi;
  GENERATE_MIPMAP_SGIS = $8191;

type

  TUnsignedFace       = Array [0..2] of Word;
  TSignedFace         = Array [0..2] of Integer;

  PUnsignedFaceArray  = ^TUnsignedFaceArray;
  TUnsignedFaceArray  = Array [0..1] of TUnsignedFace;

  PSignedFaceArray    = ^TSignedFaceArray;
  TSignedFaceArray    = Array [0..1]  of TsignedFace;

  PVector2D = ^TVector2d;
  TVector2D = record
    case byte of
     0 :(x,y : Single);
     1 :(XY:Array [0..1] of single);
  end;

  TVec3ub = record
    x, y, z : Byte;
  end;

  PVector = ^TVector;
  TVector = record
    class operator Equal(v1, v2: TVector): Boolean; inline;
    class operator Add(v1, v2: TVector): TVector;
    class operator Subtract(v1, v2: TVector): TVector;
    class operator Multiply(v: TVector; x: Single): TVector;
    class operator Multiply(v1, v2: TVector): TVector;
    class operator Divide(v: TVector; x: Single): TVector;
    class operator Divide(v1, v2: TVector): TVector;
    function  Lerp(v: TVector; t: Single): TVector; inline;
    function  Dot(v: TVector): Single; inline;
    function  Cross(v: TVector): TVector;
    function  Normal: TVector;
    procedure Normalize;
    function  Length: Single;
    function  LengthQ: Single; inline;
    function  Angle(v: TVector): Single; inline;
    Procedure Clear;
    case byte of
     0 :(x, y, z : Single);
     1 :(XYZ:Array [0..2] of single);

  end;

  TVector4f = record
//     x, y, z, w : Single;
    class operator Add(v1, v2: TVector4f): TVector4f;
    class operator Subtract(v1, v2: TVector4f): TVector4f;
    class operator Multiply(v: TVector4f; x: Single): TVector4f;
    function Dot(v: TVector4f): Single;
    function Lerp(v: TVector4f; t: Single): TVector4f;
    function SLerp(v: TVector4f; t: Single): TVector4f;
    procedure Normalize;
    function Length: Single;
    procedure FromVecAngle(v: TVector; Angle: Single);
    Procedure FromAngles(angles:TVector);
    case byte of
     0 :(x, y, z, w : Single);
     1 :(XYZW:Array [0..3] of single);
  end;

  TMat4f = record
    class operator Multiply(m: TMat4f; v: TVector): TVector;
    class operator Multiply(a, b: TMat4f): TMat4f;
    procedure Identity;
    function  Det: Single; inline;
    function  Inverse: TMat4f; inline;
    procedure SetRot(v: TVector4f); inline;
    procedure SetPos(v: TVector); inline;
    case Integer of
      0: (cell : array [0..3, 0..3] of Single);
      1: (e00, e01, e02, e03,
          e10, e11, e12, e13,
          e20, e21, e22, e23,
          e30, e31, e32, e33: Single);
      2: (row: array [0..3] of TVector4f);
  end;

  TAABB = Record
    Min,Max : TVector;
  end;

  TSingleArray = array [0..1] of Single;
  PSingleArray = ^TSingleArray;

  TVector2DArray = array [0..1] of TVector2D;
  PVector2DArray = ^TVector2DArray;


  TVec3ubArray = array [0..1] of TVec3ub;
  PVec3ubArray = ^TVec3ubArray;

  TVectorArray = array [0..1] of TVector;
  PVectorArray = ^TVectorArray;

  TVector4fArray = array [0..1] of TVector4f;
  PVector4fArray = ^TVector4fArray;


const
  V_Identity  : TVector         = (x:0;y:0;z:0);

  function Min(x, y: Integer): Integer; overload;
  function Max(x, y: Integer): Integer; overload;
  function Min(x, y: Single): Single; overload;
  function Max(x, y: Single): Single; overload;
  function Sign(x: Single): Integer;

  Function Vec4f(X:Single=0;Y:Single=0;Z:Single=0;W:Single=0):TVector4f;
  function Vec3f(x, y, z: Single): TVector;
  function Vec2f(x, y: Single): TVector2D;

  function ArcTan2(const Y, X: Single): Single;
  function ArcCos(const X: Single): Single;
{$ENDREGION}

{$Region 'Direct X Sound'}
type
 //   
 PSample = ^TSample;
 TSample = record
  ID       : integer;
  Next     : PSample;
  flag     : boolean;
  FileName : string;
  buffer   : IDirectSoundBuffer;
 end;

 TChannel = record
  Smp_ID   : integer;
  Time     : DWORD;
  Pos      : TVector;
  Buffer   : IDirectSoundBuffer;
  Buffer3D : IDirectSound3DBuffer;
 end;

 TDXSound = Class
  Private
   snd_initialized : boolean;
   snd_Samples     : integer;
   snd_Channels    : integer;
   snd_Playing     : integer;
   snd_volume      : integer;
   snd_off         : boolean;
   snd_Dist        : Single;
   h_Wnd           : HWND;

   //   
   ids   : IDirectSound;
   //  
   idsbp : IDirectSoundBuffer;
   // 
   idsl  : IDirectSound3DListener;

   //  - 
   MaxChannels : integer;
   // 
   Sample  : PSample;
   Channel : array of TChannel;
   nID     : integer;
   function  GetSample            (ID: integer): PSample;
   function  snd_ChannelExists    (Channel_ID: integer): boolean;
   function  LoadFromWAV          (Sample: PSample; FileName: string): boolean;
//   function  LoadFromStream       (Sample: PSample; Stream: TStream): boolean;
  Public
   function  snd_Init(WND:HWND): boolean;                                                    stdcall;
   procedure snd_deInit;                                                                     stdcall;
   function  snd_Load             (const FileName: string): integer;                         stdcall;
//   function  snd_LoadFromStream   (Stream:TStream): integer;                                 stdcall;
   function  snd_Free             (Sample_ID: integer): boolean;
   procedure snd_BeginUpdate;
   procedure snd_EndUpdate;                                                                  stdcall;
   function  snd_Play             (Sample_ID: integer; Loop: boolean; Pos: TVector): integer;stdcall;
   function  snd_Stop             (var Channel_ID: integer): boolean;                        stdcall;
   procedure snd_StopAll          (Sound_ID: integer);                                       stdcall;
   function  snd_SetVolume        (Channel_ID: integer; Volume: integer): boolean;           stdcall;
   function  snd_SetPos           (Channel_ID: integer; Pos: TVector): boolean;              stdcall;
   function  snd_SetFreq          (Channel_ID: integer; Freq: DWORD): boolean;               stdcall;
   procedure snd_SetVelocity      (Channel_ID: integer; Pos: TVector);                       stdcall;
   procedure snd_SetOrientation   (front, top: TVector);                                     stdcall;
   procedure snd_SetDopplerFactor (factor: single);                                          stdcall;
   procedure snd_SetRolloffFactor (factor: single);                                          stdcall;
   procedure snd_SetDistanceFactor(Dst   : single);                                          stdcall;
   procedure snd_SetGlobalPos     (Pos: TVector);                                            stdcall;
   procedure snd_SetGlobalVelocity(V: TVector);                                              stdcall;
   procedure snd_Update;                                                                     stdcall;
end;

{$EndRegion}

{$Region 'Graphic Shader'}
Type
  GLHandleARB = Integer;
  PShader = ^TShader;
  TShader = object
  private
    sh       : GLHandleARB;
    shaders  : array of GLHandleARB;
    Procedure SetUniformV(uniform:Cardinal; value:PGLFloat; Size:byte);
    Procedure SetAttribV (uniform:Cardinal; value:PGLFloat; Size:byte);
    function  CheckForErrors(glObject: GLHandleARB): String;
  public
    Tangent,
    Binormal  : Cardinal;
    procedure Load(Filename: string; Shader_Type: Glenum;Define:String='');
    Function  Compile : boolean;
    procedure Start;
    procedure Stop;
    procedure Free;
    function  GetInfoLog: string;
    function  GetUniform(uniform: PChar): GLuint;
    function  GetAttrib(attrib: PChar): GLuint;
    procedure SetUniform(uniform: GLuint; value0: Single); overload;
    procedure SetUniform(uniform: GLuint; value0: Integer); overload;
    procedure SetUniform(uniform: GLuint; value0, value1: Single); overload;
    procedure SetUniform(uniform: GLuint; value0, value1, value2: Single); overload;
    procedure SetUniform(uniform: GLuint; value0, value1, value2, value3: Single); overload;

    procedure SetAttrib (uniform: GLuint; value0 : Single); overload;
    procedure SetAttrib (uniform: GLuint; value0, value1 : Single); overload;
    procedure SetAttrib (uniform: GLuint; value0, value1, value2: Single); overload;
    procedure SetAttrib (uniform: GLuint; value0, value1, value2,value3: Single); overload;
    procedure BindUniform(uniform:GLuint; Value: PGLFLoat; size:byte); overload;
    procedure BindUniform(const name:string; Value: PGLFLoat; size:byte); overload;
    procedure BindAttrib(uniform:GLuint; Value: PGLFLoat; size:Byte); overload;
    procedure BindAttrib(const name:string; Value: PGLFLoat; size:byte); overload;
  end;

  TShadersList = OBJECT
  private
    Shaders  : array of Record
        shader : PShader;
        Frag,Vert:String;
    end;
  public
    ShaderDir: String;
    Function Add(Fragment,Vertex: string):Integer;
    procedure Start(Shader:Cardinal);
    procedure Stop;
    procedure ShaderFree(Shader:Cardinal);
    procedure FreeAll();
    function  GetShader(Shader:Cardinal): PShader;
    function  GetInfoLog(Shader:Cardinal): string;
    function  GetUniform(Shader:Cardinal; uniform: PChar): GLuint;
    function  GetAttrib(Shader:Cardinal; attrib: PChar): GLuint;
    procedure SetUniform(Shader:Cardinal; uniform: GLuint; value0: Single); overload;
    procedure SetUniform(Shader:Cardinal; uniform: GLuint; value0: Integer); overload;
    procedure SetUniform(Shader:Cardinal; uniform: GLuint; value0, value1: Single); overload;
    procedure SetUniform(Shader:Cardinal; uniform: GLuint; value0, value1, value2: Single); overload;
    procedure SetUniform(Shader:Cardinal; uniform: GLuint; value0, value1, value2, value3: Single); overload;

    procedure SetAttrib (Shader:Cardinal; uniform: GLuint; value0 : Single); overload;
    procedure SetAttrib (Shader:Cardinal; uniform: GLuint; value0, value1 : Single); overload;
    procedure SetAttrib (Shader:Cardinal; uniform: GLuint; value0, value1, value2: Single); overload;
    procedure SetAttrib (Shader:Cardinal; uniform: GLuint; value0, value1, value2,value3: Single); overload;
    procedure BindUniform(Shader:Cardinal; uniform:GLuint; Value: PGLFLoat; size:byte); overload;
    procedure BindUniform(Shader:Cardinal; const name:string; Value: PGLFLoat; size:byte); overload;
    procedure BindAttrib(Shader:Cardinal; uniform:GLuint; Value: PGLFLoat; size:Byte); overload;
    procedure BindAttrib(Shader:Cardinal; const name:string; Value: PGLFLoat; size:byte); overload;
  end;

{$ENDREGION}

{$Region 'Graphic -> Fonts'}
 function FontCreate(handle:LongWord; Name: PChar; Size,Tex_Size: Integer): Cardinal;
 procedure TextOut(Font:Cardinal; Size, x,y : Single ; str:string);
{$ENDREGION}

{$Region 'Graphic -> Frustum'}
Type
	TFrustum = array [0..5] of array [0..3] of single;
var
  	Frustum	: TFrustum;

    Procedure NormalizePlane(var frustum : tfrustum; side : integer);
    Procedure CalculateFrustum;
    function  PointInFrustum ( V:TVector) : BOOLEAN;

    function  SphereInFrustum( V:TVector; radius : single) : boolean;
    function  CubeInFrustum  ( V:TVector; size : single) : boolean;
    function  BoxInFrustum   ( Min,Max:TVector) : boolean;

{$EndRegion}

{$Region 'Graphic -> Projection'}
  Procedure ChangeFov(W,H,FOV:Single);
  Procedure SetProjection(W, H: Single; Ortho: boolean);
 {$EndRegion}

{$Region 'Graphic -> PixelBuffer'}
type
 TPixelBuffer = class
  public
   DC        : HDC;
   RC        : HGLRC;
   ParentDC  : HDC;
   ParentRC  : HGLRC;
   Handle    : TGLUInt;
   Width     : TGLUInt;
   Height    : TGLUInt;
   TextureID : TGLUInt;
   function IsLost : Boolean;
   procedure Enable;
   procedure Disable;
   procedure Bind;
   procedure Release;
   constructor Create(pWidth, pHeight : Integer;pParentDC, pParentRC : Cardinal); reintroduce;
   destructor Destroy; override;
  end;
{$EndRegion}

{$Region 'Graphic -> Render Mesh'}
 P3DObject = ^T3DObject;

 T3DObject = record
             AABB            : TAABB;
             FaceCount,
             VertexCount,
             TexCoordCount   : Integer;

             Faces           : Array of TUnsignedFace;

             Vertex,
             Normal          : Array of TVector;

             TexCoord        : Array of TVector2D;
             Shader_Tangent,
             Shader_Binormal,
             Shader_Normal   : Array of TVector;

             Matrix          : TMat4f;
              Procedure ReconstructModel(AndTexCoords:Boolean);
              procedure CalcNormals;
              procedure AdjustNormals;
             end;



procedure DrawShaderMesh(theObject: P3DObject);
procedure RenderShaderModel(Vertex_Count, Face_Type,Attrib_tangent:Cardinal; Face_array, Vertex_Array,Normal_Array,Tangent_Array, Texture0_Array :Pointer; Texture1_Array :Pointer=nil;Texture2_Array :Pointer=nil;Texture3_Array :Pointer=nil);
function  CreateShaderMesh(FaceArray:PUnsignedFaceArray; VertexArray: PVectorArray; TexCoordArray:PVector2DArray;
                           Face_Count, Vertex_Count, TexCoord_Count:Cardinal): P3DObject;
Procedure CalcAABB(Vec3f:PVectorArray; const VecCount:cardinal; var AABB:TAABB);
{$EndRegion}

{$Region 'The Game System Utilites'}
Function MessageBox(S:String; _Type:byte):boolean;
Function NotFileExists(S:String):boolean;
function FileExists(FileName: string): boolean;
function AnsiUpperCase(const S: string): string;
function ExtractFilePath(const s: string): string;
function ExtractFileName(const s: string): string;
function TrimLeft(const S: string): string;
function StrToIntDef(const S: string; Default: Integer): Integer;
function IntToStr(Num : Integer) : String;
function StrToInt(const S: string): Integer;
function CompareMem(P1, P2: Pointer; Length: Integer): Boolean; assembler;
Function SameText(A,B:String):Boolean;
Function ParseStr(cmd: string):TStrParam;
function ChangeFileExt(const FileName, Extension: string): string;
function GetFileExt(const FileName: string): string;

{$ENDREGION}

{$Region 'Game Graphic Lighting'}
Type
  TLight = Record
    POS, Color : TVector;
    Radius : Single;
  end;

var
    Global_Light : TLight;
{$endRegion}

Implementation

uses materials,textures,l_math;

{$REGION 'Math Reference'}
function Min(x, y: Integer): Integer;
begin
  if x < y then
    Result := x
  else
    Result := y;
end;

function Max(x, y: Integer): Integer;
begin
  if x > y then
    Result := x
  else
    Result := y;
end;

function Max(x, y: Single): Single;
begin
  if x > y then
    Result := x
  else
    Result := y;
end;

function Min(x, y: Single): Single;
begin
  if x < y then
    Result := x
  else
    Result := y;
end;

Function Vec4f(X:Single=0;Y:Single=0;Z:Single=0;W:Single=0):TVector4f;
begin
  Result.x := x;
  Result.y := y;
  Result.z := z;
  Result.w := w;
end;

function Vec3f(x, y, z: Single): TVector;
begin
  Result.x := x;
  Result.y := y;
  Result.z := z;
end;

function Vec2f(x, y: Single): TVector2D;
begin
  Result.x := x;
  Result.y := y;
end;

function Sign(x: Single): Integer;
begin
  if x < 0 then
    Result := -1
  else
    if x > 0 then
      Result := 1
    else
      Result := 0;
end;

function ArcTan2(const Y, X: Single): Single;
asm
  FLD     Y
  FLD     X
  FPATAN
  FWAIT
end;

function ArcCos(const X: Single): Single;
begin
  if abs(X) > 1 then
    Result := 0
  else
    Result := ArcTan2(Sqrt(1 - X * X), X);
end;

{$REGION 'TVector'}

class operator TVector.Equal(v1, v2: TVector): Boolean;
begin
  Result := (v1.X = v2.X) and (v1.Y = v2.Y) and (v1.Z = v2.Z);
end;

class operator TVector.Add(v1, v2: TVector): TVector;
begin
  Result.X := v1.X + v2.X;
  Result.Y := v1.Y + v2.Y;
  Result.Z := v1.Z + v2.Z;
end;

class operator TVector.Subtract(v1, v2: TVector): TVector;
begin
  Result.X := v1.X - v2.X;
  Result.Y := v1.Y - v2.Y;
  Result.Z := v1.Z - v2.Z;
end;

class operator TVector.Multiply(v: TVector; x: Single): TVector;
begin
  Result.X := v.X * x;
  Result.Y := v.Y * x;
  Result.Z := v.Z * x;
end;

class operator TVector.Multiply(v1, v2: TVector): TVector;
begin
{
  Result.X := v1.Y * v2.Z - v1.Z * v2.Y;
  Result.Y := v1.Z * v2.X - v1.X * v2.Z;
  Result.Z := v1.X * v2.Y - v1.Y * v2.X;     }

  Result.X := v1.X * v2.X;
  Result.Y := v1.Y * v2.Y;
  Result.Z := v1.Z * v2.Z;
end;

class operator TVector.Divide(v: TVector; x: Single): TVector;
begin

  x := 1/x;
  Result.X := v.X * x;
  Result.Y := v.Y * x;
  Result.Z := v.Z * x;
end;

class operator TVector.Divide(v1, v2: TVector): TVector;
begin
  Result.X := v1.X / v2.X;
  Result.Y := v1.Y / v2.Y;
  Result.Z := v1.Z / v2.Z;
end;


function TVector.Lerp(v: TVector; t: Single): TVector;
begin
  Result := Self + (v - Self) * t;
end;

function TVector.Dot(v: TVector): Single;
begin
  Result := X * v.X + Y * v.Y + Z * v.Z;
end;

function TVector.Cross(v: TVector): TVector;
begin
  Result.X := Y * v.Z - Z * v.Y;
  Result.Y := Z * v.X - X * v.Z;
  Result.Z := X * v.Y - Y * v.X;
end;

function TVector.Normal: TVector;
var
  len : Single;
begin
  len := Length;
  if len <> 0 then
    Result := Self * (1/len)
  else
    Result := Vec3f(0, 0, 0);
end;

procedure TVector.Normalize;
begin
  Self := Normal;
end;

function TVector.Length: Single;
begin
  Result := sqrt(LengthQ);
end;

function TVector.LengthQ: Single;
begin
  Result := sqr(X) + sqr(Y) + sqr(Z);
end;

function TVector.Angle(v: TVector): Single;
begin
  Result := ArcCos(Dot(v) * (1/(Length * v.Length)));
end;

Procedure TVector.Clear;
asm
  XOR EDX, EDX
  MOV [EAX], EDX
  MOV [EAX+4], EDX
  MOV [EAX+8], EDX
end;
{$ENDREGION}

{$REGION 'TVector4f'}
class operator TVector4f.Add(v1, v2: TVector4f): TVector4f;
begin
  Result.x := v1.x + v2.x;
  Result.y := v1.y + v2.y;
  Result.z := v1.z + v2.z;
  Result.w := v1.w + v2.w;
end;

class operator TVector4f.Subtract(v1, v2: TVector4f): TVector4f;
begin
  Result.x := v1.x - v2.x;
  Result.y := v1.y - v2.y;
  Result.z := v1.z - v2.z;
  Result.w := v1.w - v2.w;
end;

class operator TVector4f.Multiply(v: TVector4f; x: Single): TVector4f;
begin
  Result.x := v.x * x;
  Result.y := v.y * x;
  Result.z := v.z * x;
  Result.w := v.w * x;
end;

function TVector4f.Dot(v: TVector4f): Single;
begin
  Result := x * v.x + y * v.y + z * v.z + w * v.w;
end;

function TVector4f.Lerp(v: TVector4f; t: Single): TVector4f;
begin
  if Dot(v) < 0 then
    Result := Self - (v + Self) * t
  else
    Result := Self + (v - Self) * t;
end;

function TVector4f.SLerp(v: TVector4f; t: Single): TVector4f;
var
  omega, d, sinom, scale0, scale1 : Single;
begin
  d := Dot(v);
  if d < 0 then
  begin
    v := v * -1;
    d := -d;
  end;

  if  1 - d > 0 then
  begin
    omega  := ArcCos(d);
    sinom  := 1 / sin(omega);
    scale0 := sin((1 - t) * omega) * sinom;
    scale1 := sin(t * omega) * sinom;
  end else
  begin
    scale0 := 1 - t;
    scale1 := t;
  end;

  Result := (Self * scale0 + v * scale1);
end;

procedure TVector4f.Normalize;
var
  len : Single;
begin
  len := 1 / Length;
  x := x * len;
  y := y * len;
  z := z * len;
  w := w * len;
end;

function TVector4f.Length: Single;
begin
  Result := sqrt(sqr(x) + sqr(y) + sqr(z) + sqr(w));
end;

procedure TVector4f.FromVecAngle(v: TVector; Angle: Single);
var
  s : Single;
begin
  Angle := Angle * 0.5;
  v.Normalize;
  s := sin(Angle);
  x := v.x * s;
  y := v.y * s;
  z := v.z * s;
  w := cos(Angle);
end;


Procedure TVector4f.FromAngles(angles:TVector);

var angle             : single;
    sr,sp,sy,cr,cp,cy : single;
    crcp,srsp         : single;

begin
     angle:=angles.z*0.5;
     sy:=sin( angle );
     cy:=cos( angle );
     angle:= angles.y*0.5;
     sp:= sin( angle );
     cp:= cos( angle );
     angle:= angles.x*0.5;
     sr:= sin( angle );
     cr:= cos( angle );

     crcp:= cr*cp;
     srsp:= sr*sp;

     x:=sr*cp*cy-cr*sp*sy;
     y:=cr*sp*cy-sr*cp*sy;
     z:=crcp*sy -srsp*cy;
     w:=crcp*cy +srsp*sy;
end;

{$ENDREGION}

{$REGION 'TMat4f'}
class operator TMat4f.Multiply(m: TMat4f; v: TVector): TVector;
begin
  with m do
    Result := Vec3f(e00 * v.X + e10 * v.Y + e20 * v.Z + e30,
                    e01 * v.X + e11 * v.Y + e21 * v.Z + e31,
                    e02 * v.X + e12 * v.Y + e22 * v.Z + e32);
end;

class operator TMat4f.Multiply(a, b: TMat4f): TMat4f;
begin
  with Result do
  begin
    e00 := a.e00 * b.e00 + a.e01 * b.e10 + a.e02 * b.e20 + a.e03 * b.e30;
    e10 := a.e10 * b.e00 + a.e11 * b.e10 + a.e12 * b.e20 + a.e13 * b.e30;
    e20 := a.e20 * b.e00 + a.e21 * b.e10 + a.e22 * b.e20 + a.e23 * b.e30;
    e30 := a.e30 * b.e00 + a.e31 * b.e10 + a.e32 * b.e20 + a.e33 * b.e30;
    e01 := a.e00 * b.e01 + a.e01 * b.e11 + a.e02 * b.e21 + a.e03 * b.e31;
    e11 := a.e10 * b.e01 + a.e11 * b.e11 + a.e12 * b.e21 + a.e13 * b.e31;
    e21 := a.e20 * b.e01 + a.e21 * b.e11 + a.e22 * b.e21 + a.e23 * b.e31;
    e31 := a.e30 * b.e01 + a.e31 * b.e11 + a.e32 * b.e21 + a.e33 * b.e31;
    e02 := a.e00 * b.e02 + a.e01 * b.e12 + a.e02 * b.e22 + a.e03 * b.e32;
    e12 := a.e10 * b.e02 + a.e11 * b.e12 + a.e12 * b.e22 + a.e13 * b.e32;
    e22 := a.e20 * b.e02 + a.e21 * b.e12 + a.e22 * b.e22 + a.e23 * b.e32;
    e32 := a.e30 * b.e02 + a.e31 * b.e12 + a.e32 * b.e22 + a.e33 * b.e32;
    e03 := a.e00 * b.e03 + a.e01 * b.e13 + a.e02 * b.e23 + a.e03 * b.e33;
    e13 := a.e10 * b.e03 + a.e11 * b.e13 + a.e12 * b.e23 + a.e13 * b.e33;
    e23 := a.e20 * b.e03 + a.e21 * b.e13 + a.e22 * b.e23 + a.e23 * b.e33;
    e33 := a.e30 * b.e03 + a.e31 * b.e13 + a.e32 * b.e23 + a.e33 * b.e33;
  end;
end;

procedure TMat4f.Identity;
var
  i: Integer;
begin
  ZeroMemory(@Self, SizeOf(TMat4f));
  for i := 0 to 3 do
    cell[i, i] := 1;
end;

function TMat4f.Det: Single;
begin
  Result := e00 * e11 * e22 + e10 * e21 * e02 + e20 * e01 * e12 -
            e20 * e11 * e02 - e10 * e01 * e22 - e00 * e21 * e12;
end;

function TMat4f.Inverse: TMat4f;
var
  D : Single;
begin
  D := 1 / Det;
  Result.e00 :=  (e11 * e22 - e21 * e12) * D;
  Result.e01 := -(e01 * e22 - e21 * e02) * D;
  Result.e02 :=  (e01 * e12 - e11 * e02) * D;
  Result.e03 := 0;
  Result.e10 := -(e10 * e22 - e20 * e12) * D;
  Result.e11 :=  (e00 * e22 - e20 * e02) * D;
  Result.e12 := -(e00 * e12 - e10 * e02) * D;
  Result.e13 := 0;
  Result.e20 :=  (e10 * e21 - e20 * e11) * D;
  Result.e21 := -(e00 * e21 - e20 * e01) * D;
  Result.e22 :=  (e00 * e11 - e10 * e01) * D;
  Result.e23 := 0;
  Result.e30 := -(e30 * Result.e00 + e31 * Result.e10 + e32 * Result.e20);
  Result.e31 := -(e30 * Result.e01 + e31 * Result.e11 + e32 * Result.e21);
  Result.e32 := -(e30 * Result.e02 + e31 * Result.e12 + e32 * Result.e22);
  Result.e33 := 1;
end;

procedure TMat4f.SetRot(v: TVector4f);
var
  wx, wy, wz, xx, yy, yz, xy, xz, zz, x2, y2, z2 : single;
begin
  with v do
  begin
    x2 := x + x;   y2 := y + y;   z2 := z + z;
    xx := x * x2;  xy := x * y2;  xz := x * z2;
    yy := y * y2;  yz := y * z2;  zz := z * z2;
    wx := w * x2;  wy := w * y2;  wz := w * z2;
  end;

  e00 := 1 - (yy + zz);  e10 := xy + wz;        e20 := xz - wy;
  e01 := xy - wz;        e11 := 1 - (xx + zz);  e21 := yz + wx;
  e02 := xz + wy;        e12 := yz - wx;        e22 := 1 - (xx + yy);

  e30 := 0;
  e31 := 0;
  e32 := 0;
  e03 := 0;
  e13 := 0;
  e23 := 0;
  e33 := 1;
end;

procedure TMat4f.SetPos(v: TVector);
begin
  e30 := v.X;
  e31 := v.Y;
  e32 := v.Z;
  e33 := 1;
end;
{$ENDREGION}
{$EndRegion}

{$Region 'Direct X Sound'}
function TDXSound.GetSample(ID: integer): PSample;
var
 p : PSample;
begin
p := Sample;
while p <> nil do
 if p^.ID = ID then
  break
 else
  p := p^.Next;
Result := p;
end;

function TDXSound.snd_ChannelExists(Channel_ID: integer): boolean;
begin
if (not snd_initialized) or
   (Channel_ID < 0) or
   (Channel_ID >= MaxChannels) or
   (Channel[Channel_ID].Buffer = nil) then
 Result := false
else
 Result := true;
end;

////   *.wav  ///////////////////////////
function TDXSound.LoadFromWAV(Sample: PSample; FileName: string): boolean;
var
 F : File;
 a : array [1..4] of Char;

 audio1, audio2 : Pointer;
 audiosize1, audiosize2 : DWORD;
 hr : HResult;

 bufferdesc   : TDSBufferDesc;
 waveformat   : TWaveFormatEx;
 wavedatasize : Longint;
begin
Result := false;

if notFileExists(FileName) then Exit;
//     RIFF 
AssignFile(F, FileName);
Reset(F, 1);
BlockRead(F, a, 4);
if a <> 'RIFF' then
 begin
 CloseFile(F);
 Exit;
 end;

// skip some RIFF header data
Seek(F, 8);

// check next chunk in file to be a WAVE file
BlockRead(F, a, 4);
if a <> 'WAVE' then
 begin
 CloseFile(F);
 Exit;
 end;
Seek(F, 20);

// read in some properties of the wave data in the file
with waveformat do
 begin
 // skip first bytes of WAVE header
 BlockRead(F, waveformat, SizeOf(waveformat));
 nBlockAlign     := wBitsPerSample div 8 * nChannels;
 nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
 end;

//     :)
if waveformat.wBitsPerSample < 8 then
 begin
 CloseFile(F);
 Exit;
 end;

While AnsiUpperCase(a) <> 'DATA' do  //   (       40    52...       )
begin
Seek(F,filepos(f)-3 );
BlockRead(F, a, 4);
end;


//    
BlockRead(F, wavedatasize, 4);

//    
FillChar(bufferdesc, SizeOf(bufferdesc), 0);
with bufferdesc do
 begin
 Size := sizeof(bufferdesc);
 Flags :=

 DSBCAPS_CTRL3D or DSBCAPS_GLOBALFOCUS OR DSBCAPS_CTRLFREQUENCY OR DSBCAPS_GETCURRENTPOSITION2 OR DSBCAPS_CTRLVOLUME;
 {DSBCAPS_STATIC};

 BufferBytes := wavedatasize;
 WaveFormatEx := @waveformat;
 end;

//      :)
hr := ids.CreateSoundBuffer(bufferdesc, Sample^.buffer, nil);
if hr < DS_OK then
 begin
 CloseFile(F);
 Exit;
 end;
audio2     := nil;
audiosize2 := 0;
// 
hr := Sample^.buffer.Lock(0, 0,
                          audio1,
                          audiosize1,
                          audio2,
                          audiosize2,
                          DSBLOCK_ENTIREBUFFER);
if hr < DS_OK then
 begin
 CloseFile(F);
 Exit;
 end;

// 
BlockRead(F, audio1^, wavedatasize);
CloseFile(F);

// 
if Sample^.buffer.Unlock(audio1, audiosize1, audio2, audiosize2) < DS_OK then
 Exit;

Result := true;
end;

/////////  //////////
function TDXSound.snd_Init(WND:HWND): boolean;
var
 dsbufferdesc : TDSBufferDesc;
 waveformat   : TWaveFormatEx;
begin
Result := false;
if snd_initialized then Exit;
snd_initialized := false;

H_WND := WND;
//   
if not DirectSoundCreate(nil, ids, nil) <> DS_OK then
 Exit;

snd_Dist:=0.001;
snd_volume:=255;
ids.SetCooperativeLevel(h_Wnd, DSSCL_EXCLUSIVE);

FillChar(dsbufferdesc, sizeof(dsbufferdesc), 0);
with dsbufferdesc do
 begin
 Size         := sizeof(dsbufferdesc);
 Flags        := DSBCAPS_CTRL3D or DSBCAPS_PRIMARYBUFFER or DSBCAPS_LOCSOFTWARE;
 BufferBytes  := 0;
 Reserved     := 0;
 WaveFormatEx := nil;
 end;

if not ids.CreateSoundBuffer(dsbufferdesc, idsbp, nil) <> DS_OK then
 Exit;

//   
with waveformat do
 begin
 wFormatTag      := WAVE_FORMAT_PCM;
 nChannels       := 2;
 nSamplesPerSec  := 44100;
 wBitsPerSample  := 16;
 nBlockAlign     := 2;
 nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
 end;


 if Not idsbp.Play(0, 0, DSBPLAY_LOOPING) <> DS_OK then
 Exit;

if idsbp.QueryInterface(IID_IDirectSound3DListener,
                        idsl) = DS_OK then
 begin
 idsl.SetDistanceFactor(1, DS3D_DEFERRED);
 idsl.SetRolloffFactor (0.05, DS3D_DEFERRED);
 idsl.SetOrientation   (0, 1, 0, 0, 0, 1, DS3D_DEFERRED);



 idsl.CommitDeferredSettings;

 end;

Sample := nil;
nID    := 0;

snd_Samples := 0;
MaxChannels := 32;
SetLength(Channel, MaxChannels);

Result := true;
snd_initialized := true;
end;

procedure TDXSound.snd_deInit;
var
 i : integer;
 p : PSample;
begin
for i := 0 to MaxChannels - 1 do
 begin
 Channel[i].Buffer   := nil;
 Channel[i].Buffer3D := nil;
 Channel[i].Smp_ID   := -1;
 end;

p := Sample;
while p <> nil do
 begin
 p^.buffer := nil;
 p         := p^.Next;
 end;

snd_Samples := 0;
Sample := nil;
idsbp  := nil;
//ids    := nil;
end;

function TDXSound.snd_Free(Sample_ID: integer): boolean;
var
 tmp, p : PSample;
 i      : integer;
begin
Result := false;
if not snd_initialized then Exit;

tmp := GetSample(Sample_ID);
if tmp = nil then
 Exit;

for i := 0 to MaxChannels - 1 do
 if Channel[i].Smp_ID = tmp^.ID then
  with Channel[i] do
   begin
   if Buffer <> nil then
    Buffer.Stop;
   Buffer   := nil;
   Buffer3D := nil;
   Smp_ID   := -1;
   end;
tmp^.buffer := nil;

if tmp^.Next <> nil then
 tmp^ := tmp^.Next^
else
 begin
 p := Sample;
 if tmp = p then
  Sample := nil
 else
  while p <> nil do
   if p^.Next = tmp then
    begin
    p^.Next := nil;
    break;
    end
   else
    p := p^.Next;
 end;

dec(snd_Samples);

Result := true;
end;

// ,   
function TDXSound.snd_Load(const FileName: string): integer;
var
 tmpSample : PSample;
 p         : PSample;
 str       : string;
begin
Result := -1;
if not snd_initialized then Exit;

str := FileName;
p := Sample;
while p <> nil do
 if p^.FileName = str then
  begin
  p^.flag := false;
  Result  := p^.ID;
  Exit;
  end
 else
  p := p^.Next;

New(tmpSample);
tmpSample^.FileName := str;
 try
  if LoadFromWAV(tmpSample, str) then
   begin
   inc(nID);

   tmpSample^.Next := Sample;
   tmpSample^.ID   := nID;
   tmpSample^.flag := false;

   Sample := tmpSample;

   inc(snd_Samples);
   Result := nID;
   end
 except
 end;

if Result = -1 then
 Dispose(tmpSample);
end;


procedure TDXSound.snd_BeginUpdate;
var
 p : PSample;
begin
p := Sample;
while p <> nil do
 begin
 p^.flag := true;
 p       := p^.Next;
 end;
end;

procedure TDXSound.snd_EndUpdate;
var
 p : PSample;
 b : boolean;
begin
p := Sample;
while p <> nil do
 if p^.flag then
  begin
  b := p^.Next = nil;
  snd_Free(p^.ID);
  if b then break;
  end
 else
  p := p^.Next;
end;

//    ID     //
function TDXSound.snd_Play(Sample_ID: integer; Loop: boolean; Pos: TVector): integer;
var
 i      : integer;
 tmp    : PSample;
 Status : DWORD;

 function Play(i: integer): integer;
 var
  hr : HResult;
 begin
 Channel[i].Pos := Pos;
 Channel[i].buffer3D.SetPosition(Pos.X, Pos.Y, Pos.Z, DS3D_DEFERRED);

// ids.SetCooperativeLevel(h_Wnd  , DSSCL_NORMAL);
 if Loop then
  hr := Channel[i].Buffer.Play(0, 0, DSBPLAY_LOOPING)
 else
  hr := Channel[i].Buffer.Play(0, 0, 0);
 if hr <> DS_OK then
  Result := -1
 else
  begin
  Channel[i].Time := GetTickCount;
  Result := i;
  end;
 end;

 function Copy(i: integer): boolean;
 begin
 Result := false;
 Channel[i].Smp_ID := Sample_ID;
 //     
 ids.DuplicateSoundBuffer(tmp.buffer, Channel[i].Buffer);


 if Channel[i].buffer.QueryInterface(IID_IDirectSound3DBuffer,
                                     Channel[i].buffer3D) <> DS_OK then
  begin
  Channel[i].Buffer.Restore;
  Channel[i].buffer   := nil;
  Channel[i].Buffer3D := nil;
  Exit;
  end;
 Result := true;
 end;

begin
Result := -1;
if snd_off then Exit;
if not snd_initialized then Exit;

tmp := GetSample(Sample_ID); //  
if tmp = nil then Exit;      //  

//       
for i := 0 to MaxChannels - 1 do
 if (Channel[i].Buffer <> nil) and
    (Sample_ID = Channel[i].Smp_ID) then
  begin
  if (Channel[i].Buffer.GetStatus(Status) = DS_OK) and
     (Status and DSBSTATUS_PLAYING = 0) then
   begin
   Result := Play(i);
   Exit;
   end;
  end;

//      ...
for i := 0 to MaxChannels - 1 do
 if Channel[i].Buffer = nil then
  begin
  if Copy(i) then
   Result := Play(i);
  Exit;
  end;

//  ,     
for i := 0 to MaxChannels - 1 do
 //   
 if Channel[i].Buffer <> nil then
  begin
  if not((Channel[i].Buffer.GetStatus(Status) = DS_OK) and
         (Status and DSBSTATUS_PLAYING <> 0)) then
   begin
   Channel[i].Buffer.Restore;
   Channel[i].Buffer   := nil;
   Channel[i].Buffer3D := nil;
   end
  else
   continue;

  if Copy(i) then
   Result := Play(i);
  Exit;
  end;
end;

function TDXSound.snd_Stop(var Channel_ID: integer): boolean;
begin
Result := false;
if not snd_ChannelExists(Channel_ID) then Exit;
Result := Channel[Channel_ID].Buffer.Stop = DS_OK;
Channel[Channel_ID].Buffer.SetCurrentPosition(0);
Channel_ID := -1;
end;

procedure TDXSound.snd_StopAll(Sound_ID: integer);
var
 i : integer;
begin
if not snd_initialized then Exit;
//    
if Sound_ID <= 0 then
 begin
 for i := 0 to MaxChannels - 1 do
  if Channel[i].Buffer <> nil then
   Channel[i].Buffer.Stop;
 end
else
 //    Sound_ID
 for i := 0 to MaxChannels - 1 do
  if (Channel[i].Buffer <> nil) and
     (Channel[i].Smp_ID = Sound_ID) then
   Channel[i].Buffer.Stop;
end;

function TDXSound.snd_SetVolume(Channel_ID: integer; Volume: integer): boolean;
begin
Result := false;
if snd_off then Exit;
if not snd_ChannelExists(Channel_ID) then Exit;
Volume := - 50 * (100 - Volume);
Result :=  Channel[Channel_ID].buffer.SetVolume(Volume) = DS_OK;
end;

function TDXSound.snd_SetPos(Channel_ID: integer; Pos: TVector): boolean;
begin
Result := false;
if snd_off then Exit;
if not snd_ChannelExists(Channel_ID) then Exit;
Channel[Channel_ID].Pos := Pos;
Result := Channel[Channel_ID].buffer3D.SetPosition(Pos.X, Pos.Y, Pos.Z, DS3D_DEFERRED) = DS_OK;
end;

function TDXSound.snd_SetFreq(Channel_ID: integer; Freq: DWORD): boolean;
begin
Result := false;
if snd_off then Exit;
if not snd_ChannelExists(Channel_ID) then Exit;
Result := Channel[Channel_ID].buffer.SetFrequency(Freq) = DS_OK;
end;

procedure TDXSound.snd_SetVelocity(Channel_ID: integer; Pos: TVector);
begin
if snd_off then Exit;
if not snd_ChannelExists(Channel_ID) then Exit;
Channel[Channel_ID].Buffer3D.SetVelocity(Pos.X, Pos.Y, Pos.Z, DS3D_DEFERRED);
end;

procedure TDXSound.snd_SetGlobalPos(Pos: TVector);
begin
if snd_off then Exit;
if not snd_initialized then Exit;
if idsl <> nil then
 idsl.SetPosition(Pos.X, Pos.Y, Pos.Z, DS3D_DEFERRED);
end;

//  
procedure TDXSound.snd_SetGlobalVelocity(V: TVector);
begin
if snd_off then Exit;
if not snd_initialized then Exit;
if idsl <> nil then
 idsl.SetVelocity(V.Y, V.Y, V.Z, DS3D_DEFERRED);
end;

procedure TDXSound.snd_SetOrientation(front, top: TVector);
begin
if snd_off then Exit;
if not snd_initialized then Exit;
if idsl <> nil then
 idsl.SetOrientation(front.X, front.Y, front.Z,
                     top.X, top.Y, top.Z,
                     DS3D_DEFERRED);
end;

procedure TDXSound.snd_SetDopplerFactor(factor: single);
begin
if snd_off then Exit;
if not snd_initialized then Exit;
if idsl <> nil then
 idsl.SetDopplerFactor(factor, DS3D_DEFERRED);
end;

procedure TDXSound.snd_SetRolloffFactor(factor: single);
begin
if snd_off then Exit;
if not snd_initialized then Exit;
if idsl <> nil then
 idsl.SetRolloffFactor(factor, DS3D_DEFERRED);
end;

procedure TDXSound.snd_SetDistanceFactor(Dst   : single);
begin
snd_Dist := dst;
end;

procedure TDXSound.snd_Update;
var
 i      : integer;
 Status : DWORD;
 t      : DWORD;
begin
if not snd_initialized then Exit;
if idsl = nil then
 if idsbp.QueryInterface(IID_IDirectSound3DListener,
                         idsl) = DS_OK then
  begin
  idsl.SetDistanceFactor(snd_Dist, DS3D_DEFERRED);
  idsl.SetRolloffFactor(0.1, DS3D_DEFERRED);
  idsl.SetOrientation(0, 1, 0, 0, 0, 1, DS3D_DEFERRED);

  end;

snd_Channels := 0;
snd_Playing  := 0;

t := GetTickCount;
for i := 0 to MaxChannels - 1 do
 if Channel[i].Buffer <> nil then
  if (Channel[i].Buffer.GetStatus(Status) = DS_OK) and
     (status and DSBSTATUS_PLAYING <> 0) then
   begin
   snd_SetPos(i, Channel[i].Pos); //   ,     :)
   inc(snd_Playing);
   inc(snd_Channels);
   end
  else
   if t - Channel[i].Time > 3000 then
    begin
    Channel[i].Buffer.Restore;
    Channel[i].buffer   := nil;
    Channel[i].Buffer3D := nil;
    end
   else
    inc(snd_Channels);

idsl.CommitDeferredSettings;
end;
{$EndRegion}

{$Region 'Graphic -> Shader'}

function TShader.CheckForErrors(glObject: GLHandleARB): String;
 var
  blen, slen: GLInt;
  InfoLog   : PGLCharARB;
begin
 glGetObjectParameterivARB(glObject, GL_OBJECT_INFO_LOG_LENGTH_ARB, @blen);
 if blen > 1 then
 begin
  GetMem(InfoLog, blen*SizeOf(PGLCharARB));
  glGetInfoLogARB(glObject, blen , slen, InfoLog);
  Result:= PChar(InfoLog);
  Dispose(InfoLog);
 end;
end;

procedure TShader.Load(Filename: string; Shader_Type: Glenum;Define:String='');
var
  str,tmp: string;
  F      : Text;
  source : PChar;
  shader : Cardinal;
  i,
  status : integer;
begin
  if not GL_ARB_shading_language_100 then
  begin
    MessageBox('Can''t initializate Shader', 1);
    exit;
  end;

  If NotFileExists(FileName) then exit;

  str := '';
  for I := 1 to Length(Define)  do
  case Define[i] of
   '|':  str := str + #13+#10;
  else  str := str + Define[i];
  end;
//  messagebox(str +#13+#10 + 'define:'+define,0);

  AssignFile(f, Filename);
  Reset(f);
  repeat
    ReadLn(f, tmp);
    str := str + tmp + #13#10;
  until Eof(f);
  CloseFile(f);

  source := PChar(str);
  shader := glCreateShaderObjectARB(Shader_Type);
  if shader = 0 then
  begin
  //    MessageBox(0, 'Error creating shader object', 'Error', MB_OK);
    exit;
  end;
  glShaderSourceARB(shader, 1, @source, nil);
  glCompileShaderARB(shader);
  glGetObjectParameterivARB(shader, GL_OBJECT_COMPILE_STATUS_ARB, @status);
  if status <> 1 then
  begin
    messagebox(Pchar(CheckForErrors(shader) +#13+#10+filename),1);
    glDeleteObjectARB(shader);
    exit;
  end;
  SetLength(shaders, length(shaders)+1);
  shaders[length(shaders)-1] := shader;
end;

Function TShader.Compile : boolean;
var
  i: integer;
  status: integer;
begin
  if not GL_ARB_shading_language_100 then exit;

  sh := glCreateProgramObjectARB;
  for i := 0 to length(shaders)-1 do
    glAttachObjectARB(sh, shaders[i]);
  glLinkProgramARB(sh);

  glGetObjectParameterivARB(sh, GL_OBJECT_LINK_STATUS_ARB, @status);
  Result:=true;

  if status <> 1 then
  begin
    Result:=false;
    glDeleteObjectARB(sh);
    MessageBox('Error while compiling', 1);
    exit;
  end;
end;

procedure TShader.Start;
begin
  if not GL_ARB_shading_language_100 then exit;
  glUseProgramObjectARB(sh);
end;

function TShader.GetInfoLog: string;
var
  LogLen, Written: Integer;
begin
  Result:='';
  glGetObjectParameterivARB(Sh, GL_OBJECT_INFO_LOG_LENGTH_ARB, @LogLen);
  if LogLen<1 then Exit;
  SetLength(Result, LogLen);
  glGetInfoLogARB(Sh, LogLen, Written, PChar(Result));
  SetLength(Result, Written);
end;

procedure TShader.Stop;
begin
  if not GL_ARB_shading_language_100 then exit;
  glUseProgramObjectARB(0);
end;

procedure TShader.Free;
begin
  if not GL_ARB_shading_language_100 then exit;
  glDeleteObjectARB(sh);
end;

function TShader.GetUniform(uniform: PChar): GLuint;
begin
  Result := 0;
  if not GL_ARB_shading_language_100 then exit;
  Result := glGetUniformLocationARB(sh, uniform);
end;

function TShader.GetAttrib(attrib: PChar): GLuint;
begin
  Result := 0;
  if not GL_ARB_shading_language_100 then exit;
  Result := glGetAttribLocationARB(sh, attrib);
end;

procedure TShader.SetUniform(uniform: GLuint; value0: Integer);
begin
  if not GL_ARB_shading_language_100 then exit;
  glUniform1iARB(uniform, value0);
end;

procedure TShader.SetUniform(uniform: GLuint; value0: Single);
begin
  if not GL_ARB_shading_language_100 then exit;
  glUniform1fARB(uniform, value0);
end;

procedure TShader.SetUniform(uniform: GLuint; value0, value1: Single);
begin
  if not GL_ARB_shading_language_100 then exit;
  glUniform2fARB(uniform, value1, value1);
end;

procedure TShader.SetUniform(uniform: GLuint; value0, value1, value2: Single);
begin
  if not GL_ARB_shading_language_100 then exit;
  glUniform3fARB(uniform, value0, value1, value2);
end;

procedure TShader.SetUniform(uniform: GLuint; value0, value1, value2, value3: Single);
begin
  if not GL_ARB_shading_language_100 then exit;
  glUniform4fARB(uniform, value0, value1, value2, value3);
end;

procedure TShader.SetAttrib(uniform: GLuint; value0: Single);
begin
  if not GL_ARB_shading_language_100 then exit;
  glVertexAttrib1f(uniform,value0);
end;

procedure TShader.SetAttrib(uniform: GLuint; value0: Single; value1: Single);
begin
  if not GL_ARB_shading_language_100 then exit;
  glVertexAttrib2f(uniform,value0,value1);
end;

procedure TShader.SetAttrib(uniform: GLuint; value0, value1, value2: Single);
begin
  if not GL_ARB_shading_language_100 then exit;
  glVertexAttrib3f(uniform,value0,value1,value2);
end;

procedure TShader.SetAttrib(uniform: GLuint; value0, value1, value2, value3: Single);
begin
  if not GL_ARB_shading_language_100 then exit;
  glVertexAttrib4f(uniform,value0,value1,value2,value3);
end;



procedure TShader.BindUniform(uniform:GLuint; Value: PGLFLoat; size:Byte);
begin
  if not GL_ARB_shading_language_100 then exit;
      SetUniformV(uniform,value,size);
end;


procedure TShader.BindUniform(const name:string; Value: PGLFLoat; size:Byte);
var uniform:cardinal;
begin
  if not GL_ARB_shading_language_100 then exit;
  if (sh = 0) then exit;

      glUseProgramObjectARB(sh);
      uniform := glGetUniformLocationARB(sh, pchar(name));
      SetUniformV(uniform,value,size);
end;

procedure TShader.BindAttrib(uniform:GLuint; Value: PGLFLoat; size:Byte);
begin
  if not GL_ARB_shading_language_100 then exit;
      SetAttribV(uniform,value,size);
end;

procedure TShader.BindAttrib(const name:string; Value: PGLFLoat; size:Byte);
var uniform:cardinal;
begin
  if not GL_ARB_shading_language_100 then exit;
  if (sh = 0) then exit;

      glUseProgramObjectARB(sh);
      uniform := glGetUniformLocationARB(sh, pchar(name));
      SetAttribV(uniform,value,size);
end;

Procedure TShader.SetUniformV(uniform:Cardinal; value:PGLFloat; Size:Byte);
begin
      if      (size = 1) then glUniform1fvARB(uniform, 1, value)
      else if (size = 2) then glUniform2fvARB(uniform, 1, value)
      else if (size = 3) then glUniform3fvARB(uniform, 1, value)
      else if (size = 4) then glUniform4fvARB(uniform, 1, value)
      else if (size = 9) then glUniformMatrix3fvARB(uniform, 1, false, value)
      else if (size = 16) then glUniformMatrix4fvARB(uniform, 1, false, value);
end;

Procedure TShader.SetAttribV(uniform:Cardinal; value:PGLFloat; Size:Byte);
begin
      if      (size = 1) then glVertexAttrib1fv(uniform, value)
      else if (size = 2) then glVertexAttrib2fv(uniform, value)
      else if (size = 3) then glVertexAttrib3fv(uniform, value)
      else if (size = 4) then glVertexAttrib4fv(uniform, value)
      else if (size = 9) then glUniformMatrix3fvARB(uniform, 1, false, value)
      else if (size = 16) then glUniformMatrix4fvARB(uniform, 1, false, value);
end;

    Function TShadersList.Add(Fragment,Vertex: string):Integer;
    var i : integer;
    begin
       for i := 0 to length(Shaders)- 1 do
       if SameText(Shaders[i].Frag,Fragment) and
          SameText(Shaders[i].Vert,Vertex) then begin
          result:=i;
          exit;
         end;

      Result := Length(Shaders);
        SetLength(Shaders,Result+1);
        New(Shaders[Result].shader);
            Shaders[Result].shader^.Load(ShaderDir+Fragment, GL_FRAGMENT_SHADER_ARB);
            Shaders[Result].shader^.Load(ShaderDir+Vertex  , GL_VERTEX_SHADER_ARB);
            Shaders[Result].shader^.Compile;
    end;

    procedure TShadersList.Start(Shader:Cardinal);
    begin
      Shaders[Shader].shader^.Start;
    end;

    procedure TShadersList.Stop;
    var
      i :integer;
    begin
     for i := 0 to Length(shaders) - 1 do
      Shaders[i].shader^.Stop;
    end;

    procedure TShadersList.ShaderFree(Shader:Cardinal);
    begin
      Shaders[Shader].shader^.Free;
    end;

    procedure TShadersList.FreeAll();
    var i :integer;
    begin
     for i := 0 to Length(shaders) - 1 do
     begin
              Shaders[i].Shader^.Free;
      Dispose(Shaders[i].Shader);
     end;
     SetLength(Shaders,0);
    end;

    function  TShadersList.GetShader(Shader:Cardinal): PShader;
    begin
      Result := Shaders[Shader].shader;
    end;

    function  TShadersList.GetInfoLog(Shader:Cardinal): string;
    begin
      Result := Shaders[Shader].shader^.GetInfoLog
    end;

    function  TShadersList.GetUniform(Shader:Cardinal; uniform: PChar): GLuint;
    begin
      Result := Shaders[Shader].shader^.GetUniform(uniform);
    end;

    function  TShadersList.GetAttrib(Shader:Cardinal; attrib: PChar): GLuint;
    begin
      Result := Shaders[Shader].shader^.GetAttrib(attrib);
    end;

    procedure TShadersList.SetUniform(Shader:Cardinal; uniform: GLuint; value0: Single);
    begin
      Shaders[Shader].shader^.SetUniform(uniform,value0);
    end;

    procedure TShadersList.SetUniform(Shader:Cardinal; uniform: GLuint; value0: Integer);
    begin
      Shaders[Shader].shader^.SetUniform(uniform,value0);
    end;

    procedure TShadersList.SetUniform(Shader:Cardinal; uniform: GLuint; value0, value1: Single);
    begin
      Shaders[Shader].shader^.SetUniform(uniform,value0,value1);
    end;

    procedure TShadersList.SetUniform(Shader:Cardinal; uniform: GLuint; value0, value1, value2: Single);
    begin
      Shaders[Shader].shader^.SetUniform(uniform,value0,value1,value2);
    end;

    procedure TShadersList.SetUniform(Shader:Cardinal; uniform: GLuint; value0, value1, value2, value3: Single);
    begin
      Shaders[Shader].shader^.SetUniform(uniform,value0,value1,value2,value3);
    end;

    procedure TShadersList.SetAttrib (Shader:Cardinal; uniform: GLuint; value0 : Single);
    begin
      Shaders[Shader].shader^.SetAttrib(uniform,value0);
    end;

    procedure TShadersList.SetAttrib (Shader:Cardinal; uniform: GLuint; value0, value1 : Single);
    begin
      Shaders[Shader].shader^.SetAttrib(uniform,value0,value1);
    end;

    procedure TShadersList.SetAttrib (Shader:Cardinal; uniform: GLuint; value0, value1, value2: Single);
    begin
      Shaders[Shader].shader^.SetAttrib(uniform,value0,value1,value2);
    end;

    procedure TShadersList.SetAttrib (Shader:Cardinal; uniform: GLuint; value0, value1, value2,value3: Single);
    begin
      Shaders[Shader].shader^.SetAttrib(uniform,value0,value1,value2,value3);
    end;

    procedure TShadersList.BindUniform(Shader:Cardinal; uniform:GLuint; Value: PGLFLoat; size:byte);
    begin
      Shaders[Shader].shader^.BindUniform(uniform,value,size);
    end;

    procedure TShadersList.BindUniform(Shader:Cardinal; const name:string; Value: PGLFLoat; size:byte);
    begin
      Shaders[Shader].shader^.BindUniform(name,value,size);
    end;

    procedure TShadersList.BindAttrib(Shader:Cardinal; uniform:GLuint; Value: PGLFLoat; size:Byte);
    begin
      Shaders[Shader].shader^.BindAttrib(uniform,value,size);
    end;

    procedure TShadersList.BindAttrib(Shader:Cardinal; const name:string; Value: PGLFLoat; size:byte);
    begin
      Shaders[Shader].shader^.BindAttrib(name,value,size);
    end;


{$ENDREGION}

{$Region 'Graphic -> Fonts'}
type
  TCoord    = Array [0..3] of TVector2d;
  PFontData = ^TFontData;
  TFontData = record
    Font  : Cardinal;
    Vert  : Array [0..255] of TCoord;
    Width : array [0..255] of ShortInt;
  end;

var
 Fonts     : array of PFontData;

function FontCreate(handle:LongWord; Name: PChar; Size,Tex_Size: Integer): Cardinal;
var
  FNT  : HFONT;
  DC   : HDC;
  MDC  : HDC;
  BMP  : HBITMAP;
  BI   : BITMAPINFO;
  pix  : PByteArray;
  i    : Integer;
  cs   : TSize;
  s, t : Single;
  Data : PByteArray;
begin
  DC  := GetDC(handle);
  FNT := CreateFont(-MulDiv(Size, GetDeviceCaps(DC, LOGPIXELSY), 72), 0, 0, 0, 0, 0, 0, 0, RUSSIAN_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                    ANTIALIASED_QUALITY, 0, Name);
  ZeroMemory(@BI, SizeOf(BI));
  with BI.bmiHeader do
  begin
    biSize      := SizeOf(BITMAPINFOHEADER);
    biWidth     := TEX_SIZE;
    biHeight    := TEX_SIZE;
    biPlanes    := 1;
    biBitCount  := 24;
    biSizeImage := biWidth * biHeight * biBitCount div 8;
  end;

  MDC := CreateCompatibleDC(DC);
  BMP := CreateDIBSection(MDC, BI, DIB_RGB_COLORS, Pointer(pix), 0, 0);
  ZeroMemory(pix, TEX_SIZE * TEX_SIZE * 3);

  SelectObject(MDC, BMP);
  SelectObject(MDC, FNT);
  SetBkMode(MDC, TRANSPARENT);
  SetTextColor(MDC, $FFFFFF);

  for i := 0 to 255 do
    Windows.TextOut(MDC, i mod 16 * (TEX_SIZE div 16), i div 16 * (TEX_SIZE div 16), @Char(i), 1);

  Result := HIGH(Cardinal);
  for i := 0 to Length(Fonts) - 1 do
    if Fonts[i] = nil then
    begin
      Result := i;
      break;
    end;
  if Result = HIGH(Cardinal) then
  begin
    Result := Length(Fonts);
    SetLength(Fonts, Result + 1);
  end;

  New(Fonts[Result]);
  with Fonts[Result]^ do
  begin
     GetMem(Data, TEX_SIZE * TEX_SIZE * 2);
    for i := 0 to TEX_SIZE * TEX_SIZE - 1 do
    begin
      Data[i * 2]     := 255;
      Data[i * 2 + 1] := pix[i * 3];
    end;
    Font := CreateTexture(TEX_SIZE, TEX_SIZE, GL_LUMINANCE_ALPHA,Data);
    FreeMem(Data);
    for i := 0 to 255 do
    begin
      s := (i mod 16)/16 +0.001;
      t := (i div 16)/16 +0.001;
      GetTextExtentPoint32(MDC, @Char(i), 1, cs);
      Width[i] := cs.cx;
      Vert[i][0] := vec2f(s                  ,1 - t);
      Vert[i][1] := vec2f(s + cs.cx/TEX_SIZE ,1 - t - cs.cy/TEX_SIZE);
      Vert[i][2] := vec2f(cs.cx              , cs.cy);
    end;
  end;

  DeleteObject(FNT);
  DeleteObject(BMP);
  DeleteDC(MDC);
  ReleaseDC(handle, DC);
end;

procedure TextOut(Font:Cardinal; Size, x,y : Single ; str:string);
var i,i2:Word;
    ch:char;
    V:TCoord;
begin


  glPushAttrib(GL_ENABLE_BIT);
  glDisable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  glDisable(GL_LIGHTING);
  glEnable(GL_ALPHA_TEST);
  glAlphaFunc(GL_GEQUAL, 0.1);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  Texture_Enable(Fonts[Font]^.Font,0);
  glPushMatrix;

  glTranslatef(X, Y, 0);
  for i:=1 to length(str) do
  begin
       ch:= str[i];
      i2 := ord(ch);
      V  := Fonts[font]^.Vert[i2];

    glBegin(gl_polygon);
        glTexCoord2f(v[0].x , v[0].y);     glVertex2f( 0            ,0  );
        glTexCoord2f(v[1].x , v[0].y);     glVertex2f( v[2].x +Size ,0  );
        glTexCoord2f(v[1].x , v[1].y);     glVertex2f( v[2].x +Size ,v[2].y+Size );
        glTexCoord2f(v[0].x , v[1].y);     glVertex2f( 0            ,v[2].y+Size );
    glEnd;
    GLTranslatef(v[2].x +Size,0,0);;

  end;

  glPopMatrix;
  glPopAttrib;
end;
{$ENDREGION}

{$Region 'Graphic -> Frustum''}
Const
	RIGHT	= 0;
	LEFT	= 1;
	BOTTOM	= 2;
	TOP	= 3;
	BACK	= 4;
	FRONT	= 5;

Procedure NormalizePlane(var frustum : tfrustum; side : integer);
var
	magnitude	: single;
begin
	magnitude := sqrt( frustum[side][0] * frustum[side][0] +
							   frustum[side][1] * frustum[side][1] +
							   frustum[side][2] * frustum[side][2] );

	frustum[side][0] := frustum[side][0] / magnitude;
	frustum[side][1] := frustum[side][1] / magnitude;
	frustum[side][2] := frustum[side][2] / magnitude;
	frustum[side][3] := frustum[side][3] / magnitude;
end;

Procedure CalculateFrustum;
var
	proj	: array [0..15] of single;
	modl	: array [0..15] of single;
	clip	: array [0..15] of single;
begin
	glGetFloatv( GL_PROJECTION_MATRIX, @proj );
	glGetFloatv( GL_MODELVIEW_MATRIX, @modl );

	clip[ 0] := modl[ 0] * proj[ 0] + modl[ 1] * proj[ 4] + modl[ 2] * proj[ 8] + modl[ 3] * proj[12];
	clip[ 1] := modl[ 0] * proj[ 1] + modl[ 1] * proj[ 5] + modl[ 2] * proj[ 9] + modl[ 3] * proj[13];
	clip[ 2] := modl[ 0] * proj[ 2] + modl[ 1] * proj[ 6] + modl[ 2] * proj[10] + modl[ 3] * proj[14];
	clip[ 3] := modl[ 0] * proj[ 3] + modl[ 1] * proj[ 7] + modl[ 2] * proj[11] + modl[ 3] * proj[15];

	clip[ 4] := modl[ 4] * proj[ 0] + modl[ 5] * proj[ 4] + modl[ 6] * proj[ 8] + modl[ 7] * proj[12];
	clip[ 5] := modl[ 4] * proj[ 1] + modl[ 5] * proj[ 5] + modl[ 6] * proj[ 9] + modl[ 7] * proj[13];
	clip[ 6] := modl[ 4] * proj[ 2] + modl[ 5] * proj[ 6] + modl[ 6] * proj[10] + modl[ 7] * proj[14];
	clip[ 7] := modl[ 4] * proj[ 3] + modl[ 5] * proj[ 7] + modl[ 6] * proj[11] + modl[ 7] * proj[15];

	clip[ 8] := modl[ 8] * proj[ 0] + modl[ 9] * proj[ 4] + modl[10] * proj[ 8] + modl[11] * proj[12];
	clip[ 9] := modl[ 8] * proj[ 1] + modl[ 9] * proj[ 5] + modl[10] * proj[ 9] + modl[11] * proj[13];
	clip[10] := modl[ 8] * proj[ 2] + modl[ 9] * proj[ 6] + modl[10] * proj[10] + modl[11] * proj[14];
	clip[11] := modl[ 8] * proj[ 3] + modl[ 9] * proj[ 7] + modl[10] * proj[11] + modl[11] * proj[15];

	clip[12] := modl[12] * proj[ 0] + modl[13] * proj[ 4] + modl[14] * proj[ 8] + modl[15] * proj[12];
	clip[13] := modl[12] * proj[ 1] + modl[13] * proj[ 5] + modl[14] * proj[ 9] + modl[15] * proj[13];
	clip[14] := modl[12] * proj[ 2] + modl[13] * proj[ 6] + modl[14] * proj[10] + modl[15] * proj[14];
	clip[15] := modl[12] * proj[ 3] + modl[13] * proj[ 7] + modl[14] * proj[11] + modl[15] * proj[15];

	Frustum[RIGHT][0] := clip[ 3] - clip[ 0];
	Frustum[RIGHT][1] := clip[ 7] - clip[ 4];
	Frustum[RIGHT][2] := clip[11] - clip[ 8];
	Frustum[RIGHT][3] := clip[15] - clip[12];

	NormalizePlane(Frustum, RIGHT);

	Frustum[LEFT][0] := clip[ 3] + clip[ 0];
	Frustum[LEFT][1] := clip[ 7] + clip[ 4];
	Frustum[LEFT][2] := clip[11] + clip[ 8];
	Frustum[LEFT][3] := clip[15] + clip[12];

	NormalizePlane(Frustum, LEFT);

	Frustum[BOTTOM][0] := clip[ 3] + clip[ 1];
	Frustum[BOTTOM][1] := clip[ 7] + clip[ 5];
	Frustum[BOTTOM][2] := clip[11] + clip[ 9];
	Frustum[BOTTOM][3] := clip[15] + clip[13]+15;

	NormalizePlane(Frustum, BOTTOM);

	Frustum[TOP][0] := clip[ 3] - clip[ 1];
	Frustum[TOP][1] := clip[ 7] - clip[ 5];
	Frustum[TOP][2] := clip[11] - clip[ 9];
	Frustum[TOP][3] := clip[15] - clip[13];

	NormalizePlane(Frustum, TOP);

	Frustum[BACK][0] := clip[ 3] - clip[ 2];
	Frustum[BACK][1] := clip[ 7] - clip[ 6];
	Frustum[BACK][2] := clip[11] - clip[10];
	Frustum[BACK][3] := clip[15] - clip[14];

	NormalizePlane(Frustum, BACK);

	Frustum[FRONT][0] := clip[ 3] + clip[ 2];
	Frustum[FRONT][1] := clip[ 7] + clip[ 6];
	Frustum[FRONT][2] := clip[11] + clip[10];
	Frustum[FRONT][3] := clip[15] + clip[14];

	NormalizePlane(Frustum, FRONT);
end;

function PointInFrustum( V:TVector ) : BOOLEAN;
var
	i	: integer;
begin
	for i := 0 to 5 do
		if(Frustum[i][0] * v.x + Frustum[i][1] * v.y + Frustum[i][2] * v.z + Frustum[i][3] <= 0) then
		begin
			result := false; exit;
		end;

	result := true;
end;


function SphereInFrustum( V:TVector; radius : single) : boolean;
var
	i	: integer;
begin

	for i := 0 to 5 do
		if( Frustum[i][0] * v.x + Frustum[i][1] * v.y + Frustum[i][2] * v.z + Frustum[i][3] <= -radius ) then
		begin
			result := false; exit;
		end;

	result := true;
end;

function CubeInFrustum( V:TVector; size : single) : boolean;
var
	i	: integer;
begin

	for i := 0 to 5 do
	begin
		if(Frustum[i][0] * (v.x - size) + Frustum[i][1] * (v.y - size) + Frustum[i][2] * (v.z - size) + Frustum[i][3] > 0) then
		   continue;
		if(Frustum[i][0] * (v.x + size) + Frustum[i][1] * (v.y - size) + Frustum[i][2] * (v.z - size) + Frustum[i][3] > 0) then
		   continue;
		if(Frustum[i][0] * (v.x - size) + Frustum[i][1] * (v.y + size) + Frustum[i][2] * (v.z - size) + Frustum[i][3] > 0) then
		   continue;
		if(Frustum[i][0] * (v.x + size) + Frustum[i][1] * (v.y + size) + Frustum[i][2] * (v.z - size) + Frustum[i][3] > 0) then
		   continue;
		if(Frustum[i][0] * (v.x - size) + Frustum[i][1] * (v.y - size) + Frustum[i][2] * (v.z + size) + Frustum[i][3] > 0) then
		   continue;
		if(Frustum[i][0] * (v.x + size) + Frustum[i][1] * (v.y - size) + Frustum[i][2] * (v.z + size) + Frustum[i][3] > 0) then
		   continue;
		if(Frustum[i][0] * (v.x - size) + Frustum[i][1] * (v.y + size) + Frustum[i][2] * (v.z + size) + Frustum[i][3] > 0) then
		   continue;
		if(Frustum[i][0] * (v.x + size) + Frustum[i][1] * (v.y + size) + Frustum[i][2] * (v.z + size) + Frustum[i][3] > 0) then
		   continue;

		result := false; exit;
	end;

	result := true;
end;

function BoxInFrustum( Min,Max:TVector) : boolean;
var
	i	: integer;
begin
	for i := 0 to 5 do
	begin
		if(Frustum[i][0] * Min.x + Frustum[i][1] * Min.y  + Frustum[i][2] * Min.z  + Frustum[i][3] > 0)  then continue;
		if(Frustum[i][0] * Max.x + Frustum[i][1] * Min.y  + Frustum[i][2] * Min.z  + Frustum[i][3] > 0)  then continue;
		if(Frustum[i][0] * Min.x + Frustum[i][1] * Max.y  + Frustum[i][2] * Min.z  + Frustum[i][3] > 0)  then continue;
		if(Frustum[i][0] * Max.x + Frustum[i][1] * Max.y  + Frustum[i][2] * Min.z  + Frustum[i][3] > 0)  then continue;
		if(Frustum[i][0] * Min.x + Frustum[i][1] * Min.y  + Frustum[i][2] * Max.z  + Frustum[i][3] > 0)  then continue;
		if(Frustum[i][0] * Max.x + Frustum[i][1] * Min.y  + Frustum[i][2] * Max.z  + Frustum[i][3] > 0)  then continue;
		if(Frustum[i][0] * Min.x + Frustum[i][1] * Max.y  + Frustum[i][2] * Max.z  + Frustum[i][3] > 0)  then continue;
		if(Frustum[i][0] * Max.x + Frustum[i][1] * Max.y  + Frustum[i][2] * Max.z  + Frustum[i][3] > 0)  then continue;

		result := false; exit;
	end;

	result := true;
end;

{$EndRegion}

{$Region 'Graphic -> Projection'}
  Procedure ChangeFov(W,H,FOV:Single);

  function Tan(const X: Extended): Extended;
  {  Tan := Sin(X) / Cos(X) }
  asm
        FLD    X
        FPTAN
        FSTP   ST(0)      { FPTAN pushes 1.0 after result }
        FWAIT
  end;

  function CalcFov(fov, width, height: Single): Single;
    const
     PI                            = 3.14159265358979323846;
    var
      a, x: Single;
    begin
        if (fov < 1) or (fov > 179) then fov:=45; //  
        x := width / tan(fov / 360 * PI);
        a := arctan(height / x);
        a := a * 360 / PI;
        result := a;
    end;
  begin
   GL_FOV := CalcFov(fov,w,h);
  end;

  Procedure SetProjection(W, H: Single; Ortho: boolean);
  begin

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();

    if ortho then
      glOrtho(0, w, h, 0, -1, 100)
    else
      gluPerspective(gl_fov, W/H, 1, 10000);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

  end;

 {$EndRegion}

{$Region 'Graphic -> PixelBuffer'}
constructor TPixelBuffer.Create(pWidth, pHeight : Integer;pParentDC, pParentRC : Cardinal);
const
 PixelFormatAttribs  : array[0..12] of TGLUInt = (WGL_SUPPORT_OPENGL_ARB, GL_TRUE,
                                                  WGL_DRAW_TO_PBUFFER_ARB, GL_TRUE,
                                                  WGL_COLOR_BITS_ARB, 24,
                                                  WGL_ALPHA_BITS_ARB, 8,
                                                  WGL_DEPTH_BITS_ARB, 24,
                                                  WGL_DOUBLE_BUFFER_ARB, GL_FALSE, 0);

 PixelBufferAttribs  : array[0..4] of TGLUInt = (WGL_TEXTURE_FORMAT_ARB, WGL_TEXTURE_RGBA_ARB,
                                                 WGL_TEXTURE_TARGET_ARB, WGL_TEXTURE_2D_ARB, 0);
 EmptyF              : TGLFLoat = 0;
var
 PFormat       : array[0..64] of TGLUInt;
 NumPFormat    : TGLUInt;
 TempW, TempH  : TGLUInt;
 TempDC        : TGLUInt;
begin
ParentDC := pParentDC;
ParentRC := pParentRC;
Width    := pWidth;
Height   := pHeight;

   TempDC := wglGetCurrentDC;
if TempDC  = 0 then begin
  messagebox('PixelBuffer->wglGetCurrentDC->Couldn''t obtain valid device context',2);
  exit;
 end;

if not wglChoosePixelFormatARB(TempDC, @PixelFormatAttribs, @EmptyF, Length(PFormat), @PFormat, @NumPFormat) then begin
    messagebox('PixelBuffer->wglChoosePixelFormatARB->No suitable pixelformat found',2);
   exit;
 end;

   Handle := wglCreatePBufferARB(TempDC, PFormat[0], Width, Height, @PixelBufferAttribs);

if Handle > 0 then begin
     wglQueryPbufferARB(Handle, WGL_PBUFFER_WIDTH_ARB, @TempW);
     wglQueryPbufferARB(Handle, WGL_PBUFFER_HEIGHT_ARB, @TempH);
   end
else
   begin
    MessageBox('PixelBuffer->wglCreatePBufferARB->Couldn''t obtain valid handle',2);
    exit;
 end;

    DC := wglGetPBufferDCARB(Handle);
 if DC = 0 then begin
   MessageBox('PixelBuffer->wglGetPBufferDCARB->Couldn''t obtain valid DC for PBuffer',2);
   exit;
 end;

   RC := wglCreateContext(DC);
if RC = 0 then begin
   MessageBox('PixelBuffer->wglGetPBufferDCARB->Couldn''t create rendercontext for PBuffer',2);
   exit;
 end;
glGenTextures(1, @TextureID);
glBindTexture(GL_TEXTURE_2D, TextureID);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
end;

destructor TPixelBuffer.Destroy;
begin
wglDeleteContext(RC);
wglReleasePbufferDCARB(Handle, DC);
wglDestroyPbufferARB(Handle);
inherited;
end;

function TPixelBuffer.IsLost : Boolean;
var
 Flag : TGLUInt;
begin
Result := False;
wglQueryPbufferARB(Handle, WGL_PBUFFER_LOST_ARB, @Flag);
if Flag <> 0 then
 Result := True;
end;

procedure TPixelBuffer.Enable;
begin
wglMakeCurrent(DC, RC);
end;

procedure TPixelBuffer.Disable;
begin
wglMakeCurrent(ParentDC, ParentRC);
end;

procedure TPixelBuffer.Bind;
begin
wglBindTexImageARB(Handle, WGL_FRONT_LEFT_ARB);
end;

procedure TPixelBuffer.Release;
begin
wglReleaseTexImageARB(Handle, WGL_FRONT_LEFT_ARB);
end;
{$EndRegion}

{$Region 'Graphic -> Render Mesh'}
procedure RenderShaderModel(Vertex_Count, Face_Type,Attrib_tangent:Cardinal; Face_array, Vertex_Array,Normal_Array,Tangent_Array, Texture0_Array :Pointer; Texture1_Array :Pointer=nil;Texture2_Array :Pointer=nil;Texture3_Array :Pointer=nil);
begin

 glEnableClientState(GL_VERTEX_ARRAY);
 glEnableClientState(GL_NORMAL_ARRAY);
 glEnableClientState(GL_TEXTURE_COORD_ARRAY);

   glVertexPointer  (3, GL_FLOAT, SizeOf(Tvector), Vertex_Array);

   glNormalPointer  (   GL_FLOAT, 0, Normal_Array);
   glClientActiveTextureARB(GL_TEXTURE0_ARB); glTexCoordPointer(2, GL_FLOAT, 0, Texture0_Array  );

   if GL_USE_SHADER then
   begin
    if Texture3_Array <> nil then begin
       glClientActiveTextureARB(GL_TEXTURE3_ARB); glTexCoordPointer(2, GL_FLOAT, 0, Texture3_Array  );
    end;
    if Texture2_Array <> nil then begin
       glClientActiveTextureARB(GL_TEXTURE2_ARB); glTexCoordPointer(2, GL_FLOAT, 0, Texture2_Array  );
    end;
    if Texture1_Array <> nil then begin
       glClientActiveTextureARB(GL_TEXTURE1_ARB); glTexCoordPointer(2, GL_FLOAT, 0, Texture1_Array  );
    end;

     glEnableVertexAttribArrayARB(Attrib_tangent);
     glVertexAttribPointerARB(Attrib_tangent , 3, GL_FLOAT, false, 0, Tangent_Array);
   end;

    glDrawElements(GL_TRIANGLES, Vertex_Count, Face_Type, Face_array);

   if GL_USE_SHADER then
   glDisableVertexAttribArrayARB(Attrib_tangent);

   glDisableClientState(GL_TEXTURE_COORD_ARRAY);
   glDisableClientState(GL_NORMAL_ARRAY);
   glDisableClientState(GL_VERTEX_ARRAY);
end;

procedure T3DObject.CalcNormals;
var
 i, j    : Integer;
 n       : TVector;
begin
   SetLength(Normal, Length(Vertex) );
   for i := 0 to Length(Faces) - 1 do
   begin
     n := Vertex[Faces[i][0]] - Vertex[Faces[i][1]];
     n := n.Cross((Vertex[Faces[i][0]] - Vertex[Faces[i][2]]));
     for j := 0 to 2 do
       Normal[Faces[i][j]] :=v_normalize(Normal[Faces[i][j]] + n);
   end;
end;

procedure T3DObject.AdjustNormals;
var V1, V2,
    Norm,
    VSum, VZero:TVector;
    TempNormals:array of TVector;
    VPoly      :array[0..2] of TVector;
    I, Shared,J:Integer;
begin
  SetLength(TempNormals, FaceCount);
  SetLength(Normal, VertexCount);

  for I:=0 to FaceCount-1 do
   begin
     vPoly[0]:=vertex[Faces[I][0]];
     vPoly[1]:=vertex[Faces[I][1]];
     vPoly[2]:=vertex[Faces[I][2]];

     V1 := V_Sub(vPoly[0], vPoly[2]);
     V2 := V_Sub(vPoly[2], vPoly[1]);

     Norm:= v_Normalize(V_Cross(V1, V2));
     TempNormals[I]:= Norm;
   end;

  vSum := V_Identity;
  VZero:= v_identity;

  for I:=0 to VertexCount-1 do
   begin
     Shared:=0;

     for J:=0 to FaceCount-1 do
      if (Faces[J][0] = I) or (Faces[J][1] = I) or (Faces[J][2] = I) then
       begin
         VSum:=V_Add(VSum, TempNormals[J]);
         Inc(Shared);
       end;

     Normal[I]:= V_Div(vSum, -Shared);
     Normal[I]:= V_Normalize(Normal[I]);
     vSum:=vZero;
   end;

  Finalize(TempNormals);
end;


Procedure CalcAABB(Vec3f:PVectorArray; const VecCount:cardinal; var AABB:TAABB);
const m = 4000000000;
var i : integer;
begin
      aabb.Min := Vector( m, m, m);
      aabb.Max := Vector(-m,-m,-m);

     for i := 0 to VecCount -1 do
      begin
       aabb.Min := VAABBMin(aabb.min, Vec3f[i]);
       aabb.Max := VaabbMax(aabb.Max, Vec3f[i]);
      end;
end;

Procedure T3DObject.ReconstructModel(AndTexCoords:Boolean);
Function V_Compare(const A,B: TVector): boolean;
const
  Epsilon = 0.001;
begin
  result := false;
  if abs(B.x -A.x ) <= Epsilon then
  if abs(B.y -A.y ) <= Epsilon then
  if abs(B.z -A.z ) <= Epsilon then
        result := true;
end;

Function V2d_Compare(const A,B: TVector2d): boolean;
const
  Epsilon = 0.01;
begin
  result := false;
  if abs(B.x -A.x ) <= Epsilon then
  if abs(B.y -A.y ) <= Epsilon then
        result := true;
end;

var i,j : integer;
 VS : Array of TVector;
 TS : Array of TVector2d;
 FS : Array of TUnsignedFace;
 Function add_point(V:TVector;T:TVector2D):Integer;
 var i :integer;
 begin
  for i := 0 to length(vs)-1 do
  If AndTexCoords then
  begin
    if v_compare(vs[i],v) and V2d_Compare(ts[i],t) then begin result:=i; exit; end;
  end else
    if v_compare(vs[i],v)  then begin result:=i; exit; end;

  i := Length(VS);
  SetLength(vs,i+1);
  SetLength(ts,i+1);
            vs[i] := v;
            ts[i] := t;
           result := i;
 end;
begin
 SetLength(FS, Length(Faces));

 For i := 0 to length(Faces)-1 do
 for j := 0 to 2 do
 begin
  FS[i][j] := add_point( Vertex[Faces[i][j]] , Texcoord[Faces[i][j]] );
 end;
 Move(Vs[0].x   ,Vertex[0].x , LEngth(VS)  * SizeOf(TVector));
 if AndTexCoords then
 Move(TS[0].x   ,Texcoord[0].x , LEngth(TS)  * SizeOf(TVector2d));
 Move(FS[0][0]  ,Faces [0][0], Length(FS)  * SizeOf(TUnsignedFace));
end;


function CreateShaderMesh(FaceArray    : PUnsignedFaceArray;
                          VertexArray  : PVectorArray;
                          TexCoordArray: PVector2DArray;
                          Face_Count,
                          Vertex_Count,
                          TexCoord_Count: Cardinal): P3DObject;
 var
     I, I2 : integer;
begin
  New(Result);

  with Result^ do
  begin
    FaceCount     := Face_Count;
    VertexCount   := Vertex_Count;
    TexCoordCount := TexCoord_Count;

    SetLength(Faces           , FaceCount );
    SetLength(Vertex          , VertexCount );
    SetLength(TexCoord        , TexCoordCount );
    SetLength(Shader_Tangent  , VertexCount );
    SetLength(Shader_Binormal , VertexCount );
    SetLength(Shader_Normal   , VertexCount );

       {
    with Volume_model do
    begin
      GetMem(V_Edge  , Length(faces) * 24 * SizeOf(Word));
      GetMem(V_Vertex, Length(faces) * 3 * SizeOf(TVector) * 8);
    end;

    Matrix.Identity;
       }

    Move(FaceArray[0][0]   ,Faces[0][0]   , FaceCount     * SizeOf(TUnsignedFace));
    Move(VertexArray[0].x  ,Vertex[0].x   , VertexCount   * SizeOf(TVector));
    Move(TexCoordArray[0].x,TexCoord[0].x , TexCoordCount * SizeOf(TVector2D));
    ReconstructModel(true);
//      CalcNormals;
//      ReconstructModel(true);
//      AdjustNormals;

    for i:= 0 to FaceCount -1 do
    begin
           CalcTangentSpaceVectors(Vertex[ Faces[i][0] ], Vertex[  Faces[i][1]],   Vertex[Faces[i][2]],
                             TexCoord[ Faces[i][0] ], TexCoord[Faces[i][1]], TexCoord[Faces[i][2]],
                              P_Normal(Vertex[Faces[i][2]], Vertex[  Faces[i][1]],   Vertex[Faces[i][0]]),
                             Shader_Normal  [Faces[i][0]],
                             Shader_Binormal[Faces[i][0]],
                             Shader_Tangent [Faces[i][0]]);

                For i2 := 1 to 2 do
                begin
                  Shader_Tangent [Faces[i][i2]]  := Shader_Tangent [Faces[i][0]];
                  Shader_Binormal[Faces[i][i2]]  := Shader_Binormal[Faces[i][0]];
                  Shader_Normal  [Faces[i][i2]]  := Shader_Normal  [Faces[i][0]];
                end;
    end;

  end;

end;

procedure DrawShaderMesh(theObject: P3DObject);
begin
  with theobject^ do begin

    RenderShaderModel(Length(Vertex), GL_UNSIGNED_SHORT ,GL_Shader_Tangent, @Faces[0], @Vertex[0].x, @Shader_Normal[0].x,@Shader_Tangent[0].x,@Texcoord[0].x);
  end;
end;

{$EndRegion}

{$Region 'The Game System Utilites'}
Function MessageBox(S:String; _Type:byte):boolean;
begin
Result:=false;
 case _type of
  0: Windows.MessageBox(0,Pchar(s),PrjName,0);
  1: Windows.MessageBox(0,Pchar(s),PrjName,MB_OK or MB_ICONWARNING);
  2: Windows.MessageBox(0,Pchar(s),PrjName,MB_OK or MB_ICONERROR);
  3: Result := Windows.Messagebox(0,Pchar(S),PrjName,MB_YESNO) = 6;
 end;

end;

function NotFileExists(S:String):boolean;
begin
Result:=false;
if (S='') then            begin MessageBox('Not a file name ['+s+']',2);   result:=true; exit; end;
if not FileExists(S) then begin MessageBox('File not found:'+#13+#10+s,2); result:=true; exit; end;
end;

function FileExists(FileName: string): boolean;
var
 F: File;
begin
FileMode := 64;
AssignFile(F, FileName);
{$I-}
Reset(F);
{$I+}
Result:=IOResult=0;
if Result then
 CloseFile(F);
end;

function AnsiUpperCase(const S: string): string;
var
  Len: Integer;
begin
  Len := Length(S);
  SetString(Result, PChar(S), Len);
  if Len > 0 then CharUpperBuff(Pointer(Result), Len);
end;

Function SameText(A,B:String):Boolean;
begin
if AnsiUpperCase(a) = AnsiUpperCase(b) then result:=true else result:=false;
end;

function CompareMem(P1, P2: Pointer; Length: Integer): Boolean; assembler;
asm
        PUSH    ESI
        PUSH    EDI
        MOV     ESI,P1
        MOV     EDI,P2
        MOV     EDX,ECX
        XOR     EAX,EAX
        AND     EDX,3
        SAR     ECX,2
        JS      @@1     // Negative Length implies identity.
        REPE    CMPSD
        JNE     @@2
        MOV     ECX,EDX
        REPE    CMPSB
        JNE     @@2
@@1:    INC     EAX
@@2:    POP     EDI
        POP     ESI
end;

function IntToStr(Num : Integer) : String;
begin
  Str(Num, result);
end;

function StrToInt(const S: string): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
  if E <> 0 then Result:=0;
end;

function StrToIntDef(const S: string; Default: Integer): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
  if E <> 0 then Result := Default;
end;

function TrimLeft(const S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  Result := Copy(S, I, Maxint);
end;

function ExtractFilePath(const s: string): string;
var
i :integer;
begin
//    setlength(s,length(s)-1);
    for i :=length(s)-1 downto 1 do
    if s[i]='\' then
    begin
    result := copy(s,1,i);
    exit;
    end;
end;

function ExtractFileName(const s: string): string;
var
i :integer;
begin
Result:=S;
    for i :=length(s)-1 downto 1 do
    if s[i]='\' then
    begin
    result := copy(s,i+1,length(s)-1);
    exit;
    end;
end;

Function ParseStr(cmd: string):TStrParam;
var
  i,i2,
  c1,c2:integer;
  S : String;
  b : Boolean;
begin
  SetLength(Result,0);
  i := 1;
  b := false;
  c2:= pos('#',Cmd);
  if c2 = 0 then c2 := length(cmd);
  while (i<=C2) and (not b) do begin
    While (cmd[i]= ' ') and (i<=c2) do inc(i);
      if  (cmd[i]= '#') then exit else
       if (cmd[i]<>' ') then
        begin
          c1 := i;
          While (cmd[i]<>' ') and (i<=c2) do inc(i);
           S := Copy(cmd,c1,i-c1);
          if pos('#',s) <> 0 then SetLength(S,pos('#',s)-1);

          i2 := Length(Result);
          SetLength   (Result,i2+1);
          Result[i2] :=S;
          end;
    end;
end;

function ChangeFileExt(const FileName, Extension: string): string;
var
  I: Integer;
  S: String;
begin
I := POS('.',FileName);
s := Copy(FileName,1,i-1);
    Result:= S+Extension;
end;

function GetFileExt(const FileName: string): string;
var
  I: Integer;
  S: String;
begin
I := POS('.',FileName);
s := Copy(FileName,i+1,length(FileName));
    Result:= S;
end;

{$ENDREGION}

end.
