unit game_main;

interface
uses windows,game_variables,game_wnd,model4,
           t_player,game_bullets;

Procedure Init_Game;
procedure Game_Draw;

implementation

uses t_camera, OpenGL15, Engine , Shaders, Materials,textures;


  Const
    BoxSize = 1000;
    BoxMax : TVector = (x: BoxSize;y: 300;z: BoxSize);
    BoxMin : TVector = (x:-BoxSize;y: 100;z:-BoxSize);

var
  L : Array [0..3] of TLight;

Procedure Init_Game;
var i :integer;
begin
  PixelBuffer := TPixelBuffer.Create(256,256,h_dc,h_rc);
  wglShareLists(h_RC, PixelBuffer.RC);

  PixelBuffer.Enable;
    glEnable(GL_TEXTURE_2D);
    glEnable(GL_DEPTH_TEST);
    SetProjection(256,256,false);

    glClearColor(0.5,0.5,1,0);
    glClear(GL_Color_Buffer_bit or GL_DEPTH_BUFFER_BIT);
    GLLoadIdentity;
  PixelBuffer.Disable;

  glEnable   (GL_DEPTH_TEST);
  glDepthFunc(GL_LESS);
  glHint     (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
  glEnable   (GL_TEXTURE_2D);
  glEnable   (GL_CULL_FACE);
  glShadeModel(GL_SMOOTH);
  glClearDepth(1.0);

  ChangeFov(WIDTH,HEIGHT, 90);
  SetProjection(WIDTH,HEIGHT,FALSE);
  GLClearColor(0.3,0.3,0.3,0);


  GL_USE_MipMap:=true;

  //        !!!
  TheFont := FontCreate(h_wnd,'Courier New Cyr',10,256);

  ShadersDir := AppDir + 'shaders\';
  Init_Shaders;


  Level := T4Model.Create;
  Level.LoadFromFile(appdir+'Models\level.sm',appdir+'materials\');

  PLAYER.Init(vec3f(0,200,0));

  Model[0] := T4Model.Create;
  Model[1] := T4Model.Create;
  Model[0].LoadFromFile(appdir+'Models\player_all.sm',appdir+'materials\');
  Model[1].LoadFromFile(appdir+'Models\player_all_2.sm',appdir+'materials\');


//  LoadTexture('J:\Projects\Mars_carnage\materials\textures\Light.jpg',bullet_tex);


  cam.DST := 300;
  cam.Tilt :=70;
  cam.Init(player.pos,0,0);
  FrameTime:=16;
  LastTime:=GetTickCount;

  for i  := 0 to Length(L) - 1 do
  begin
    l[i].POS   := Vec3f( BoxMin.X+ random*(BoxMax.X-BoxMin.X),
                          BoxMin.y+ random*(BoxMax.y-BoxMin.y),
                          BoxMin.z+ random*(BoxMax.z-BoxMin.z) );
    l[i].Color := Vec3f((Random(128)+127) / 255,(Random(128)+127) / 255,(Random(128)+127) / 255);
    l[i].Radius:= 1000;
  end;

  player.onGround :=true;
  frametime :=16;
  lasttime:=0;
  Global_light.pos := vec3f(0,300,0);
  SetCursorPos(100,100);

end;

{ ------------------------------------------------------------------------ }
{ --   -------------------------------------------- }
{ ------------------------------------------------------------------------ }
Procedure Process;
begin
  player.Update;
  player.Heading := cam.Heading;
  player.Tilt    := cam.Tilt;
  cam.Update(player.pos);
  cam.UpdateMouse(100,100);

  if MWhell =1 then
  cam.DST := cam.dst -20;
  if MWhell =2 then
  cam.DST := cam.dst +20;
end;

Procedure RenderLevel;
var
    I :integer;
begin
    GLLoadIdentity;
    cam.SetView;
    CalculateFrustum;


    l[0].radius := abs(Sin( GetTickCount * 0.001)) * 1000 + 100;
    l[0].Color := vec3f(1,1,1);

                        if keys[ord('L')] then
                        l[0].pos:=cam.pos;

    for i := 0 to length(l) - 1 do
    begin
      glLight_Pos    (GL_Light0+i,l[i].pos);
      glLight_Color4f(gl_light0+i,l[i].Color,l[i].Radius);
    end;

     Level.ShaderRender(Mat_Lighting,false);
     global_light := l[0];

   player.RenderBullets;

 GLPushMatrix;

    CalculateFrustum;
    with player.pos do
    GLTranslateF(x,y,z);
    Model[0].ShaderRender(Mat_Lighting,false);
    GLTranslateF(0,30,0);
    Model[1].ShaderRender(Mat_Lighting,false);
 glpopmatrix;
 glcolor3F(1,1,1);
{

     glpointsize(10);
   for i := 0 to Length(l) - 1 do
   begin
     glbegin(gl_Points);
     glvertex3fv(@l[i].POS);
     glend;
   end;
 }


end;

procedure Game_Draw;
begin
  SetProjection(width,height,false);
  glClear(GL_Color_Buffer_bit or GL_DEPTH_BUFFER_BIT);
    RenderLevel;

  SetProjection(width,height,true);
  TextOut(TheFont,0,10,10,'FPS: '+inttostr(fps));

  TextOut(TheFont,0,10,175,'Y:'+inttostr(round(cam.Heading)) + ' X:'+inttostr(round(cam.tilt)));
  with cam.pos do
  TextOut(TheFont,0,10,195,'x: '+inttostr(round(x)) + ' y:'+inttostr(round(y))+ ' z:'+inttostr(round(z) ));
  TextOut(TheFont,0,10,215,'[L] - set light [0] pos');

  TextOut(TheFont,0,width *0.5 -60,height - 20,'Made by SVSD_VAL');
  Process;
end;


end.