unit shaders;
{
  Made By SVSD_VAL
   Site   : SVSD.MirGames.Ru
   ICq    : 223-725-915
   Mail   : ValDIm_05@mail.ru / SVSD_VAL@SibNet.ru
   Jabber : svsd_val@Jabber.Sibnet.ru
}

interface
uses OpenGL15,Engine;

 Const
    GLSL_Bump       = 0;
    GLSL_Bump_Illum = 1;
    GLSL_Parallax   = 2;
    GLSL_Scroll     = 3;

var

 ShaderList : Array [0..5] of PShader;
 ShadersDir : String;



 procedure SetLightOptionsOnInit();
 procedure glLight_Pos(ID: integer; Pos:TVector);
 procedure glLight_Color(ID: integer; R, G, B: single);overload
 procedure glLight_Color(ID: integer; clr:TVector); overload
 procedure glLight_Color4f(ID: integer; clr:TVector;R:Single);
 procedure glLight_cfg(ID: integer);

Function Get_Shader(S : String):Pshader;
Procedure Stop_Shaders;
Procedure Init_Shaders;
Procedure Update_Shader;
implementation
uses game_variables;

Procedure Update_Shader;
//var i :integer;
begin
//   glLight_Pos(GL_Light0,Global_light.pos);
//    glLight_Color4f(gl_light0,global_light.Color,global_light.Radius);

//    for i := GLSL_Bump to GLSL_Bump_add do
//    with ShaderList[i]^ do
//    begin
//     Start;
//      BindUniform('light_radius', @global_light.radius,1);
//     Stop;
//    end;
end;


Function Get_Shader(S : String):Pshader;
begin
    Result:=Nil;
 if SameText(S,'glsl_bump')     then Result:=ShaderList[GLSL_BUMP];
 if SameText(S,'glsl_bump_add') then Result:=ShaderList[GLSL_Bump_Illum];
 if SameText(S,'glsl_parallax') then Result:=ShaderList[GLSL_Parallax];
 if SameText(S,'glsl_scroll')   then Result:=ShaderList[GLSL_Scroll];
end;

Procedure Stop_Shaders;
var i  :integer;
begin
 for i := 0 to Length(ShaderList) - 1 do
   ShaderList[i].Stop;

end;

Procedure Shader_Parallax_Init;
begin
  // 
  New(ShaderList[GLSL_Parallax]);
  // 
  with ShaderList[GLSL_Parallax]^ do
  begin
    Load(ShadersDir+'shader_ml.fp', GL_FRAGMENT_SHADER_ARB,'#define PARALLAX;');
    Load(ShadersDir+'shader_ml.vp', GL_VERTEX_SHADER_ARB);

  // 
    Compile;

  //     :)
  Start;
  //     
   Tangent := GetAttrib('tangent');
  //     SetUniform  BIND (  ,       )
    SetUniform(GetUniform('color_map'),0);
    SetUniform(GetUniform('normal_map'),1);
    SetUniform(GetUniform('height_map'),2);
    SetUniform(GetUniform('exponent'),48.0);

  Stop;
  end;

end;

Procedure Shader_Bump_Init;
const
  _exponent       : Single  = 48.0;
begin
  // 
  New(ShaderList[GLSL_Bump]);
  with ShaderList[GLSL_Bump]^ do
  begin
    Load(ShadersDir+'shader_ml.fp', GL_FRAGMENT_SHADER_ARB);//,'#define SPECULAR;');
    Load(ShadersDir+'shader_ml.vp', GL_VERTEX_SHADER_ARB);

  // 
    Compile;

  //     :)
  Start;
  //     
   Tangent := GetAttrib('tangent');
  //     SetUniform  BIND (  ,       )
    SetUniform(GetUniform('color_map'),0);
    SetUniform(GetUniform('normal_map'),1);
    SetUniform(GetUniform('height_map'),2);

//    SetUniform(GetUniform('illum_map') ,2);
    SetUniform(GetUniform('specular_map'),2);


    SetUniform(GetUniform('exponent'),48.0);

  Stop;
  end;
end;


Procedure Shader_Bump_add_Init;
const
  _exponent       : Single  = 48.0;
begin
  // 
   New(ShaderList[GLSL_Bump_Illum]);
  with ShaderList[GLSL_Bump_Illum]^ do
  begin
    Load(ShadersDir+'shader_ml.fp' , GL_FRAGMENT_SHADER_ARB,'#define ILLUM;');
    Load(ShadersDir+'shader_ml.vp' , GL_VERTEX_SHADER_ARB);

  // 
    Compile;

  //     :)
  Start;
  //     
   Tangent := GetAttrib('tangent');
  //     SetUniform  BIND (  ,       )
    SetUniform(GetUniform('color_map'),0);
    SetUniform(GetUniform('normal_map'),1);
    SetUniform(GetUniform('illum_map'),2);

    SetUniform(GetUniform('exponent'),48.0);

  Stop;
  end;
end;


Procedure Shader_Scroll_Init;
begin
  // 
  New(ShaderList[GLSL_Scroll]);
  with ShaderList[GLSL_Scroll]^ do
  begin
    Load(ShadersDir+'scroll.fp', GL_FRAGMENT_SHADER_ARB);
    Load(ShadersDir+'scroll.vp', GL_VERTEX_SHADER_ARB);

  // 
    Compile;

  //     :)
  Start;
  //     SetUniform  BIND (  ,       )
    SetUniform(GetUniform('color_map'),0);
    SetUniform(GetUniform('uv_scroll'),1);
  Stop;
  end;
end;

Procedure Init_Shaders;
begin
  Shader_Bump_Init;
  Shader_Bump_add_Init;

  Shader_Parallax_Init;
  Shader_Scroll_Init;
//  Shader_Fix_Init;

  SetLightOptionsOnInit;
end;


procedure SetLightOptionsOnInit();
{
 const material_specular : Array[0..3] of Single = (1, 1, 1, 1);
       material_shininess: Array[0..0] of Single = (128);
       material_ambient  : Array[0..3] of Single = (0.4, 0.4, 0.4, 1);
       material_diffuse  : Array[0..3] of Single = (1, 1, 1, 1);

       light_position    : Array[0..3] of Single = (0, 0, 0, 1);
       light_ambient     : Array[0..3] of Single = (0.1, 0.1, 0.1, 1);
       light_diffuse     : Array[0..3] of Single = (0.8, 0.8, 0.8, 1);
       light_specular    : Array[0..3] of Single = (0.8, 0.8, 0.8, 1);
       }
 const material_specular : Array[0..3] of Single = (1, 1, 1, 1);
       material_shininess: Array[0..0] of Single = (128);
       material_ambient  : Array[0..3] of Single = (0.4, 0.4, 0.4, 1);
       material_diffuse  : Array[0..3] of Single = (1, 1, 1, 1);

       light_position    : Array[0..3] of Single = (0, 0, 0, 1);
       light_ambient     : Array[0..3] of Single = (0.1, 0.1, 0.1, 1);
       light_diffuse     : Array[0..3] of Single = (1, 1, 1, 1);
       light_specular    : Array[0..3] of Single = (1, 1, 1, 1);

begin
 glEnable(GL_LIGHT0);

 glMaterialfv(GL_FRONT, GL_SPECULAR , @material_specular[0]);
 glMaterialfv(GL_FRONT, GL_SHININESS, @material_shininess[0]);
 glMaterialfv(GL_FRONT, GL_AMBIENT  , @material_ambient[0]);
 glMaterialfv(GL_FRONT, GL_DIFFUSE  , @material_diffuse[0]);

 glLightfv(GL_LIGHT0 , GL_POSITION, @light_position[0]);
 glLightfv(GL_LIGHT0 ,  GL_AMBIENT, @light_ambient[0]);
 glLightfv(GL_LIGHT0 ,  GL_DIFFUSE, @light_diffuse[0]);
 glLightfv(GL_LIGHT0 , GL_SPECULAR, @light_specular[0]);
end;

procedure glLight_cfg(ID: integer);
const
 light_position : array [0..3] of single = (1, 1, 1, 0);
 white_light    : array [0..3] of single = (1, 1, 1, 1);
begin
glLightfv(ID, GL_POSITION, @light_position);
glLightfv(ID, GL_DIFFUSE,  @white_light);
glLightfv(ID, GL_SPECULAR, @white_light);
glLightfv(ID, GL_AMBIENT , @white_light);
//glLightf(ID, GL_SPOT_EXPONENT , 0.000001);

end;

procedure glLight_Pos(ID: integer; Pos:TVector);
var
 p : array [0..3] of single;
begin
p[0] := pos.X;
p[1] := pos.Y;
p[2] := pos.Z;
p[3] := 1;
glLightfv(ID, GL_POSITION, @p);
end;

procedure glLight_Color(ID: integer; R, G, B: single); overload
var
 c : array [0..3] of single;
begin
c[0] := R;
c[1] := G;
c[2] := B;
c[3] := 1;
glLightfv(ID, GL_DIFFUSE,  @c);
glLightfv(ID, GL_SPECULAR, @c);
end;

procedure glLight_Color(ID: integer; clr:TVector); overload
var
 c : array [0..3] of single;
begin
c[0] := clr.x;
c[1] := clr.y;
c[2] := clr.z;
c[3] := 1;
glLightfv(ID, GL_DIFFUSE,  @c);
glLightfv(ID, GL_SPECULAR, @c);
end;

procedure glLight_Color4f(ID: integer; clr:TVector;R:Single);
var
 c : array [0..3] of single;
begin
c[0] := clr.x;
c[1] := clr.y;
c[2] := clr.z;
c[3] := R;
glLightfv(ID, GL_DIFFUSE,  @c);
glLightfv(ID, GL_SPECULAR, @c);
end;

end.
