unit t_player;
{$Warnings off}
{$Hints on}

interface

uses
 Windows,OpenGL,Engine,l_math,game_variables,model4,game_bullets;

type
 // 
 TPlayer = object
  public
   Pos,
   ACC,
   Speed    : TVector;
   Tilt,
   Heading,
   health   : single;
   Bullets  : Array [0..10] of TBullet;
   onGround : boolean;

   procedure Init(P:Tvector);
   procedure Update;
   procedure RenderBullets;
 end;

const
 PKEY_FORW   = ORD('W');
 PKEY_BACK   = ORD('S');
 PKEY_LEFT   = ORD('A');
 PKEY_RIGHT  = ORD('D');
 PKEY_JUMP   = ORD(' ');

VAR
 PLAYER     : TPLAYER;
 Model      : Array [0..1] of T4Model;

implementation

procedure TPlayer.Init(P:Tvector);
begin
Pos     := p;
Heading := 0;
Tilt    := 0;
acc     := Vector(0, 0, 0);
Speed   := Vector(0, 0, 0);
Health  := 100;
onground:= true;
end;


procedure TPlayer.RenderBullets;
begin
  bullets[0].POS := vec3f(0,100,0);
  bullets[0].used :=true;
  Bullet_Render(@bullets[0],length(bullets));
end;


procedure TPlayer.Update;

 Function Shot:Integer;
 begin
 end;

var
 RSpeedT  : Single;
 n:tvector;

begin
RSpeedT:=FrameTime/30;

// SHOOT WEAPON
{------------------------------------------------------------------------------}
{----------------------------------------------------------------------}
{------------------------------------------------------------------------------}
  if (GetAsyncKeyState(vk_Lbutton) <> 0) then
  begin
   Shot;

  end;

  if keys[ord('F')] then onGround:=true;
  if onGround  then
 begin
   acc   :=vector(0,0,0);
   Speed :=vector(0,0,0);

   if Keys[PKEY_FORW ] then acc   := V_Add(acc, Vector( sin( Heading    *pi/180), 0 ,-cos( Heading    *pi/180)));
   if Keys[PKEY_BACK ] then acc   := V_Add(acc, Vector(-sin( Heading    *pi/180), 0 , cos( Heading    *pi/180)));
   if Keys[PKEY_LEFT ] then acc   := V_Add(acc, v_mult(Vector(-sin((Heading+90)*pi/180), 0 , cos((Heading+90)*pi/180)),0.7));
   if Keys[PKEY_RIGHT] then acc   := V_Add(acc, v_mult(Vector( sin((Heading+90)*pi/180), 0 ,-cos((Heading+90)*pi/180)),0.7));
   if Keys[VK_Shift]   then acc   := v_mult(acc,2);
   if Keys[PKEY_JUMP ] then Acc.Y := 1;
 end;

// GRAVITY
{------------------------------------------------------------------------------}
{--------------------------------------------------------------------}
{------------------------------------------------------------------------------}
 if not onground then
 Acc.y  := Acc.Y - (frametime*0.003);

// BUILD CUR. POS AND CHECKING "WE ON THE GROUND" ?
{------------------------------------------------------------------------------}
{-        ?-------------------}
{------------------------------------------------------------------------------}
 Speed    := V_mult(acc, RSpeedT*6);
 Pos      := V_Add (Pos,  Speed);

// CHECKING COLLISION
{------------------------------------------------------------------------------}
{- --------------------------------------------------------}
{------------------------------------------------------------------------------}
 onground := level.Collision(Pos,n,acc,25.1);

end;

end.
