{*********************************************************
 *     BMP / JPG / GIF / TGA / TEX, 	         **
 *                                                        *
 **********************************************************
}
{$Warnings off}
{$Hints on }
unit Textures;
{
  Made By SVSD_VAL
   Site   : SVSD.MirGames.Ru
   ICq    : 223-725-915
   Mail   : ValDIm_05@mail.ru / SVSD_VAL@SibNet.ru
   Jabber : svsd_val@Jabber.Sibnet.ru
}

interface

uses
  Windows, OpenGL15 ,Engine;

type
  TTexMode   = (TM_COLOR = 1, TM_DEPTH = 2);
var
  GL_USE_MipMap : boolean;

{------------------------------------------------------------------------------}
{--Textures arrays ------------------------------------------------------------}
{------------------------------------------------------------------------------}
Procedure DeleteTexture(GL_ID:Cardinal);
Procedure FreeTextures;
Procedure AddToTextureList(const GLID:Cardinal);


{------------------------------------------------------------------------------}
{--Generation textures---------------------------------------------------------}
{------------------------------------------------------------------------------}
function  TexNewID(clamp, mipmap: Boolean): Cardinal;
function  CreateTexture(Width, Height, Format : Word; pData : Pointer) : Integer;

{------------------------------------------------------------------------------}
{--Activating / deactivating textures -----------------------------------------}
{------------------------------------------------------------------------------}
procedure Texture_Disable(const Channel: Integer);
procedure Texture_Enable(const ID: Cardinal; const Channel: Integer);

{------------------------------------------------------------------------------}
{--Loading textures------------------------------------------------------------}
{------------------------------------------------------------------------------}
function LoadTexture  (Filename: String; var Texture : cardinal;Alpha:boolean=false;Color:integer=0;Quality:integer=0) : Boolean;
function LoadTextureEx(Filename: String; var W,H,BPP:Integer; var pData : PByteArray) : Boolean;
Function SaveTexture(Fname:String;W, H ,bpp:Word;Data : PByteArray) : Integer;
function  LoadBJG(const FileName: PChar; var Width, Height, BPP: Integer; var Data: PByteArray): Boolean;
function LoadBJGmem(mem: Pointer; Size: Integer; var Width, Height, BPP: Integer; var Data: PByteArray): Boolean;
Function LoadTextureFromMem(const Data:Array of byte):Integer;




implementation

type
 TTexture         = Record
  GL_ID           : Cardinal;
 end;

var
  GL_Textures      : Array of TTexture;

{------------------------------------------------------------------}
{  Create the Texture                                              }
{------------------------------------------------------------------}

Procedure AddToTextureList(const GLID:Cardinal);
var i : integer;
begin
 I := Length(GL_Textures);
 SetLength(GL_Textures,i+1);
 GL_Textures[i].GL_ID  := glid;
end;

Procedure FreeTextures;
var i : integer;
begin
  for i := 0 to Length(GL_Textures)-1 do
  glDeleteTextures(1,@GL_Textures[i].GL_ID);
  SetLength(GL_Textures,0);
end;

Procedure DeleteTexture(GL_ID:Cardinal);
var i : integer;
begin
  for i := 0 to Length(GL_Textures)-1 do
  if GL_Textures[i].GL_ID = GL_ID then
  begin
    glDeleteTextures(1,@GL_Textures[i].GL_ID);
    GL_Textures[i] :=  GL_Textures[length(GL_Textures)-1];
    setlength (GL_Textures, length(GL_Textures)-1);
    exit;
  end;
end;
{------------------------------------------------------------------}
{  Create the Texture                                              }
{------------------------------------------------------------------}

function TexNewID(clamp, mipmap: Boolean): Cardinal;
var
id:cardinal;
begin
//==      
  begin
    glGenTextures(1, @ID);
    glBindTexture(GL_TEXTURE_2D, ID);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

    if clamp then
    begin
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
    end else
    begin
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    end;

    if mipmap then
      glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR)
    else
      glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
      glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);

    Result := ID;
    AddToTextureList(id);
  end;
end;


function CreateTexture(Width, Height, Format : Word; pData : Pointer) : Integer;
var
  Texture : Cardinal;
begin

  Texture := TexNewID(False,GL_USE_MipMap);

// if GL_MaxAnisotropy < ANISOTROPYCount then ANISOTROPYCount:= GL_MaxAnisotropy;
// if ANISOTROPYCount>0 then glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, ANISOTROPYCount);
  case Format of
  GL_RGBA: gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, Width, Height, GL_RGBA, GL_UNSIGNED_BYTE,  pData);
  GL_RGB : gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB , Width, Height, GL_RGB , GL_UNSIGNED_BYTE,  pData);
  GL_BGRA: gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGBA, Width, Height, GL_BGRA, GL_UNSIGNED_BYTE,  pData);
  GL_RGB8: gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB8, Width, Height, GL_RGB , GL_UNSIGNED_BYTE,  pData);
  GL_LUMINANCE_ALPHA: gluBuild2DMipmaps(GL_TEXTURE_2D, 2, Width, Height, GL_LUMINANCE_ALPHA, GL_UNSIGNED_BYTE, pData);
  end;
  result :=Texture;
end;



procedure Texture_Enable(const ID: Cardinal; const Channel: Integer);
begin
  glActiveTextureARB(GL_TEXTURE0_ARB + Channel);
  glEnable(GL_TEXTURE_2D);
//     -    
  if (ID = 0) or not glIsTexture(ID) then
  glBindTexture(GL_TEXTURE_2D, 0) else
  glBindTexture(GL_TEXTURE_2D, ID);
end;

procedure Texture_Disable(const Channel: Integer);
begin
  glActiveTextureARB(GL_TEXTURE0_ARB + Channel);
//  glBindTexture(GL_TEXTURE_2D, 0);
  glDisable(GL_TEXTURE_2D);
end;

Function SaveTexture(Fname:String;W, H ,bpp :Word;Data : PByteArray) : Integer;
var
 F : File Of Byte;

  BMP : packed record
    bfType          : Word;
    bfSize          : DWORD;
    bfReserved1     : Word;
    bfReserved2     : Word;
    bfOffBits       : DWORD;
    biSize          : DWORD;
    biWidth         : Integer;
    biHeight        : Integer;
    biPlanes        : Word;
    biBitCount      : Word;
    biCompression   : DWORD;
    biSizeImage     : DWORD;
    biXPelsPerMeter : Integer;
    biYPelsPerMeter : Integer;
    biClrUsed       : DWORD;
    biClrImportant  : DWORD;
  end;

begin
assignfile(f,Fname);
rewrite(f);

if bpp<3 then bpp:=3;
    with BMP do
    begin
      bfType          := $4D42;
      bfSize          := w * h * bpp + SizeOf(BMP);
      bfReserved1     := 0;
      bfReserved2     := 0;
      bfOffBits       := SizeOf(BMP);
      biSize          := SizeOf(BITMAPINFOHEADER);
      biWidth         := w;
      biHeight        := h;
      biPlanes        := 1;
      biBitCount      := bpp*8;
      biCompression   := 0;
      biSizeImage     := w * h * bpp;
      biXPelsPerMeter := 0;
      biYPelsPerMeter := 0;
      biClrUsed       := 0;
      biClrImportant  := 0;
      blockwrite(F, BMP, SizeOf(BMP));
    end;

    blockwrite(f,data^[0],w*h*bpp);
closefile(f);
end;

Procedure ScaleTexture(const PW,PH,Bpp,MaxSize :integer; const PData : PByteArray; var W,H:Integer; var CData : PByteArray);
var
  ScaleF: single;
  X, Y , C,C2 : integer;
  TD : PByteArray;
Begin
  IF PW > MaxSize then W := MaxSize;
  IF PH > MaxSize then H := MaxSize;
  ScaleF := Pw/MaxSize;

  if PW > -1 then
  begin
     GetMem(TD, W*H*bpp);

     For X := 0 to W-1 do
     For Y := 0 to H-1 do
     begin
     C  := (Y*W+X)*bpp;
     C2 := round(   (Y*(PW*ScaleF)) + (X)*ScaleF  ) * bpp;

        TD^[c]   := PData^[c2];
        TD^[c+1] := PData^[c2+1];
        TD^[c+2] := PData^[c2+2];
        TD^[c+3] := PData^[c2+3];
     end;
     GetMem(CData, W*H*Bpp);
     For Y := 0 to W*H*Bpp do
      cData^[Y] := Td^[Y];

      SaveTexture('test3.bmp',w, h,bpp,TD);

     FreeMem(TD, W*H*Bpp);

  end;
end;

{-----------------------------------}
{     BGRA  RGBA }
{-----------------------------------}

procedure SwapRGBA(data : Pointer; size : Integer);
asm
  mov ebx, eax    // data
  mov ecx, edx    // Size

@@loop :
  mov al,[ebx+0]  // Red										// Loads Value At ebx Into al
  mov ah,[ebx+2]  // Blue										// Loads Value At ebx+2 Into ah
  mov    [ebx+2],al										// Stores Value In al At ebx+2
  mov    [ebx+0],ah										// Stores Value In ah At ebx

  add ebx,4										  // Moves Through The Data By 3 Bytes
  dec ecx												// Decreases Our Loop Counter
  jnz @@loop
end;
{

procedure SwapRGB(pdata : pbytearray; size : Integer);
var
I:Integer;
R,B: Byte;
begin
    for i := 0 to size -1 do
    begin
      b:=pdata[i*4   ];
//    g:=pdata[i*4+1 ];
      r:=pdata[i*4+2 ];

      pdata[i*4   ]:=r;
//    pdata[i*4+1 ]:=g;
      pdata[i*4+2 ]:=b;
    end
end;}

Function LoadTextureFromMem(const Data:Array of byte):Integer;
Var W,H,B: Integer;
  Texture: PByteArray;
begin
 LoadBJGmem(@Data,SizeOF(Data),w,h,b,Texture);
 Result:=CreateTexture(w, h, GL_BGRA ,Texture);
end;

function LoadBMP_JPG_GIF_Texture(Filename: String; var Texture : cardinal;Alpha:boolean;Color,Quality:Integer) : Boolean;
var
  W,H,BPP,i,pr,pg,pb:integer;
  pData : PByteArray;
begin

    LoadBJG(Pchar(FileName),W,H,BPP,pdata); // -  Xproger'a (=   )
    if alpha then
    for i := 0 to w*h do
    begin
       pb:=abs(pdata[i*4   ] - GetBValue(Color));
       pg:=abs(pdata[i*4+1 ] - GetGValue(Color));
       pr:=abs(pdata[i*4+2 ] - GetRValue(Color));
      if Quality < 1 then
      if pdata[i*4   ] = GetBValue(Color) then
      if pdata[i*4+1 ] = GetGValue(Color) then
      if pdata[i*4+2 ] = GetRValue(Color) then
         pdata[i*4+3]:= 0;

      if Quality > 1 then
      if (pr <=Quality) then
      if (pg <=Quality) then
      if (pb <=Quality) then
         pdata[i*4+3]:= 0;

    end;

//    if is12OpenGL then
//    begin
//  SwapRGBA(pData,W*H);
//  Texture :=CreateTexture(W, H, GL_RGBA, pData);
//    end
//    else

    Texture :=CreateTexture(W, H, GL_BGRA, pData);
    FreeMem(pData);
    result :=TRUE;
end;

{------------------------------------------------------------------}
{  TGA textures                                                    }
{------------------------------------------------------------------}
function LoadTGATexture( filename : string; var Texture: Cardinal;Alpha:boolean;Color,Quality:Integer) : boolean;			// Loads A TGA File Into Memory
const
TGAheader     : array [0..11] of GLubyte = (0,0,2,0,0,0,0,0,0,0,0,0);	// Uncompressed TGA Header
TGAComheader  : array [0..11] of GLubyte = (0,0,10,0,0,0,0,0,0,0,0,0);	// Compressed TGA Header
var
  TGAcompare    : array [0..11] of Byte;   // Used To Compare TGA Header
  header        : array [0..5] of Byte;    // First 6 Useful Bytes From The Header
  bytesPerPixel : Cardinal;					    // Holds Number Of Bytes Per Pixel Used In The TGA File
  imageSize     : Cardinal;							// Used To Store The Image Size When Setting Aside Ram
  i             : Cardinal;							// Temporary Variable
  gltype        : Cardinal;					    // Set The Default GL Mode To RBGA (32 BPP)
  Compressed    : boolean;
  Tm            : Char;
  ColorBuffer   : Pchar;

  tgafile       : file;

  ChunkHeader   : Byte;
  PixelCount,
  CurrentPixel,
  CurrentByte   : Cardinal;
  Counter, Ret  : integer;

	imageData     : PChar;                // Image Data (Up To 32 Bits)
  AlphaImgData  : PByteArray;

	bpp           : Cardinal;             // Image Color Depth In Bits Per Pixel.
	width         : Cardinal;             // Image Width
	height        : Cardinal;             // Image Height
  pr,pg,pb,
  r,g,b         : byte;
begin
  if not fileexists(filename) then exit;
  AssignFile(TGAFile, Filename);
  Reset(TGAFile, 1);

  BlockRead(tgafile, TGAcompare, sizeof(TGAcompare),ret);

  if (Ret <> sizeof(TGAcompare)) then// Are There 12 Bytes To Read?
  begin
      CLoseFile(tgafile);								// If Anything Failed, Close The File
      result := false;									// Return False
      exit;
  end;

   if (CompareMem(@TGAComheader, @TGAcompare, 7) = True) Then
      Compressed := True else Compressed:= false;

   BlockRead(tgafile, header, sizeof(header),ret);
   if (ret <> sizeof(header)) then
   begin
       closefile(tgafile);              // If Anything Failed, Close The File
       result := false;									// Return False
       exit;
   end;

  width  := header[1] * 256 + header[0];			// Determine The TGA Width	(highbyte*256+lowbyte)
  height := header[3] * 256 + header[2];			// Determine The TGA Height	(highbyte*256+lowbyte)

  if (width <= 0)	or								// Is The Width Less Than Or Equal To Zero
     (height <= 0)	or								// Is The Height Less Than Or Equal To Zero
     ((header[4] <> 24) and (header[4] <> 32)) then					// Is The TGA 24 or 32 Bit?
  begin
    closefile(tgafile);										// If Anything Failed, Close The File
    result := false;										// Return False
    exit;
  end;

  bpp	:= header[4];							// Grab The TGA's Bits Per Pixel (24 or 32)
  bytesPerPixel	:= bpp div 8;						// Divide By 8 To Get The Bytes Per Pixel
  imageSize	:= width * height * bytesPerPixel;	// Calculate The Memory Required For The TGA Data


  GetMem(imageData, imageSize);		// Reserve Memory To Hold The TGA Data
  //Setlength(texture.imagedata, imagesize);
  if Not Compressed then
  begin

  BlockRead(tgafile, imageData^, integer(imageSize),ret);
   if (imageData = nil)or //	       // Does The Storage Memory Exist?
    (ret <> imageSize)   	// Does The Image Size Match The Memory Reserved?
      then
      begin
        if (imageData <> nil)						// Was Image Data Loaded
           then freemem(imageData);						// If So, Release The Image Data

        closefile(tgafile);										// Close The File
        result := false;										// Return False
        exit;
      end;

    i := 0;
    while i < imageSize do
    begin
     Tm := ImageData[I+2];
     imageData[i+2] := imageData[i];					// Set The 3rd Byte To The Value In 'temp' (1st Byte Value)
     imageData[i] := Tm;                          // Set The 1st Byte To The Value Of The 3rd Byte

     i := i + bytesPerPixel;
    end;

 end
 else  //COMPRESSED TGA'S
 begin
   PixelCount := width * Height;
   CurrentPixel := 0;
   CurrentByte := 0;
   GetMem(ColorBuffer, BytesPerPixel);

   Repeat
      ChunkHeader := 0;
      BlockRead(tgaFile, ChunkHeader, sizeof(gluByte),ret);
      if  ret = 0 then
      begin
        //ERROR reading Chunk!
        closefile(tgafile);
        result := false;										// Return False
        exit;
      end;


      if ChunkHeader < 128 then
      begin
         ChunkHeader := ChunkHeader + 1;
         For Counter := 0 to ChunkHeader-1 do
         begin
         blockread(tgafile, ColorBuffer^, BytesPerPixel,ret);
            if ret <> BytesPerPixel then
            begin
             CloseFile(tgafile);										// Close The File
             result := false;										// Return False
             exit;
            end;

            imageData[CurrentByte] := (ColorBuffer[2]);
            imageData[CurrentByte+1] := (ColorBuffer[1]);
            imageData[CurrentByte+2] := (ColorBuffer[0]);
            if BytesPerPixel = 4 then
            imageData[CurrentByte+3] := (ColorBuffer[3]);

            CurrentByte := CurrentByte + bytesPerPixel;
            inc(CurrentPixel);
            if CurrentPixel > PixelCount then
            begin
             closefile(tgafile);										// Close The File
             result := false;										// Return False
             exit;
            end;
         end;
      end
      else //Chunkheader > 128
      begin
         ChunkHeader := ChunkHeader - 128;
         BlockRead(tgafile, ColorBuffer^, BytesPerPixel,ret);
         if ret <> BytesPerPixel then
         begin
          closefile(tgafile);                 // Close The File
          result := false;                    // Return False
          exit;
         end;
         For Counter := 0 to ChunkHeader do
         begin
            imageData[CurrentByte] := ColorBuffer[2];
            imageData[CurrentByte+1] := ColorBuffer[1];
            imageData[CurrentByte+2] := ColorBuffer[0];
            if BytesPerPixel = 4 then
            imageData[CurrentByte+3] := ColorBuffer[3];

            CurrentByte := CurrentByte + bytesPerPixel;
            inc(CurrentPixel);
         end;

      end;
   Until CurrentPixel >= PixelCount;
 end;
 closefile (tgafile);											// Close The File

  if not alpha then
  begin
  if bpp = 24 then									              // Was The TGA 24 Bits
            gltype := GL_RGB else
            gltype := GL_RGBA;										// If So Set The 'type' To GL_RGB
  Texture := CreateTexture(Width, Height, gltype, Imagedata);
  freemem(Imagedata);
  end else
  if alpha then
  begin
   imageSize	:= width * height * 4;
   gltype := GL_RGBA;										// If So Set The 'type' To GL_RGB
   GetMem(AlphaImgData,imageSize);

    for i := 0 to width*height do
    begin
      case bpp of
        24:begin
             pr:=abs(ord(Imagedata[i*3   ]) - GetRValue(Color));
             pg:=abs(ord(Imagedata[i*3+1 ]) - GetGValue(Color));
             pb:=abs(ord(Imagedata[i*3+2 ]) - GetBValue(Color));
              r:=ord(Imagedata[i*3   ]);
              g:=ord(Imagedata[i*3+1 ]);
              b:=ord(Imagedata[i*3+2 ]);

         end;
        32:begin
             pr:=abs(ord(Imagedata[i*4   ]) - GetRValue(Color));
             pg:=abs(ord(Imagedata[i*4+1 ]) - GetGValue(Color));
             pb:=abs(ord(Imagedata[i*4+2 ]) - GetBValue(Color));
              r:=ord(Imagedata[i*4   ]);
              g:=ord(Imagedata[i*4+1 ]);
              b:=ord(Imagedata[i*4+2 ]);
           end;
       end;

      AlphaImgData[i*4   ] := pr;
      AlphaImgData[i*4+1 ] := pg;
      AlphaImgData[i*4+2 ] := pb;
      AlphaImgData[i*4+3 ] := 125;
      if Quality < 1 then
      if AlphaImgData[i*4   ] = GetBValue(Color) then
      if AlphaImgData[i*4+1 ] = GetGValue(Color) then
      if AlphaImgData[i*4+2 ] = GetRValue(Color) then
         AlphaImgData[i*4+3]:= 0;

      if Quality > 1 then
      if (pr <=Quality) then
      if (pg <=Quality) then
      if (pb <=Quality) then
         AlphaImgData[i*4+3]:= 0;

    end;

  Texture := CreateTexture(Width, Height, gltype, AlphaImgData);
  freemem(AlphaImgData);
  end;

  result  := true;											            // Texture Building Went Ok, Return True
end;


{------------------------------------------------------------------}
{  TEX - Serios Sam Textures                                       }
{------------------------------------------------------------------}
function LoadTexTexture( filename : string; var Texture: Cardinal;Alpha:boolean;Color,Quality:Integer) : boolean;			// Loads A TGA File Into Memory
Var
 F      : File Of Byte;

 Header : Record
  TVER    : array [0..3] of char;
  Version : Integer;
  TDat    : array [0..3] of char;
  imgbpp  : Integer;
  Width   : integer;
  Height  : integer;
  Unknow2 : Integer;
  Stepen  : Integer;
  FCount  : Integer;
  FRMS    : array [0..3] of char;
 end;
  i,
  bpp     : Integer;
 ImgData,
 imgdata32: PByteArray;
  pr,pg,pb: byte;

begin
AssignFile(F,Filename);
Reset(f);
BlockRead(F,Header,SizeOf(Header));
if header.imgbpp in [2,0] then bpp:=3 else bpp:=4;

with Header do
  begin
    Width  := Width  div (1 shl Stepen);
    Height := Height div (1 shl Stepen);
  end;

getmem(ImgData,Header.width*Header.Height*BPP);
BlockRead(F,ImgData^,Header.width*Header.Height*BPP);

 if alpha then
 begin
    getmem(imgdata32,Header.width*Header.Height*4);

    for i := 0 to Header.width*Header.Height do
    begin
       ImgData32[i*4   ] := ImgData[i*BPP  ];
       ImgData32[i*4+1 ] := ImgData[i*BPP+1];
       ImgData32[i*4+2 ] := ImgData[i*BPP+2];

       pb:=abs(ImgData32[i*BPP   ] - GetRValue(Color));
       pg:=abs(ImgData32[i*BPP+1 ] - GetGValue(Color));
       pr:=abs(ImgData32[i*BPP+2 ] - GetBValue(Color));
      if Quality < 1 then
      if ImgData32[i*BPP   ] = GetRValue(Color) then
      if ImgData32[i*BPP+1 ] = GetGValue(Color) then
      if ImgData32[i*BPP+2 ] = GetBValue(Color) then
         ImgData32[i*BPP+3]:= 0;

      if Quality > 1 then
      if (pr <=Quality) then
      if (pg <=Quality) then
      if (pb <=Quality) then
         ImgData32[i*BPP+3]:= 0;
    end;

    Texture :=CreateTexture(Header.width, Header.Height, GL_RGBA, ImgData32);
 end else
 begin
    if bpp=3 then
    Texture :=CreateTexture(Header.width, Header.Height, GL_RGB, ImgData) else
    Texture :=CreateTexture(Header.width, Header.Height, GL_RGBA, ImgData);
 end;

end;

function LoadTexture  (Filename: String; var Texture : cardinal;Alpha:boolean=false;Color:integer=0;Quality:integer=0) : Boolean;
Var S: String;
begin
  if NotFileExists(FileName) then exit;

      S:= copy(AnsiUpperCase(filename), length(filename)-3, 4);
  if (S = '.BMP') or (S = '.JPG') or (S = '.GIF') then
    LoadBmp_Jpg_Gif_Texture(Filename, Texture,Alpha,Color,Quality);
  if  S = '.TGA' then
    LoadTGATexture(Filename, Texture,Alpha,Color,Quality);
  if  S = '.TEX' then
    LoadTexTexture(Filename, Texture,Alpha,Color,Quality);

end;

////
//
function LoadTextureEx(Filename: String; var W,H,BPP:Integer; var pData : PByteArray) : Boolean;
begin
Result:=True;
if Not FileExists(FileName) then exit;
try
  LoadBJG(Pchar(FileName),W,H,BPP,pdata); // -  Xproger'a (   )
  SwapRGBA(pdata,w*h);
  except Result :=False; end;

end;




{------------------------------------------------------------------------------}
{ GIF BMP JPG }
{------------------------------------------------------------------------------}

const
  IID_IPicture : TGUID = '{7BF80980-BF32-101A-8BBB-00AA00300CAB}';

type
  OLE_HANDLE = LongWord;
  OLE_XPOS_HIMETRIC  = Longint;
  OLE_YPOS_HIMETRIC  = Longint;
  OLE_XSIZE_HIMETRIC = Longint;
  OLE_YSIZE_HIMETRIC = Longint;

  PCLSID = PGUID;
  TCLSID = TGUID;

  TOleChar = WideChar;
  POleStr  = PWideChar;
  PPOleStr = ^POleStr;
  Largeint = Int64;

  TVarData = packed record
    VType     : Word;
    Reserved1 : Word;
    Reserved2 : Word;
    Reserved3 : Word;
    varOleStr : PWideChar;
    Reserved4 : Word;
    Reserved5 : Word;
  end;

  PStatStg = ^TStatStg;
  tagSTATSTG = record
    pwcsName: POleStr;
    dwType: Longint;
    cbSize: Largeint;
    mtime: TFileTime;
    ctime: TFileTime;
    atime: TFileTime;
    grfMode: Longint;
    grfLocksSupported: Longint;
    clsid: TCLSID;
    grfStateBits: Longint;
    reserved: Longint;
  end;
  TStatStg = tagSTATSTG;
  {$EXTERNALSYM STATSTG}
  STATSTG = TStatStg;

  ISequentialStream = interface(IUnknown)
    ['{0c733a30-2a1c-11ce-ade5-00aa0044773d}']
    function Read(pv: Pointer; cb: Longint; pcbRead: PLongint): HResult;
      stdcall;
    function Write(pv: Pointer; cb: Longint; pcbWritten: PLongint): HResult;
      stdcall;
  end;

  IStream = interface(ISequentialStream)
    ['{0000000C-0000-0000-C000-000000000046}']
    function Seek(dlibMove: Largeint; dwOrigin: Longint;
      out libNewPosition: Largeint): HResult; stdcall;
    function SetSize(libNewSize: Largeint): HResult; stdcall;
    function CopyTo(stm: IStream; cb: Largeint; out cbRead: Largeint;
      out cbWritten: Largeint): HResult; stdcall;
    function Commit(grfCommitFlags: Longint): HResult; stdcall;
    function Revert: HResult; stdcall;
    function LockRegion(libOffset: Largeint; cb: Largeint;
      dwLockType: Longint): HResult; stdcall;
    function UnlockRegion(libOffset: Largeint; cb: Largeint;
      dwLockType: Longint): HResult; stdcall;
    function Stat(out statstg: TStatStg; grfStatFlag: Longint): HResult;
      stdcall;
    function Clone(out stm: IStream): HResult; stdcall;
  end;

  IPicture = interface
    ['{7BF80980-BF32-101A-8BBB-00AA00300CAB}']
    function get_Handle(out handle: OLE_HANDLE): HResult;  stdcall;
    function get_hPal(out handle: OLE_HANDLE): HResult; stdcall;
    function get_Type(out typ: Smallint): HResult; stdcall;
    function get_Width(out width: OLE_XSIZE_HIMETRIC): HResult; stdcall;
    function get_Height(out height: OLE_YSIZE_HIMETRIC): HResult; stdcall;
    function Render(dc: HDC; x, y, cx, cy: Longint;
      xSrc: OLE_XPOS_HIMETRIC; ySrc: OLE_YPOS_HIMETRIC;
      cxSrc: OLE_XSIZE_HIMETRIC; cySrc: OLE_YSIZE_HIMETRIC;
      rcWBounds: Pointer): HResult; stdcall;
    function set_hPal(hpal: OLE_HANDLE): HResult; stdcall;
    function get_CurDC(out dcOut: HDC): HResult; stdcall;
    function SelectPicture(dcIn: HDC; out hdcOut: HDC;
      out bmpOut: OLE_HANDLE): HResult; stdcall;
    function get_KeepOriginalFormat(out fkeep: BOOL): HResult; stdcall;
    function put_KeepOriginalFormat(fkeep: BOOL): HResult; stdcall;
    function PictureChanged: HResult; stdcall;
    function SaveAsFile(const stream: IStream; fSaveMemCopy: BOOL;
      out cbSize: Longint): HResult; stdcall;
    function get_Attributes(out dwAttr: Longint): HResult; stdcall;
  end;

  function OleLoadPictureFile(varFileName: TVarData; var lpdispPicture:
                                 IDispatch): HResult; stdcall; external 'oleaut32.dll';
  function OleLoadPicture(stream: IStream; lSize: Longint; fRunmode: BOOL;
                                 const iid: TGUID; out vObject): HResult; stdcall; external 'olepro32.dll';
  function CreateStreamOnHGlobal(hglob: HGlobal; fDeleteOnRelease: BOOL;
                                 out stm: IStream): HResult; stdcall; external 'ole32.dll';

//   ,    OLE 
procedure CreateBitmap(pPicture: IPicture; var Width, Height, BPP: Integer; var Data: PByteArray);
var
  i    : Integer;
  bi   : BITMAPINFO;
  bmp  : HBITMAP;
  DC   : HDC;
  p    : Pointer;
  w, h : Integer;
begin
//   
  DC := CreateCompatibleDC(GetDC(0));
  pPicture.get_Width(W);
  Width  := MulDiv(W, GetDeviceCaps(DC, LOGPIXELSX), 2540);
  pPicture.get_Height(H);
  Height := MulDiv(H, GetDeviceCaps(DC, LOGPIXELSY), 2540);
  BPP    := 32;
  ZeroMemory(@bi, SizeOf(bi));
  bi.bmiHeader.biSize        := SizeOf(BITMAPINFOHEADER);
  bi.bmiHeader.biBitCount    := 32;
  bi.bmiHeader.biWidth       := Width;
  bi.bmiHeader.biHeight      := Height;
  bi.bmiHeader.biCompression := BI_RGB;
  bi.bmiHeader.biPlanes      := 1;
  bmp := CreateDIBSection(DC, bi, DIB_RGB_COLORS, p, 0, 0);
  SelectObject(DC, bmp);
  pPicture.Render(DC, 0, 0, Width, Height, 0, h, W, -H, nil);
  GetMem(Data, Width * Height * BPP div 8);
  Move(p^, Data^, Width * Height * 4);
  GetBitmapBits(bmp, Width * Height * BPP div 8, Data);
  for i := 0 to Width * Height - 1 do
    Byte(Pointer(Integer(Data) + i * 4 + 3)^) := 255;
  DeleteObject(bmp);
  DeleteDC(DC);
end;

//   
function LoadBJG(const FileName: PChar; var Width, Height, BPP: Integer; var Data: PByteArray): Boolean;
var
  v         : TVarData;
  pPicture  : IPicture;
  pDispatch : IDispatch;
begin
//        "oleaut32.dll"
  Result := False;
  try
  //   
    ZeroMemory(@v, SizeOf(v));
    v.VType     := varOleStr;
    v.varOleStr := StringToOleStr(FileName);
    if OleLoadPictureFile(v, pDispatch) = 0 then
    begin
    //  HBITMAP
      pDispatch.QueryInterface(IID_IPicture, pPicture);
      CreateBitmap(pPicture, Width, Height, BPP, Data);
      Result := True;
    end;
  except
  end;
end;

//   
function LoadBJGmem(mem: Pointer; Size: Integer; var Width, Height, BPP: Integer; var Data: PByteArray): Boolean;
var
  m        : Pointer;
  g        : HGLOBAL;
  Stream   : IStream;
  pPicture : IPicture;
begin
//        "oleaut32.dll"
  Result := False;
  g := 0;
  try
  //    HGlobal    
  //   ,   Mem    OLE... %)
    g := GlobalAlloc(GMEM_FIXED, Size);
    m := GlobalLock(g);
    Move(mem^, m^, Size);
    GlobalUnlock(g);
  //   
    if (CreateStreamOnHGlobal(Cardinal(m), False, Stream) = 0) and
       (OleLoadPicture(Stream, 0, False, IID_IPicture, pPicture) = 0) then
    begin
      CreateBitmap(pPicture, Width, Height, BPP, Data);
      Result := True;
    end;
  finally
    if g <> 0 then
      GlobalFree(g);
  end;
end;


end.
