unit model4;

interface

(**********************************************************************)
(******** :    .************)
(**********************************************************************)
(*********************** Site: SVSD.MirGames.Ru ***********************)
(***********Mail : ValDim_05@Mail.ru*****Icq :223-725-915**************)
(**********************************************************************)
                                                          // 16:10:2006
uses Windows,OpenGL,Math,l_math,SysUtils;

const
     ID      = 'OGLMAP By SVSD_VAL';
     VERSION = 7;

     GL_UNSIGNED_SHORT       = $1403;  //    
	   GL_FLOAT                = $1406;  // OpenGL 1.2
	   GL_VERTEX_ARRAY         = $8074;  //  Delphi Opengl.pas  1.1
	   GL_TEXTURE_COORD_ARRAY  = $8078;  //    

type

  TFACE        = array [0..2] of Word;
  TAABB        = Record
   MINS,MAXS   : TVector;
  end;

  THEADER      = record
   ID          : array [0..18] of Char;
   VERSION     : Word;
  end;

  TTexture     = record
   Name        : String;
   Texture     : Cardinal;
  end;


  TObj         = Record
   AlphaTest   : Boolean;

   VERTEXcount,
   FACEcount,
   TEXCount : Word;

   FACE        : array of TFACE;
   Vertex      : array of TVEctor;
   Normals     : array of TVector;
   TEXCOORD    : array of TVector2d;
   FACEBBOXS   : array of TAABB;
   AABB        : TAABB;

   TextureNameL: Byte;
   TextureName : String;
   TextureNum  : Integer;

   //----------|

   Plane       : array of TPlane;
   Center      : TVector;
   MaxDist     : single;
   Colided     : Boolean;
   Water       : boolean;
  end;

  T4MODEL = class
  public
   HEADER                : THEADER;
   ObjectsCount          : Word;
   Obj                   : Array of TObj;
   ModelAabb             : TAABB;
   Texture               : Array of TTexture;
   onwater               : boolean;
   DrawingObjects        : word;
   CColide               : word;
   function  SaveToFile  (FileName:string;S:Single):Boolean;
   function  LoadFromFile(FileName:string):Boolean;
   Procedure Render;
   Procedure RenderObjectT(ObjectNum:integer;Texture:Cardinal);
   Procedure RenderObject(ObjectNum:integer);

   function  Collision        (var Pos, Speed: TVector; R: single): boolean;
   function  OnGroundCollision(Pos: TVector; R: single): boolean;

   function  TestCollision    (Pos: TVector; R: single): boolean;
   Procedure CalculateData;
  Private
   function  ADDTexture(FileName:string):Integer;
  end;

procedure glEnableClientState (aarray: cardinal); stdcall; external opengl32;
procedure glDisableClientState(aarray: cardinal); stdcall; external opengl32;
procedure glVertexPointer     (size: integer; atype: cardinal; stride: integer; data: pointer); stdcall; external opengl32;
procedure glTexCoordPointer   (size: integer; atype: cardinal; stride: integer; data: pointer); stdcall; external opengl32;
procedure glDrawElements      (mode: cardinal; count: integer; atype: cardinal; indices: Pointer); stdcall; external opengl32;
procedure glBindTexture       (target: GLenum; texture: GLuint); stdcall; external opengl32;

implementation

Procedure T4model.Render;
var i :integer;
begin
   DrawingObjects:=0;
   glEnable(GL_CULL_FACE);
  for i := 0 to ObjectsCount-1 do
  if not obj[i].Water then
  begin
  inc(DrawingObjects);
    glBindTexture(GL_TEXTURE_2D, Texture[Obj[i].Texturenum].Texture);
//    if obj[i].Colided then GLColor3F(0.2,1,0.2) else GLColor3F(1,1,1);
    if Obj[i].AlphaTest = True then begin glEnable(GL_ALPHA_TEST);   glDisable(GL_CULL_FACE); end;

  	glEnableClientState(GL_VERTEX_ARRAY);
    glVertexPointer(3, GL_FLOAT, 0, @Obj[i].VERTEX[0].x);
  	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
  	glTexCoordPointer(2, GL_FLOAT, 0, @Obj[i].TEXCOORD[0].x);

  	glDrawElements(GL_TRIANGLES, Obj[i].FACEcount*3, GL_UNSIGNED_SHORT, @Obj[i].FACE[0]);

    glDisableClientState(GL_VERTEX_ARRAY);
  	glDisableClientState(GL_TEXTURE_COORD_ARRAY);

    if Obj[i].AlphaTest = True then begin glDisable(GL_ALPHA_TEST); glEnable(GL_CULL_FACE); end;
  end;
   glDisable(GL_CULL_FACE);

  for i := 0 to ObjectsCount-1 do
  if obj[i].Water then
  begin
  inc(DrawingObjects);
  glDepthMask(false);
  glEnable(gl_Blend);
  glBlendFunc(GL_src_Color,GL_one);
    glBindTexture(GL_TEXTURE_2D, Texture[Obj[i].Texturenum].Texture);
//    if obj[i].Colided then GLColor3F(0.2,1,0.2) else GLColor3F(1,1,1);

  	glEnableClientState(GL_VERTEX_ARRAY);
    glVertexPointer(3, GL_FLOAT, 0, @Obj[i].VERTEX[0].x);
  	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
  	glTexCoordPointer(2, GL_FLOAT, 0, @Obj[i].TEXCOORD[0].x);

  	glDrawElements(GL_TRIANGLES, Obj[i].FACEcount*3, GL_UNSIGNED_SHORT, @Obj[i].FACE[0]);

    glDisableClientState(GL_VERTEX_ARRAY);
  	glDisableClientState(GL_TEXTURE_COORD_ARRAY);

    gldisable(gl_Blend);
    glDepthMask(true);

  end;
end;

Procedure T4model.RenderObjectT(ObjectNum:integer;Texture:Cardinal);
begin
    glBindTexture(GL_TEXTURE_2D, Texture);
  	glEnableClientState(GL_VERTEX_ARRAY);
    glVertexPointer(3, GL_FLOAT, 0, @Obj[ObjectNum].VERTEX[0].x);
  	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
  	glTexCoordPointer(2, GL_FLOAT, 0, @Obj[ObjectNum].TEXCOORD[0].x);

  	glDrawElements(GL_TRIANGLES, Obj[ObjectNum].FACEcount*3, GL_UNSIGNED_SHORT, @Obj[ObjectNum].FACE[0]);

    glDisableClientState(GL_VERTEX_ARRAY);
  	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
end;

Procedure T4model.RenderObject(ObjectNum:integer);
begin
    glBindTexture(GL_TEXTURE_2D, Texture[Obj[ObjectNum].Texturenum].Texture);

  	glEnableClientState(GL_VERTEX_ARRAY);
    glVertexPointer(3, GL_FLOAT, 0, @Obj[ObjectNum].VERTEX[0].x);
  	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
  	glTexCoordPointer(2, GL_FLOAT, 0, @Obj[ObjectNum].TEXCOORD[0].x);

  	glDrawElements(GL_TRIANGLES, Obj[ObjectNum].FACEcount*3, GL_UNSIGNED_SHORT, @Obj[ObjectNum].FACE[0]);

    glDisableClientState(GL_VERTEX_ARRAY);
  	glDisableClientState(GL_TEXTURE_COORD_ARRAY);

end;

//-----------------------------------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------------------------------
function T4model.ADDTexture(FileName:string):Integer;
var
i :integer;
begin
for i := 0 to length(Texture)-1 do
If SameText(texture[i].Name,FileName) then Begin result :=i; exit; end;

i := Length(Texture);
SetLength(Texture,i+1);
Texture[i].Name :=FileName;
//Loadtexture(FileName,Texture[i].Texture,false);
Result := i;

end;


function T4model.Collision(var Pos, Speed: TVector; R: single): boolean;
var
 i, i2   : integer;
 Dist   : single;
 offset : TVector;
 ins    : TVector;
begin
Result := false;
CColide:=0;

for i := 0 to ObjectsCount - 1 do
  if V_Dist(obj[i].Center, Pos) <= obj[i].MaxDist + R then
   for i2 := 0 to obj[i].FACEcount - 1 do
    if P_Classify(Pos, obj[i].Plane[i2]) > 0 then
     begin
     inc(CColide);
     Dist := P_Dist(Pos, obj[i].Plane[i2]);
     if Dist < R then
      begin
      offset := V_Mult(obj[i].Plane[i2].Normal, R - Dist);
      ins    := V_Sub (Pos, V_Mult(obj[i].Plane[i2].Normal, Dist));
      if P_InsideTri(ins,
                     obj[i].Vertex[obj[i].Face[i2, 0]],
                     obj[i].Vertex[obj[i].Face[i2, 1]],
                     obj[i].Vertex[obj[i].Face[i2, 2]]) or
  		    EdgeSphereCollision(Pos, obj[i].Vertex[obj[i].Face[i2, 0]],
                     obj[i].Vertex[obj[i].Face[i2, 1]],
                     obj[i].Vertex[obj[i].Face[i2, 2]], R/2) then
                     if not obj[i].water then
       begin

       Pos := V_Add(Pos, offset);
       if abs(Pos.Y - ins.Y) > R/2 then
       if Pos.Y > ins.Y then
        Result := true;
       end;
      end;
     end;

end;

function T4model.OnGroundCollision(Pos: TVector; R: single): boolean;
var
 i, i2  : integer;
 Dist   : single;
 ins    : TVector;
begin
Result := false;
for i := 0 to ObjectsCount - 1 do begin obj[i].Colided := false; onwater:=false end;

for i := 0 to ObjectsCount - 1 do
if not obj[i].Water then
  if V_Dist(obj[i].Center, Pos) <= obj[i].MaxDist + R then
   for i2 := 0 to obj[i].FACEcount - 1 do
    if P_Classify(Pos, obj[i].Plane[i2]) > 0 then
     begin
     Dist := P_Dist(Pos, obj[i].Plane[i2]);
     if Dist < R then
      begin
      ins    := V_Sub(Pos, V_Mult(obj[i].Plane[i2].Normal, Dist));
      if P_InsideTri(ins,
                     obj[i].Vertex[obj[i].Face[i2, 0]],
                     obj[i].Vertex[obj[i].Face[i2, 1]],
                     obj[i].Vertex[obj[i].Face[i2, 2]]) or
  		    EdgeSphereCollision(Pos, obj[i].Vertex[obj[i].Face[i2, 0]],
                     obj[i].Vertex[obj[i].Face[i2, 1]],
                     obj[i].Vertex[obj[i].Face[i2, 2]], R/2) then
                     begin result := true; obj[i].colided := true; end;
      end;
     end;
end;


function T4model.TestCollision(Pos: TVector; R: single): boolean;
var
 i, i2  : integer;
 Dist   : single;
 ins    : TVector;
begin
Result := false;
for i := 0 to ObjectsCount - 1 do
  if V_Dist(obj[i].Center, Pos) <= obj[i].MaxDist + R then
   for i2 := 0 to obj[i].FACEcount - 1 do
    if P_Classify(Pos, obj[i].Plane[i2]) > 0 then
     begin
     Dist := P_Dist(Pos, obj[i].Plane[i2]);
     if Dist < R then
      begin
      ins    := V_Sub(Pos, V_Mult(obj[i].Plane[i2].Normal, Dist));
      if P_InsideTri(ins,
                     obj[i].Vertex[obj[i].Face[i2, 0]],
                     obj[i].Vertex[obj[i].Face[i2, 1]],
                     obj[i].Vertex[obj[i].Face[i2, 2]]) or
  		    EdgeSphereCollision(Pos, obj[i].Vertex[obj[i].Face[i2, 0]],
                     obj[i].Vertex[obj[i].Face[i2, 1]],
                     obj[i].Vertex[obj[i].Face[i2, 2]], R/2) then
//       if abs(Pos.Y - ins.Y) > R/2 then
       if Pos.Y -r*2 < ins.Y then
        Result := true;

//                     result := true;
      end;
     end;
end;

//-----------------------------------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------------------------------
Procedure T4Model.CalculateData;
Procedure CALCBBOXS;
var i,i2 :integer;
  begin
    for i := 0 to objectscount - 1 do
    with obj[i] do
    begin
      SetLength(FACEBBOXS, FACEcount);
      for i2 := 0 to facecount - 1 do
        begin
             FACEBBOXS[i2].MINS := Vertex[FACE[i2][0]];
             FACEBBOXS[i2].MAXS := Vertex[FACE[i2][0]];
             FACEBBOXS[i2].MINS := VAABBMin(Vertex[FACE[i2][1]],FACEBBOXS[i2].MINS);
             FACEBBOXS[i2].MINS := VAABBMin(Vertex[FACE[i2][2]],FACEBBOXS[i2].MINS);
             FACEBBOXS[i2].MAXS := VAABBMax(FACEBBOXS[i2].MAXS,Vertex[FACE[i2][1]]);
             FACEBBOXS[i2].MAXS := VAABBMax(FACEBBOXS[i2].MAXS,Vertex[FACE[i2][2]]);

        end;
    end;
end;

procedure AdjustNormals(var obj:TObj);
var V1, V2,
    Normal,
    VSum, VZero:TVector;
    TempNormals:array of TVector;
    VPoly      :array[0..2] of TVector;
    I, Shared,J:Integer;
begin
  SetLength(TempNormals, Obj.FaceCount);
  SetLength(obj.Normals, Obj.VertexCount);

  for I:=0 to Obj.FaceCount-1 do
   begin
     vPoly[0]:=Obj.vertex[Obj.Face[I][0]];
     vPoly[1]:=Obj.vertex[Obj.Face[I][1]];
     vPoly[2]:=Obj.vertex[Obj.Face[I][2]];

     V1 := V_Sub(vPoly[0], vPoly[2]);
     V2 := V_Sub(vPoly[2], vPoly[1]);

     Normal:= v_Normalize(V_Cross(V1, V2));
     TempNormals[I]:= Normal;
   end;

  vSum := V_Clear;
  VZero:= V_Clear;

  for I:=0 to obj.VertexCount-1 do
   begin
     Shared:=0;

     for J:=0 to obj.FaceCount-1 do
      if (obj.Face[J][0] = I) or (obj.Face[J][1] = I) or (obj.Face[J][2] = I) then
       begin
         VSum:=V_Add(VSum, TempNormals[J]);
         Inc(Shared);
       end;

     obj.Normals[I]:= V_Div(vSum, -Shared);
     obj.Normals[I]:= V_Normalize(obj.Normals[I]);
     vSum:=vZero;
   end;

  Finalize(TempNormals);
end;

const
M = 400000000;
var
i,i2 : integer;
d    : Single;
begin

    for i := 0 to length(obj)-1 do
    with obj[i] do
    begin
//    Mins := VERTEX[0];
//    Maxs := VERTEX[0];
      aabb.Mins := Vector(m,m,m);
      aabb.Maxs := Vector(-m,-m,-m);

     for i2 := 0 to vertexcount -1 do
      begin
       aabb.Mins := VAABBMin(aabb.mins, VERTEX[i2]);
       aabb.Maxs := VaabbMax(aabb.Maxs, VERTEX[i2]);
      end;

      for i2 := i+1 to length(obj)-1 do
      begin
      ModelAABB.Mins := VAABBMin(obj[i].aabb.Mins,obj[i2].aabb.Mins);
      ModelAABB.Maxs := VaabbMax(obj[i].aabb.Maxs,obj[i2].aabb.Maxs);
      end;
    end;

    CALCBBOXS;


//    
for i := 0 to ObjectsCount - 1 do
 with obj[i] do
  begin
   AdjustNormals(obj[i]);
  //   
  SetLength(Plane, FACEcount);
  for i2 := 0 to facecount - 1 do
   Plane[i2] := P_Plane(Vertex[Face[i2, 2]],
                        Vertex[Face[i2, 1]],
                        Vertex[Face[i2, 0]]);

  //  "" 
  Center := V_Clear;
  for i2 := 0 to VERTEXcount - 1 do
  Center := V_Add(Center, Vertex[i2]);
  Center := V_Div(Center, VERTEXcount);
  //       
  MaxDist := -1;

  for i2 := 0 to VERTEXcount - 1 do
  begin
  d := V_Distq(Center, Vertex[i2]);
  if d > MaxDist then
   MaxDist := d;
  end;

   MaxDist := sqrt(MaxDist);

  end;

end;


function T4model.SaveToFile(FileName:string;S:Single):Boolean;
var
 I,I2  : Integer;
 F     : File of byte;
begin
result:=false;
 try
  AssignFile(F,FileName);
  Rewrite(F);
    Header.ID := id;
    Header.VERSION := Version;

    ObjectsCount       := Length(Obj);
    for i := 0 to ObjectsCount-1 do
    with obj[i] do
    begin
    VERTEXcount := Length(Vertex  );
    FACEcount   := Length(FACE    );
    TEXCount    := Length(TEXCOORD);
    end;

    BlockWrite(F,Header,SizeOf(THeader));
    BlockWrite(F,ObjectsCount,2);

    for i := 0 to ObjectsCount-1 do
    with obj[i] do
    begin
       Obj[i].TextureNameL := Length(Obj[i].TextureName);

       BlockWrite(F,AlphaTest     ,1);
       BlockWrite(F,VERTEXcount   ,2);
       BlockWrite(F,FACEcount     ,2);
       BlockWrite(F,TEXcount      ,2);
       BlockWrite(F,TextureNameL  ,1);
       BlockWrite(F,TextureName[1],TextureNameL);
       BlockWrite(F,FACE[0][0]          ,sizeof(TFACE    )*FACEcount);
       BlockWrite(F,Plane[0].Normal.x   ,sizeof(TPlane   )*FACEcount);
       BlockWrite(F,VERTEX[0].x         ,sizeof(TVEctor  )*VERTEXcount);
       BlockWrite(F,Normals[0].x        ,sizeof(TVEctor  )*FACEcount);
       BlockWrite(F,TEXCOORD[0].x       ,sizeof(TVector2d)*TEXCount);
       BlockWrite(F,FACEBBOXS[0].MINS.x ,Sizeof(TAabb    )*FaceCount);
       BlockWrite(F,AABB.MINS.x         ,Sizeof(TAAbb    ));
       BlockWrite(F,Center              ,SizeOf(TVector));
       BlockWrite(F,MaxDist             ,4);

    end;
    BlockWrite(F,ModelAABB.MINS.x     ,Sizeof(TAAbb    ));
    BlockWrite(F,ID,Length(iD));
    BlockWrite(F,S,4);

  CloseFile(F);

 except
  result:=true;
 end;
end;

//-----------------------------------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------------------------------
function T4model.LoadFromFile(FileName:string):Boolean;
var
I,I2: Integer;
F   : File of byte;
d   : single;
begin
 try
  AssignFile(F,FileName);
  Reset(F);

    BlockRead(F,HEADER.ID[0] ,Sizeof(THEADER));
//    if HEADER.ID <> id then begin result := false; exit;end;
    BlockRead(F,ObjectsCount,2);

    setlength(obj,ObjectsCount);
    for i := 0 to ObjectsCount-1 do
    with obj[i] do
    begin
    BlockRead(F,AlphaTest   ,1);
    BlockRead(F,VERTEXcount ,2);
    BlockRead(F,FACEcount   ,2);
    BlockRead(F,TEXCount    ,2);
    BlockRead(F,TextureNameL,1);
    SetLength(TextureName,TextureNameL);

    BlockRead(F,TextureName[1],TextureNameL);
    setlength(VERTEX   ,VERTEXcount);
    setlength(FACE     ,FACEcount);
    setlength(Plane    ,FACEcount);
    setlength(TEXCOORD ,TEXCount);

       BlockRead(F,FACE[0][0]        ,sizeof(TFACE )*FACEcount);
       BlockRead(F,Plane[0].Normal.x ,sizeof(TPlane)*FACEcount);

       BlockRead(F,VERTEX[0].x   ,sizeof(TVEctor  )*VERTEXcount);
       BlockRead(F,TEXCOORD[0].x ,sizeof(TVector2d)*TEXCount);

    BlockRead(F,Obj[i].Center        ,SizeOf(TVector));
    BlockRead(F,Obj[i].MaxDist       ,4);
    end;
    CloseFile(F);

    result := true;
 except
  result:=false;
 end;
end;

end.
