#include "BotAI.h"
#include "World.h"


float MIN_HEALTH = 20;

void Bot::updateAI()
{
	//     !
	//  
	if ( Health < MIN_HEALTH )
	{
		Bonus* b;
		b = findClosestBonus(BNS_MEDKIT);
		if ( b != NULL )
		{
			if ( length(b->pos-pos) < 800 )
			{
				moveTarget = &b->pos;
				strategy = MOVE2BONUS;	//  
			}
			else
			{
				shootTarget = findClosestEnemy();
				moveTarget = &shootTarget->pos;
				strategy = MOVE2ENEMY;
			}

		}
	}

	switch ( strategy )
	{
	case IDLE:
		shootTarget = findClosestEnemy();
		moveTarget = &shootTarget->pos;
		strategy = MOVE2ENEMY;

		break;

	case ATTACK:

		if ( length(pos-shootTarget->pos) >= 250 )
		{
			strategy = MOVE2ENEMY;
		}

		selectWeapon();				//   
		if ( shootTarget->Active )
			shoot(shootTarget->pos);
		if ( shootTarget->Active == false ) strategy = IDLE;

		break;

	case MOVE2ENEMY:
		moveTo( 250.0f );
		if ( length(pos - shootTarget->pos) <= 250 ) strategy = ATTACK;

		//    
		if ( frand(500)<1.0f)
		{
			shootTarget = findMostSickEnemy();
			moveTarget = &shootTarget->pos;
			strategy = MOVE2ENEMY;
		}

		break;

	case MOVE2BONUS:
		moveTo( 30.0f );
		if ( length(pos - (*moveTarget)) <= 30 ) strategy = IDLE;

		if ( frand(50) < 1.0f )
			shoot(findClosestEnemy()->pos);

		break;
	}

	//    
	if ( frand( 7000 ) < 1.0f ) putMine();
}


Car* Bot::findClosestEnemy()
{
	Car* ret = NULL;

	float len;
	float min_len=9999999999999999.0f;
	vec2 v;
	for ( unsigned int i=0; i<World::bots.getCount(); i++ )
	{
		if ( pos == World::bots[i].pos || !World::bots[i].Active ) continue;
		v = pos - World::bots[i].pos;
		len = dot(v,v);
		if ( len < min_len )
		{
			min_len = len;
			ret = &World::bots[i];
		}
	}
	if ( ret == NULL )
		return &World::bots[0];
	else
		return ret;
}


Car* Bot::findMostSickEnemy()
{
	Car* ret = NULL;
	float min_health=101.0f;
	for ( unsigned int i=0; i<World::bots.getCount(); i++ )
	{
		if ( pos == World::bots[i].pos || !World::bots[i].Active ) continue;
		if ( World::bots[i].Health < min_health )
		{
			min_health = World::bots[i].Health;
			ret = &World::bots[i];
		}
	}
	if ( ret == NULL )
		return &World::bots[0];
	else
		return ret;
}


Bonus* Bot::findClosestBonus(BonusID bns)
{
	Bonus* ret = NULL;
	float len;
	float min_len=999999999999.0f;
	vec2 v;
	for ( unsigned int i=0; i<World::map.bonuses.getCount(); i++ )
	{
		v = pos - World::map.bonuses[i].pos;
		len = dot(v,v);
		if ( len < min_len && World::map.bonuses[i].active && World::map.bonuses[i].type == bns )
		{
			min_len = len;
			ret = &World::map.bonuses[i];
		}
	}
	if ( ret == NULL && World::map.bonuses.getCount()>0 )
		return &World::map.bonuses[0];
	else
		return ret;	
}


void Bot::moveTo(float stopRadius)
{
	if ( length(*moveTarget - pos) > stopRadius)
	{
		float target_angle = Angle( *moveTarget - pos );

		target_angle = difference( Alpha, target_angle );

		if ( target_angle < -0.1f )
			turnLeft();
		else
			if ( target_angle > 0.1f )
				turnRight();

		if ( abs(target_angle) <= 0.2f )
			pressGas();
	}		
}


void Bot::selectWeapon()
{
	if ( shopCount[currentWeapon]<=0 || frand(500)<1.0f )
		currentWeapon = (WeaponID)(int)frand(WEAPONS_COUNT-1);

	int c = 0;
	for ( int i=0; i<WEAPONS_COUNT-1; i++ )
	{
		if ( shopCount[i] <= 0 ) c++;
	}

	if ( c >= WEAPONS_COUNT-2 ) 
	{
		Bonus* b;
		b = findClosestBonus((BonusID)(int)frand(4));
		if ( b != NULL )
		{
			moveTarget = &b->pos;
			strategy = MOVE2BONUS;	//  
		}
	}
}


