
#include "Image.h"


bool isExtInFile(const char *filename, const char *ext)
{

	if( stricmp(strrchr(filename,'.'), ext) == 0)
		return true;
	else
		return false;
}

int Image::Release()
{
	if(m_dest!=NULL)
	{
		free(m_dest);
		m_dest=NULL; //      ;)
		return true;
	}
	return false;
}

bool Image::ReadFile(const char *filename)
{
	if (m_dest != NULL) return true; //    

	if( isExtInFile(filename, ".tga") )
	{
		CTga tga;
		if(tga.ReadFile(filename, true)==0)
		{
			tga.Release();
			return false;
		}

		//        
		if(tga.Bpp()==8)
		{
			m_dest = (unsigned char*)malloc(tga.GetSizeX() * tga.GetSizeY());
			memcpy ( m_dest, tga.GetPointer(), tga.GetSizeX() * tga.GetSizeY());
		}

		if(tga.Bpp()==32 || tga.Bpp()==24)
		{
			m_dest = (unsigned char*)malloc(tga.GetSizeX() * tga.GetSizeY() * 4);
			memcpy ( m_dest, tga.GetPointer(), tga.GetSizeX() * tga.GetSizeY() * 4);
		}

		//  
		m_SizeX = tga.GetSizeX();
		m_SizeY = tga.GetSizeY();
		m_Bpp   = tga.Bpp();

		tga.Release();

	}
	else 

	if( isExtInFile(filename, ".bmp") )
	{
		CBmp Bmp;
		if(Bmp.ReadFile(filename)==0)
		{
			Bmp.Release();
			return false;
		}

		//   24 
 		m_dest = (unsigned char *)malloc( Bmp.GetSizeX() * Bmp.GetSizeY() * 3 );
		memcpy ( m_dest, Bmp.GetPointer(), Bmp.GetSizeX() * Bmp.GetSizeY() * 3 );

		m_SizeX = Bmp.GetSizeX();
		m_SizeY = Bmp.GetSizeY();
		m_Bpp   = Bmp.Bpp();
		
		Bmp.Release();
	}
	else

	if ( isExtInFile(filename, ".jpg") || isExtInFile(filename, ".jpeg") || isExtInFile(filename, ".gif") )
	{
		CPicture picture;
		if(picture.ReadFile(filename)==0)
		{
			picture.Release();
			return 0;
		}

 		m_dest = (unsigned char *)malloc( picture.GetSizeX() * picture.GetSizeY() * 4 );
		memcpy ( m_dest, picture.GetPointer(), picture.GetSizeX() * picture.GetSizeY() * 4 );

		m_SizeX = picture.GetSizeX();
		m_SizeY = picture.GetSizeY();
		m_Bpp   = 32;

		picture.Release();
	}
	else
	{
		Log.Write("File format is not supported !\n");
		return false;
	}

	return true;
}