#include <stdio.h>
#include <stdlib.h>
#include <iostream>

/*
	Read a TGA bitmap
	Le TGA file must been :
	- Greyscale 8 bit per pixel uncompressed
	- Color 24 bit per pixel uncompressed
	- Color 32 bit per pixel uncompressed
	- Color 24 bit per pixel compressed (RLE)
	- Color 32 bit per pixel compressed (RLE)

	\param str : File name
	\param dest : Pointer on the destination 
	Pointeur vers lequel l'image est situe aprs la fonction
	\param SizeX : width of the bitmap
	\param SizeY : height of the bitmap
	\param Bpp : Bit per pixel of the bitmap (8,24 or 32)
*/

class  CTgaHeader
{
public:
    char  idlength;
    char  colourmaptype;
    char  datatypecode;
    short colourmaporigin;
    short colourmaplength;
    char  colourmapdepth;
    short x_origin;
    short y_origin;
    short SizeX;
    short SizeY;
    char  Bpp;
    char  imagedescriptor;
};

class CTga
{
private:
	CTgaHeader TgaHeader;
	int m_SizeX, m_SizeY, m_Bpp;
	unsigned char *m_dest;

public:

	CTga();	

	~CTga() { Release(); }

	CTga(const char *str)
	{
		ReadFile(str, false);
	}

	int GetSizeX()
	{
		return m_SizeX;
	}
	
	int GetSizeY()
	{
		return m_SizeY;
	}
	
	int Bpp()
	{
		return m_Bpp;		
	}
	
	unsigned char * GetPointer()
	{
		return m_dest;
	}	
	
	bool ReadFile(const char *str, bool forceFlip = false);
	int Release();
};
