#ifndef __COLLISIONS_H__
#define __COLLISIONS_H__

#include "vector.h"


class Circle;
class AABB;
class Line;
class Ray;



bool colLineCircle(vec2& x1, vec2& x2, vec2& center, float radius, vec2* normal, float* depth);     //  
bool colLineCircle2(vec2& x1, vec2& x2, vec2& center, float radius, vec2* normal, float* depth);	//  
vec2 closestPointOnLine(vec2& vA, vec2& vB, vec2& vPoint);
float lineDistance(vec2& a, vec2& b, vec2& c);


// -------------------------------------------------------
// 
// !!!      !!!
//

class Triangle
{
public:
	vec2 v1;
	vec2 v2;
	vec2 v3;

public:
	Triangle() {} 
	Triangle(vec2& V1, vec2& V2, vec2& V3): v1(V1), v2(V2), v3(V3) {}

	vec2 getCenter();													// ok

	bool pointInside(vec2& v);											// ok
	bool pointInside(vec2& v, vec2* normal, float* depth);				// ok
	bool colCircle(vec2& v, float radius, vec2* normal, float* depth);  // ok
};



class AABB
{
public:
	vec2 v1;	// 
	vec2 v2;	// 

public:
	AABB(){}
	AABB(vec2& V1, vec2& V2): v1(V1), v2(V2) {}
	bool pointInside(vec2& v);									// ok
	bool pointInside(vec2& v, float alpha);						// ok  AABB   OBB ;)
	bool colLine(vec2& a, vec2& b);
	bool colLine(vec2& a, vec2& b, vec2* normal, float* depth);
	bool colCircle(Circle& c);
};




class Line
{
public:
	vec2 a;
	vec2 b;

public:
	Line(vec2& A, vec2& B):a(A), b(B){}
	bool lineIntersect(vec2& c, vec2& d);
	float pointDistance(vec2& c);
	float orient(vec2& c);					// ok
};




class Ray
{
public:
	vec2 origin;
	vec2 point; 

public:

};




class Circle
{
public:
	vec2 center;
	float radius;

public:
	Circle(vec2& c, float r): center(c), radius(r){};
	bool colCircle(vec2& p, float r);					// ok
	bool colCircle(vec2& p, float r, vec2* depth);		// ok
	bool pointInside(vec2& p);							// ok
};


#endif

