#ifndef __PARTICLES_EFFECTS_H__
#define __PARTICLES_EFFECTS_H__



#include "Utils/ParticleSystem.h"
#include "Utils/SpriteAnimation.h"
#include "Resources.h"



//   
class PFRicochet: public ParticlesEmitter
{
public:
	PFRicochet(vec2& p, vec2& normal, int n, vec3& col);
	void UpdateParticle(int i, float dt);
};



//   
class PFCrater: public ParticlesEmitter
{
public:
	PFCrater(vec2& p, float size);
};



//  
class PFExplosionWave: public ParticlesEmitter
{
public:
	PFExplosionWave(vec2& pos, float size);
	void UpdateParticle(int i, float dt);
	void Render();
};


//  
class PFExplosionAnim: public ParticlesEmitter
{
	Animation sa;
public:
	PFExplosionAnim(vec2& pos, float size);
	void Update(float dt);
	void Render();
};



//  
class PFCarRespawn: public ParticlesEmitter
{
public:
	PFCarRespawn(vec2& pos);
	void Update(float dt);
};




//   
class PFSmoke: public ParticlesEmitter
{
public:
	bool owner_dead;

public:
	PFSmoke();
	void Update(float dt);
	void AddParticle(vec2& Pos, vec2& Speed, vec2& Size, float Life);
};



//   
class PFTiresTrail: public ParticlesEmitter
{
public:
	bool off;

public:
	PFTiresTrail();
	void AddParticle(vec2& Pos, float Angle);
	void Update(float dt);
};



#endif


