#include "Resources.h"
#include "Utils/ini.h"
#include "Utils/Camera.h"


// 

Texture tex_car1_normal;  //  
Texture tex_car1_broken;  //  

Texture tex_car2_normal;
Texture tex_car2_broken;

Texture tex_car3_normal;
Texture tex_car3_broken;



Texture tex_bullet;
Texture tex_fire;				//   
Texture tex_rocket;
Texture tex_mine;


Texture tex_spark;
Texture tex_white_spark;
Texture tex_respawn;
Texture tex_smoke;
Texture tex_tyres_trail;
Texture tex_sphere;



Texture tex_panel_normal;
Texture	tex_panel_rollover;
Texture	tex_panel_press;

//Texture tex_gun;
Texture tex_font;				// 
Texture tex_cursor;				// 


Texture tex_explosion_anim;		//  
Texture tex_shokwave1;			//     1
Texture tex_crater;


Texture tex_ter_dirt;
Texture tex_ter_grass;
Texture tex_ter_grass_dark;
Texture tex_ter_road;
Texture tex_ter_rock;
Texture tex_ter_sand;


		// 
Texture tex_bullet_bonus;
Texture tex_fire_bonus;
Texture tex_medkit_bonus;
Texture tex_mine_bonus;
Texture tex_rocket_bonus;
Texture tex_shotgun_bonus;





PTexture tex_back_menu;
PTexture tex_back_other;
Texture  tex_mini_map;




// 
PSound snd_explosion;
PSound snd_bullet_ricochet1,
       snd_bullet_ricochet2,
	   snd_bullet_ricochet3;
PSound snd_mine_activate;		//  
PSound snd_machine_gun;
PSound snd_rocket_start;
PSound snd_rocket_blow;

PSound snd_take_bonus;
PSound snd_respawn;



// 

int WINDOW_WIDTH;
int WINDOW_HEIGHT;
bool vSync;
bool fullScreen;



int		botsNamesCount;
char*	botNames[256];




void loadTextures()
{
	// GUI
	tex_panel_normal.load("Textures/gui/panel_normal.tga");
	tex_panel_rollover.load("Textures/gui/panel_rollover.tga");
	tex_panel_press.load("Textures/gui/panel_press.tga");

	tex_car1_normal.load("Textures/Cars/car1.tga");
	tex_car1_broken.load("Textures/Cars/badcar1.tga");

	tex_car2_normal.load("Textures/Cars/car2.tga");
	tex_car2_broken.load("Textures/Cars/badcar2.tga");

	tex_car3_normal.load("Textures/Cars/car3.tga");
	tex_car3_broken.load("Textures/Cars/badcar3.tga");


	tex_bullet.load("Textures/Weapons/bullet.tga");
	tex_rocket.load("Textures/Weapons/rocket.tga");
	tex_mine.load("Textures/Weapons/mine.tga");


	tex_font.load("Textures/font.tga");
	tex_cursor.load("Textures/cursor.tga");

	// Terrain
	tex_ter_dirt.load("Textures/Terrain/dirt.bmp");
	tex_ter_grass.load("Textures/Terrain/grass.bmp");
	tex_ter_grass_dark.load("Textures/Terrain/grass_dark.bmp");
	tex_ter_road.load("Textures/Terrain/road.bmp");
	tex_ter_rock.load("Textures/Terrain/rock.bmp");
	tex_ter_sand.load("Textures/Terrain/sand.bmp");

	// Effects
	tex_shokwave1.load("Textures/Effects/Shokwave1.tga");
	tex_explosion_anim.load("Textures/Effects/Explosion_anim.tga");
	tex_crater.load("Textures/Effects/crater.tga");
	tex_spark.load("Textures/Effects/spark.tga");
	tex_sphere.load("Textures/Effects/sphere.tga");
	tex_fire.load("Textures/Effects/fire.bmp");
	tex_white_spark.load("Textures/Effects/white_spark.tga");
	tex_respawn.load("Textures/Effects/respawn.tga");
	tex_smoke.load("Textures/Effects/smoke.tga");
	tex_tyres_trail.load("Textures/Effects/tyres_trail.tga");


	tex_bullet_bonus.load("Textures/Bonuses/bullet_bonus.tga");
	tex_fire_bonus.load("Textures/Bonuses/fire_bonus.tga");
	tex_medkit_bonus.load("Textures/Bonuses/medkit_bonus.tga");
	tex_mine_bonus.load("Textures/Bonuses/mine_bonus.tga");
	tex_rocket_bonus.load("Textures/Bonuses/rocket_bonus.tga");
	tex_shotgun_bonus.load("Textures/Bonuses/shotgun_bonus.tga");



	tex_back_menu = Tex_LoadFromFile("Textures/back_menu.jpg", -1, TEX_DEFAULT_2D);
	tex_back_other= Tex_LoadFromFile("Textures/back_other.jpg", -1, TEX_DEFAULT_2D);
	tex_mini_map.load("Textures/MiniMap.tga");
}



void loadSounds()
{
	Snd_Init();

	snd_explosion		 = Snd_LoadFromFile("Sounds/explosion.wav", 4);

	snd_bullet_ricochet1 = Snd_LoadFromFile("Sounds/bullet_ricoshet1.wav", 5);
	snd_bullet_ricochet2 = Snd_LoadFromFile("Sounds/bullet_ricoshet2.wav", 5);
	snd_bullet_ricochet3 = Snd_LoadFromFile("Sounds/bullet_ricoshet3.wav", 5);

	snd_mine_activate	 = Snd_LoadFromFile("Sounds/mine_activate.wav", 2);
	snd_machine_gun      = Snd_LoadFromFile("Sounds/MachineGun.wav", 8);
	snd_rocket_start     = Snd_LoadFromFile("Sounds/rocket_start.wav", 3);
	snd_rocket_blow      = Snd_LoadFromFile("Sounds/rocket_blow.wav", 3);


	snd_take_bonus	     = Snd_LoadFromFile("Sounds/take_bonus.wav", 3);
	snd_respawn			 = Snd_LoadFromFile("Sounds/respawn.wav", 3);
}

void loadBotNames()
{
	FILE* f;

	f = fopen("Config/BotsNames.txt","r");
	if (f == NULL)
	{
		return;
	}

	fscanf(f, "%d\n", &botsNamesCount);
	for ( int i=0; i<botsNamesCount; i++)
	{
		botNames[i] = new char[256];
		fscanf(f, "%s\n", botNames[i]);
	}

	fclose(f);
}

void loadConfig()
{
	IniFile f("Config/Config.ini");

	WINDOW_WIDTH = f.GetInt("Window","width", 800);
	WINDOW_HEIGHT= f.GetInt("Window","height", 600);
	vSync = (bool) f.GetInt("Window","vsync", 0);
	fullScreen = (bool) f.GetInt("Window","fullscreen", 0);
}

void saveConfig()
{
	IniFile f("Config/Config.ini");

	f.SetInt("Window","width", WINDOW_WIDTH);
	f.SetInt("Window","height", WINDOW_HEIGHT);
	f.SetInt("Window","vsync", vSync);
	f.SetInt("Window","fullscreen", fullScreen);
}

void applyConfig()
{
	OE_ChangeScreenOptions(WINDOW_WIDTH, WINDOW_HEIGHT, 32, 0, fullScreen, vSync);	

	// 
	cam.width = WINDOW_WIDTH;
	cam.height = WINDOW_HEIGHT;
}

void unloadTextures()
{
/*	// GUI
	tex_panel_normal.Delete();
	tex_panel_rollover.Delete();
	tex_panel_press.Delete();

	tex_automobile_normal.Delete();
	tex_automobile_broken.Delete();
	tex_bullet.Delete();
	tex_fire.Delete();
	tex_spark.Delete();

	tex_gun.Delete();
	tex_font.Delete();

	// Terrain
	tex_ter_dirt.Delete();
	tex_ter_grass.Delete();
	tex_ter_grass_dark.Delete();
	tex_ter_road.Delete();
	tex_ter_rock.Delete();
	tex_ter_sand.Delete();

	// Effects
	tex_shokwave1.Delete();
	tex_explosion_anim.Delete();
	tex_crater.Delete();
*/
}