#ifndef __RESOURCES__
#define __RESOURCES__

#include "Utils/TextureManager.h"
#include "Omega/OMEGA_functions.h"
#include "Math/Vector.h"



// 

// 
extern Texture tex_car1_normal;  //  
extern Texture tex_car1_broken;  //  

extern Texture tex_car2_normal;
extern Texture tex_car2_broken;

extern Texture tex_car3_normal;
extern Texture tex_car3_broken;



extern Texture tex_bullet;
extern Texture tex_fire;				//   
extern Texture tex_rocket;
extern Texture tex_mine;


extern Texture tex_spark;
extern Texture tex_white_spark;
extern Texture tex_respawn;
extern Texture tex_smoke;
extern Texture tex_tyres_trail;


extern Texture tex_panel_normal;
extern Texture tex_panel_rollover;
extern Texture tex_panel_press;

//extern Texture tex_gun; 
extern Texture tex_font;		// 
extern Texture tex_cursor;		// 

extern Texture tex_explosion_anim;  //  
extern Texture tex_shokwave1;		//   
extern Texture tex_crater;
extern Texture tex_sphere;


extern Texture tex_ter_dirt;
extern Texture tex_ter_grass;
extern Texture tex_ter_grass_dark;
extern Texture tex_ter_road;
extern Texture tex_ter_rock;
extern Texture tex_ter_sand;

		// 
extern Texture tex_bullet_bonus;
extern Texture tex_fire_bonus;
extern Texture tex_medkit_bonus;
extern Texture tex_mine_bonus;
extern Texture tex_rocket_bonus;
extern Texture tex_shotgun_bonus;



extern PTexture tex_back_menu;
extern PTexture tex_back_other;
extern Texture  tex_mini_map;



// 
extern PSound snd_explosion;
extern PSound snd_bullet_ricochet1,
       snd_bullet_ricochet2,
	   snd_bullet_ricochet3;
extern PSound snd_mine_activate;      //  
extern PSound snd_machine_gun;
extern PSound snd_rocket_start;
extern PSound snd_rocket_blow;

extern PSound snd_take_bonus;
extern PSound snd_respawn;


// 

extern int WINDOW_WIDTH;
extern int WINDOW_HEIGHT;
extern bool     vSync;
extern bool     fullScreen;



extern int		botsNamesCount;
extern char*	botNames[256];



// 

void loadTextures();
void loadSounds();
void loadBotNames();
void loadConfig();
void saveConfig();
void applyConfig();


void unloadTextures();



//   World.cpp
void playSound(PSound snd, vec2& source_pos);

#endif

