#include "Font.h"

const char font_text[64]=" 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ.,:+-=()[]{}|\"!?#/\\%^*\`<>";
char st[255];

int strpos(const char& elem, const char* line)
{
	for (int i=0; i<strlen(line);i++)
	{
		if (elem == line[i]) return i;
	}
}


Font::Font()
{}

void Font::Init(int tex_id)
{
	texture = tex_id;

	int i, x, y;
	float w;

	kerning =  1.22f;

	list = glGenLists(64);

	w = 1.0f / 8.0f;	//    

	for (int i = 0; i < 64; i++)
	{
		x = i % 8;
		y = i / 8;
		
		float u = x * w;
		float v = 1.0f - y * w;	// 

		glNewList(list + i, GL_COMPILE);
		glBegin(GL_QUADS);
		glTexCoord2f(u, v);				 glVertex2f(0, 0);
		glTexCoord2f(u + w, v);			 glVertex2f(1, 0);
		glTexCoord2f(u + w, v - w);		 glVertex2f(1, 1);
		glTexCoord2f(u, v - w);			 glVertex2f(0, 1);
		glEnd();   
		glEndList();
	}
}

void Font::drawText(vec2& pos, float s, const char *szFormat, ...)
{
	kerning =  s*0.02f;
	va_list ap;

	va_start(ap, szFormat);
	vsprintf(st, szFormat, ap);
	va_end(ap);

	int i, p, a;


	char* pt = st;
	pt = strupr(st);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	setTexture(texture);          
	glEnable(GL_TEXTURE_2D);

	glPushMatrix();
	glTranslatef(pos.x, pos.y, 0.0f);
	glScalef(s, s, 1.0f);


	int len = strlen(st);
	for (int i = 0; i < len; i++)
	{
		p = strpos(st[i], font_text);

		if (p > 0) glCallList(list + p);

		glTranslatef(kerning, 0.0f, 0.0f);
	}

	glPopMatrix();
}


