#include "Ini.h"


IniFile::IniFile(const char* filename)
{
  char Path[256]; 
  GetCurrentDirectory(256, Path); 
  sprintf (szIniFile,"%s\\%s",Path, filename); 
}

IniFile::~IniFile()
{}

void IniFile::SetInt(const char *section, const char *name, int value)
{
	char buf[256];

	if(szIniFile[0])
	{
		sprintf(buf,"%d",value);
		WritePrivateProfileString(section, name, buf, szIniFile);
	}
}


int IniFile::GetInt(const char *section, const char *name, int def_val)
{
	char buf[256];

	if(szIniFile[0])
	{
		if(GetPrivateProfileString(section, name, "", buf, sizeof(buf), szIniFile))
		{
			return atoi(buf);
		}
		else
		{
			return def_val;
		}
	}

	return def_val;
}


void IniFile::SetFloat(const char *section, const char *name, float value)
{
	char buf[256];

	if(szIniFile[0])
	{
		sprintf(buf,"%f",value);
		WritePrivateProfileString(section, name, buf, szIniFile);
	}
}


float IniFile::GetFloat(const char *section, const char *name, float def_val)
{
	char buf[256];

	if(szIniFile[0])
	{
		if(GetPrivateProfileString(section, name, "", buf, sizeof(buf), szIniFile))
		{
			return (float)atof(buf);
		}
		else
		{
			return def_val;
		}
	}

	return def_val;
}


void IniFile::SetString(const char *section, const char *name, const char *value)
{
	if(szIniFile[0]) WritePrivateProfileString(section, name, value, szIniFile);
}


char* IniFile::GetString(const char *section, const char *name, const char *def_val)
{
	if(szIniFile[0]) 
		GetPrivateProfileString(section, name, def_val, szIniString, sizeof(szIniString), szIniFile);
	else
		strcpy(szIniString, def_val);

	return szIniString;
}

