#include "OGLutils.h"

void RenderQuad(vec2& v1, vec2& v2)
{
	glBegin(GL_QUADS);
	glTexCoord2f(0.0f, 1.0f); glVertex2f(v1.x, v1.y);
	glTexCoord2f(1.0f, 1.0f); glVertex2f(v1.x + v2.x, v1.y);
	glTexCoord2f(1.0f, 0.0f); glVertex2f(v1.x + v2.x, v1.y + v2.y);
	glTexCoord2f(0.0f, 0.0f); glVertex2f(v1.x, v1.y + v2.y);
	glEnd();
}

void setTexture(int id)
{
	glBindTexture(GL_TEXTURE_2D, id);
}


int createNoiseTexture()
{
	unsigned int id;
	unsigned char *texture;

	texture = (unsigned char *) malloc(512 * 512 * 1);

	for (int i=0; i<512*512; i++)
		texture[i] = (int) frand(256);

	glGenTextures(1, &id);

	glBindTexture(GL_TEXTURE_2D, id); 
	
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR );
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );

	glTexImage2D(GL_TEXTURE_2D, 0, GL_LUMINANCE, 512, 512, 0, GL_LUMINANCE, GL_UNSIGNED_BYTE, texture);

	free(texture);

	return id;
}


