// --------------------------------------------------------------------
//     
//
//  - ViZgl
//
//

#ifndef __SPRITE_ANIMATION__
#define __SPRITE_ANIMATION__

#include "../Math/vector.h"
#include <windows.h>
#include <gl/gl.h>
#include "OglUtils.h"


class Animation
{
public:
	Animation();

	virtual void init(vec2& pos,  //   
					  vec2& size, //   

					  int tex,	  // 
					  int tex_w,  //  
					  int tex_h,  //  
					  int nFrames,//   
					  float fps,  //    
					  int sprite_width, //    
					  int sprite_height,
					  bool Loop = false,
					  bool Active = true,
					  bool Alpha = true);

	virtual void update(float dt);
	virtual void render();

	void setActive(bool state);
	void setLoop(bool state);

	void setFrame(int n);

	bool getActive(){ return active; }
	bool getLoop() { return loop; }

private:
	vec2	pos;
	vec2	size;           //   
	vec2    half_size;

	float	current_u;		//    
	float   current_v;

	float	width_t;		//  1    
	float	height_t;		//  1    

	int		num_in_row;		//    
	int		num_in_col;     //  

	int		sprite_width;   //    
	int		sprite_height;

	int		current_frame;
	int		texture;        // 
	int		tex_width;      //  
	int		tex_height;     
	float	FPS;			//    
	int		framesCount;	//   

	bool	loop;			//   
	bool	active;			// ?
	bool	alpha;

	float	timer;
};

#endif

