#ifndef __WEAPONS_H__
#define __WEAPONS_H__

#include "Utils/Array.h"
#include "Utils/Camera.h"
#include "Utils/Ini.h"
#include "Utils/TextureManager.h"
#include "ParticlesEffects.h"


const int WEAPONS_COUNT = 5; //  

typedef 
enum WeaponID
{ 
	MACHINEGUN, 
	FIREFLOW, 
	ROCKETLAUNCHER,
	SHOTGUN,
	MINE
};




class Bullet
{
public:
	vec2		pos;
	vec2		startPos;
	vec2		vel;
	float		timeToDead;		//  
	float		angle;			//  

	bool		dead;			// ?

	WeaponID	type;
	void*		owner;			//  (  Car*)


	vec3 startColor;
	vec3 endColor;

	PFSmoke* blt_smoke;   //  

public:
	Bullet(){blt_smoke=NULL;}
	void update(float dt);
	void kill();
};




class WeaponParam
{
public:
	float reloadTime;      //  
	float damage;          //  1- 
	float speed;           //   1 
	float speedEps;        //  
	int   bullCount;	   //    
	int   shopSize;		   //  
	int   bullLifeTime;    //   
	float variation;       //  

	int   multiply;		   //  	
	int   bullTex;		   //  
//	int   weaponTex;

	char  weapon_type[256];

public:
	void init(const char* weapon_type);
};



class BulletsManager
{
public:
	Array<Bullet>	bullets;
	WeaponParam		paramWeapon[WEAPONS_COUNT];
public:

	void init();
	void addBullet(Bullet& bull);
	void update(float dt);
	void render();
	void renderMine();
};


extern BulletsManager	bulletsManager;	//  

#endif

