#ifndef __WORLD_H__
#define __WORLD_H__

#include "Weapons.h"
#include "Car.h"
#include "BotAI.h"
#include "Map.h"
#include "ParticlesEffects.h"
#include "Utils/Font.h"



// -------------------------------------------------------------
//    ;)
//

class World
{
public:
	World()	{}
	~World(){}

	void update(float dt);					//  
	void renderMini();
	void render();							// 
	void solveCollisions();					//  

public:
	static	Array<Bot>	bots;				// ,  0(   ,  )
	static  Map			map;				//  
	static  PFTiresTrail*	tyres;			//   
	static  PFSmoke*		carSmoke;		//  
	
	void renderHUD();
	void renderStatistic();
	
	void addRichochet(WeaponID wpn, vec2& pos, vec2& normal, bool idPlayer=false, bool use_sound=true);
	void addCarExplosion(vec2& pos);
	void addSmallExplosion(vec2& pos, float size);
	void checkBotsCollisions(int i, int j);
	void checkBotWithMap(int i);
};

extern World world;

#endif

